Function ann_get_multiline_string_proc(mt As Ihandle Ptr , iLine As Integer , sRet As String , iLenSimbols As Long) As Long
	
	sRet = Mid(*IupGetAttribute(mt , "LINE" & iLine) , 1 , iLenSimbols)
	
	If Len(sRet) Then
		
		sRet = ac_truncate_blocks_proc(sRet , Chr(34) , Chr(34))
		
	Endif
	
	If Len(sRet) Then
		
		sRet = ac_truncate_blocks_proc(sRet , "/'" , "'/")
		
	Endif
	
	If Len(sRet) Then
		
		sRet = ac_truncate_blocks_proc(sRet , "'" , "")
		
	Endif		
	
	Dim As Integer iLineTransfer  = iLine
	
	Dim As Long iBeginTransferLines = -2
	
	Do
		
		If iLineTransfer > 0 Then
			
			iLineTransfer -=1
			
			Dim As String sText = *IupGetAttribute(mt , "LINE" & iLineTransfer)
			
			Select Case atc_check_simbol_underscore_proc(sText)
					
				Case 1
					
					sRet = Rtrim(sText, Any Chr(10) & Chr(13) & "_ ") & " " & sRet
					
					iBeginTransferLines = iLineTransfer
					
				Case Else
					
					Exit Do
					
			End Select
			
		Else
			
			Exit Do
			
		Endif
		
	Loop
	
	Return iBeginTransferLines	
	
End Function

Sub ann_execute_proc(mt As iHandle Ptr  , sNameFunction As String , iCom As Long , iLine As Integer)

	Dim As String sTextAnnotation , sStyles
	
	Dim As Byte bCONST_DESTR
	
	Select Case Right(sNameFunction,1)
		
		Case "|"
			
			bCONST_DESTR = 1
			
			sNameFunction = Left(sNameFunction,Len(sNameFunction)-1)
			
		Case "~"
		
			bCONST_DESTR = 2
			
			sNameFunction = Left(sNameFunction,Len(sNameFunction)-1)
		
	End Select
	
	For i As Long = 0 To iAcIndexParserListDeclaresFunc-1
		
		Dim As String sN , sP , sR , sP0 , sP1 , sP2

		If *(tAcParserListDeclaresFunc(i).pszName) = sNameFunction Then
			
			Select Case tAcParserListDeclaresFunc(i).fType
					
				Case 1
					
					sN = "Function ("
					
				Case 2 
					
					sN = "Sub ("
					
				Case 3
					
					sN = "Property ("
					
				Case 4
					
					If bCONST_DESTR = 2 Then Continue For
					
					sN = "Constructor ("
					
				Case 5
					
					If bCONST_DESTR = 1 Then Continue For
					
					sN = "Destructor ("
					
				Case 6
				
					sN = "Operator ("
					
			End Select

			If tAcParserListDeclaresFunc(i).pszReturnParam Then
				
				sR = *(tAcParserListDeclaresFunc(i).pszReturnParam)
				
			Endif					
			
			Dim As Long iFind , iFindEnd
			
			If tAcParserListDeclaresFunc(i).pszParameters Then
				
				sP = *(tAcParserListDeclaresFunc(i).pszParameters)
				
				If iCom Then
					
					For i As Long = 0 To iCom-1
						
						iFind = Instr(iFind+1 , sP , ",")
						
						If iFind = 0 Then Exit For
						
					Next
					
					iFindEnd = Instr(iFind+1 , sP , ",")
					
					If iFind Then
						
						sP0 = String(iFind , 44)
						
						If iFindEnd Then
							
							sP1 = String(iFindEnd - (iFind +1) , 45)
							
							sP2 = String(Len(sP) - iFindEnd +1 , 44)
							
						Else
							
							sP1 = String(Len(sP) - iFind , 45)
							
						Endif
						
						If Len(sStyles) Then
							
							sStyles &= !"\n" & String(Len(sN),46) & sP0 & sP1 & sP2 & String(Len(sR)+1, 46)
							
						Else	
							
							sStyles = String(Len(sN),46) & sP0 & sP1 & sP2 & String(Len(sR)+1, 46)
							
						Endif
						
					Else
						
						If Len(sStyles) Then
							
							sStyles &= !"\n" & String(Len(sN),46) & String(Len(sP), 44) & String(Len(sR)+1, 46)
							
						Else	
							
							sStyles = String(Len(sN),46) & String(Len(sP), 44) & String(Len(sR)+1, 46)	
							
						Endif
						
					Endif
					
				Else
					
					iFind = Instr(iFind+1 , sP , ",")
					
					If iFind Then
						
						If Len(sStyles) Then
							
							sStyles &= !"\n" & String(Len(sN),46) & String(iFind-1, 45) & String(Len(sP) - iFind +1, 44) & String(Len(sR)+1, 46)
							
						Else	
							
							sStyles = String(Len(sN),46) & String(iFind-1, 45) & String(Len(sP) - iFind +1, 44) & String(Len(sR)+1, 46)
							
						Endif
						
					Else
						
						If Len(sStyles) Then
							
							sStyles &= !"\n" & String(Len(sN),46) & String(Len(sP), 45) & String(Len(sR)+1, 46)
							
						Else	
							
							sStyles = String(Len(sN),46) & String(Len(sP), 45) & String(Len(sR)+1, 46)
							
						Endif	
						
					Endif
					
				Endif
				
			Else
				
				If Len(sStyles) Then
					
					sStyles &= !"\n" & String(Len(sN)+Len(sR)+1,46)
					
				Else	
					
					sStyles = String(Len(sN)+Len(sR)+1,46)
					
				Endif
				
			Endif
			
			If Len(sTextAnnotation) Then
				
				sTextAnnotation &= (!"\n" &  sN & sP & ")" & sR )
				
			Else
				
				sTextAnnotation = (sN & sP & ")" & sR)
				
			Endif
			
		Endif
		
	Next	

	If Len(sTextAnnotation) = 0 Then

		For i As Long = 0 To iAcIndexLinesLocalArea-1
			
			Dim As String sN , sP , sR , sP0 , sP1 , sP2
			
			If *(tAcDimLinesLocalArea(i).pszName) = sNameFunction Then
				
				Select Case tAcDimLinesLocalArea(i).fType
						
					Case 1
						
						sN = "Function ("
						
					Case 2 
						
						sN = "Sub ("
						
					Case 12
					
						sN = "Operator ("
						
					Case 13
						
						sN = "Property ("
						
				End Select
				
				If tAcDimLinesLocalArea(i).pszReturnParam Then
					
					sR = *(tAcDimLinesLocalArea(i).pszReturnParam)
					
				Endif					
				
				Dim As Long iFind , iFindEnd
				
				If tAcDimLinesLocalArea(i).pszParameters Then
					
					sP = *(tAcDimLinesLocalArea(i).pszParameters)
					
					If iCom Then
						
						For i As Long = 0 To iCom-1
							
							iFind = Instr(iFind+1 , sP , ",")
							
							If iFind = 0 Then Exit For
							
						Next
						
						iFindEnd = Instr(iFind+1 , sP , ",")
						
						If iFind Then
							
							sP0 = String(iFind , 44)
							
							If iFindEnd Then
								
								sP1 = String(iFindEnd - (iFind +1) , 45)
								
								sP2 = String(Len(sP) - iFindEnd +1 , 44)
								
							Else
								
								sP1 = String(Len(sP) - iFind , 45)
								
							Endif
							
							If Len(sStyles) Then
								
								sStyles &= !"\n" & String(Len(sN),46) & sP0 & sP1 & sP2 & String(Len(sR)+1, 46)
								
							Else	
								
								sStyles = String(Len(sN),46) & sP0 & sP1 & sP2 & String(Len(sR)+1, 46)
								
							Endif
							
						Else
							
							If Len(sStyles) Then
								
								sStyles &= !"\n" & String(Len(sN),46) & String(Len(sP), 44) & String(Len(sR)+1, 46)
								
							Else	
								
								sStyles = String(Len(sN),46) & String(Len(sP), 44) & String(Len(sR)+1, 46)	
								
							Endif
							
						Endif
						
					Else
						
						iFind = Instr(iFind+1 , sP , ",")
						
						If iFind Then
							
							If Len(sStyles) Then
								
								sStyles &= !"\n" & String(Len(sN),46) & String(iFind-1, 45) & String(Len(sP) - iFind +1, 44) & String(Len(sR)+1, 46)
								
							Else	
								
								sStyles = String(Len(sN),46) & String(iFind-1, 45) & String(Len(sP) - iFind +1, 44) & String(Len(sR)+1, 46)
								
							Endif
							
						Else
							
							If Len(sStyles) Then
								
								sStyles &= !"\n" & String(Len(sN),46) & String(Len(sP), 45) & String(Len(sR)+1, 46)
								
							Else	
								
								sStyles = String(Len(sN),46) & String(Len(sP), 45) & String(Len(sR)+1, 46)
								
							Endif	
							
						Endif
						
					Endif
					
				Else
					
					If Len(sStyles) Then
						
						sStyles &= !"\n" & String(Len(sN)+Len(sR)+1,46)
						
					Else	
						
						sStyles = String(Len(sN)+Len(sR)+1,46)
						
					Endif
					
				Endif
				
				If Len(sTextAnnotation) Then
					
					sTextAnnotation &= (!"\n" &  sN & sP & ")" & sR )
					
				Else
					
					sTextAnnotation = (sN & sP & ")" & sR)
					
				Endif
				
			Endif
			
		Next			
		
	Endif

	If Len(sTextAnnotation) Then
		
		If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Parser" , "tips1") = "1" Then
			
			IupScintillaSendMessage(mt, SCI_CALLTIPCANCEL , 0, 0)
			
			Dim As Integer iPos = Cint(IupScintillaSendMessage(mt , SCI_POSITIONFROMLINE , iLine , 0 ))
			
			IupScintillaSendMessage(mt, SCI_CALLTIPSHOW , iPos, Strptr(sTextAnnotation))
			
			If Len(sStyles) Then
				
				Dim As Integer iB , iE
				
				For i As Long = 0 To Len(sStyles)
					
					If iB Andalso sStyles[i] <> 45 Then
						
						iE = i
						
						Exit For
						
					Elseif sStyles[i] = 45 Andalso iB = 0 Then
						
						iB = i
						
					Endif
					
				Next
				
				IupScintillaSendMessage(mt,2204 , iB , Cast(Zstring Ptr ,iE) ) 'SCI_CALLTIPSETHLT
				
			Endif
			
		Else
		
			IupScintillaSendMessage(mt, SCI_ANNOTATIONCLEARALL, 0, 0)	
			
			IupScintillaSendMessage(mt, SCI_ANNOTATIONSETTEXT, iLine, Strptr(sTextAnnotation))
			
			If Len(sStyles) Then
				
				IupScintillaSendMessage(mt, SCI_ANNOTATIONSETSTYLES, iLine, Strptr(sStyles))
				
			Endif	
			
		Endif

	Else
		
		If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Parser" , "tips1") = "1" Then
			
			IupScintillaSendMessage(mt, SCI_CALLTIPCANCEL , 0, 0)
			
		Else
		
			IupScintillaSendMessage(mt, SCI_ANNOTATIONCLEARALL, 0, 0)
			
		Endif
		
	Endif		
	
End Sub

Sub ann_start_proc()
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Exit Sub
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	If TGlobalVariables->tTabsOptions(idTabs).multitext = 0 Orelse _
	*IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext , "AUTOCACTIVE") = "YES" Then Exit Sub
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Parser","istips") = "OFF" Orelse _
	*IupConfigGetVariableStr(TGlobalVariables->hConfig,"Parser","isparser") = "OFF" Then
		
		Exit Sub
		
	Endif
	
	Dim As Integer iCurPos = Cint(IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext , SCI_GETCURRENTPOS , 0 , 0 ))
	
	Dim As Integer  iPosLineBegin , iLine , iColumn , iPosTemp , iPosLineBeginFirstMultiLine
	
	Dim As Long iBeginTransferLine
	
	Dim As String sRetString
	
	IupTextConvertPosToLinCol(TGlobalVariables->tTabsOptions(idTabs).multitext, iCurPos, Cast(Any Ptr, @iLine), Cast(Any Ptr, @iColumn))
	
	IupTextConvertLinColToPos(TGlobalVariables->tTabsOptions(idTabs).multitext, iLine , 0, Cast(Any Ptr, @iPosLineBegin))

	iBeginTransferLine = ann_get_multiline_string_proc(TGlobalVariables->tTabsOptions(idTabs).multitext, iLine , sRetString , iCurPos - iPosLineBegin )

	If Len(sRetString) = 0 Orelse Lcase(Left(sRetString,7)) = "declare" Then
		
		If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Parser" , "tips1") = "1" Then
			
			IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_CALLTIPCANCEL , 0, 0)
			
		Else
		
			IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_ANNOTATIONCLEARALL, 0, 0)
			
		Endif
		
		Exit Sub
		
	Endif
	
	If iBeginTransferLine <> -2 Then
		
		IupTextConvertLinColToPos(TGlobalVariables->tTabsOptions(idTabs).multitext, iBeginTransferLine , 0, Cast(Any Ptr, @iPosLineBeginFirstMultiLine))
		
	Endif
	
	Dim As Byte bBr1 , bBr2  , bFlag ,  bFlagReset , bSplit , bCONSR_DESTR_OPER
	
	Dim As Long  iCom 
	
	Dim As String sNameFunction	 , sNameVar , sOper , sOperVar
	
	Dim As Wstring Ptr wPtr = Callocate(Sizeof(Wstring)*Len(sRetString)+10)
	
	*wPtr = Wstr(sRetString)
	
	sRetString = Lcase(Ltrim(sRetString , Any Chr(9) & " "))
	
	If Left( sRetString , 11) = "constructor" Then
		
		bCONSR_DESTR_OPER = 1
		
	Elseif Left( sRetString , 10) = "destructor" Then	
	
		bCONSR_DESTR_OPER = 2
		
	Elseif Left( sRetString , 8) = "operator" Then
	
		bCONSR_DESTR_OPER = 3
		
		Dim As Long iBr = Instr( 9, sRetString , "(")  
		
		If iBr Then
			
			sOper = (Trim(Mid(sRetString , 9 , iBr - 9 ) ,  Any Chr(9) & " "))
			
			Dim As Long iDot = Instr(sOper , ".")
			
			If iDot Then

				sOperVar = Mid(sOper , 1 , iDot-1) 
				
				sOper = Mid(sOper , iDot+1)
				
			Endif
			
		Endif

	Endif
	
	iPosTemp = Len(*wPtr)

	Do
		
		iPosTemp-=1
		
		If iPosTemp < 0 Then
			
			Exit Do
			
		Endif
		
		Select Case (*wPtr)[iPosTemp]
				
			Case 41 ')
				
				bBr1+=1
				
				If bFlag Then 
					
					Exit Do
					
				Endif
				
			Case 93, 125  '] , } 
				
				bBr2+=1
				
				If bFlag Then 
					
					Exit Do
					
				Endif
				
			Case 91 , 123 '[ , {  	
				
				bBr2-=1
				
				If bFlag Then 
					
					Exit Do
					
				Endif
				
			Case 40 '(
				
				bBr1-=1
				
				If bBr1 = -1 Then
					
					bFlag = 1
					
					bFlagReset = 1
					
				Elseif bFlag Then
					
					Exit Do
					
				Endif
				
			Case 44 ',
				
				If bBr1 + bBr2 = 0 Then
					
					iCom +=1
					
				Endif
				
				If bFlag Then 
					
					Exit Do
					
				Endif
				
			Case &h30 To &h39 , &h41 To &h5A , &h61 To &h7A , &h5F '"0" to "9" , "A" to "Z" , "a" to "z" , "_"
				
				If bFlag = 1 Then
					
					bFlagReset = 0
					
					sNameFunction &= Chr((*wPtr)[iPosTemp])
					
					Select Case Ucase(sNameFunction) 
							
						Case "LCEDC" , "LLACDTS" , "LACSAP" , "DAOLREVO" , "SAILA" , "DEKAN"
							
							sNameFunction = ""
							
							bFlagReset = 1
							
					End Select
					
				Elseif bFlag = 2 Then	
					
					sNameVar &= Chr((*wPtr)[iPosTemp])
					
				Endif
				
			Case 32 , 9 ' space, tab
				
				If bFlag Andalso bFlagReset = 0 Then 
					
					Exit Do
					
				Endif 
				
			Case 46 '.
				
				If bFlag = 1 Then
					
					bSplit = 1
					
					bFlag = 2
					
				Elseif bFlag = 2 Then
					
					Exit Do
					
				Endif
				
			Case 62 
				
				If (iPosTemp - 1) >= 0 Andalso (*wPtr)[iPosTemp-1] = 45 Then ' ->
					
					If bFlag = 1 Then
						
						bSplit = 2
						
						bFlag = 2
						
					Elseif bFlag = 2 Then
						
						Exit Do	
						
					Endif
					
					iPosTemp -= 1				
					
				Endif
				
			Case Else
				
				If bFlag Then 
					
					Exit Do
					
				Endif
				
		End Select
		
	Loop	
	
	Deallocate(wPtr)

	If Len(sNameFunction) Orelse (bCONSR_DESTR_OPER = 3 Andalso bFlag) Then
		
		If bCONSR_DESTR_OPER = 3 Then
			
			sNameFunction = sOper
			
			sNameVar = sOperVar
			
		Else
		
			misc_reverse_string_proc(sNameFunction)
			
			sNameFunction = Lcase(sNameFunction)			
			
		Endif

		If Len(sNameVar) Then
			
			If bCONSR_DESTR_OPER <> 3 Then
				
				misc_reverse_string_proc(sNameVar)
				
				sNameVar = Lcase(sNameVar)				
				
			Endif

			Dim As String sFind

			If bSplit = 1 Then
				
				sFind = sNameVar & "." & sNameFunction
				
			Elseif bSplit = 2 Then	
				
				sFind = sNameVar & "->" & sNameFunction
				
			Endif	 
			
			Dim As Integer iLenFind = Len(sFind)
			
			IupScintillaSendMessage( TGlobalVariables->tTabsOptions(idTabs).multitext , SCI_SETSEARCHFLAGS , 0 , 0)	
			
			IupScintillaSendMessage( TGlobalVariables->tTabsOptions(idTabs).multitext , SCI_SETTARGETSTART , iCurPos , 0)
			
			IupScintillaSendMessage( TGlobalVariables->tTabsOptions(idTabs).multitext , SCI_SETTARGETEND , iPosLineBeginFirstMultiLine  , 0)
			
			Dim As Integer iFindPos =  Cint(IupScintillaSendMessage( TGlobalVariables->tTabsOptions(idTabs).multitext , SCI_SEARCHINTARGET , iLenFind  , Strptr(sFind) ))	
			
			iFindPos += Len(sNameVar)
			
			Dim As Integer iCurLine = ac_split_words_proc(TGlobalVariables->tTabsOptions(idTabs).multitext , iFindPos)
			
			Dim As String sRetType

			If iAcIndexChainOfWords Then
				
				Dim As Integer iRetLine
				
				Dim As iHandle Ptr hMultiText
				
				sRetType = ac_truncate_pointers_proc(ac_gettype_from_alltypes_proc(hMultiText , iCurLine , iRetLine))	

				If iAcIndexTypeVariables Then

					For i As Long = 0 To iAcIndexTypeVariables -1 

						If tAcDimTypeVariables(i).pszTypeName <> 0 Andalso _
						(*(tAcDimTypeVariables(i).pszTypeName) = sRetType Orelse Lcase(*(tAcDimTypeVariables(i).pszTypeName)) = snamevar) Then

							If tAcDimTypeVariables(i).bTypeVar > 1 Andalso tAcDimTypeVariables(i).bTypeVar < 5  Then ' sub | func , prop , oper 

								If tAcDimTypeVariables(i).pszName <> 0 Andalso Lcase(*(tAcDimTypeVariables(i).pszName)) = sNameFunction Then
						
									If Len(sRetType) Then
										
										sNameFunction = Lcase(sRetType) & "." & sNameFunction
										
									Else
									
										sNameFunction = snamevar & "." & sNameFunction
										
									Endif

									ann_execute_proc(TGlobalVariables->tTabsOptions(idTabs).multitext , sNameFunction , iCom , iLine)
									
									Exit For
									
								Endif
								
							Endif
							
						Endif
						
					Next
					
				Endif					
				
			Endif
			
		Else

			If bCONSR_DESTR_OPER = 1 Then
				
				sNameFunction &="|"
				
			Elseif bCONSR_DESTR_OPER = 2 Then	
			
				sNameFunction &="~"
				
			Endif
			
			ann_execute_proc(TGlobalVariables->tTabsOptions(idTabs).multitext , sNameFunction , iCom , iLine)		
			
		Endif	
		
	Else
		
		If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Parser" , "tips1") = "1" Then
			
			IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_CALLTIPCANCEL , 0, 0)
			
		Else
		
			IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_ANNOTATIONCLEARALL, 0, 0)
			
		Endif
		
	Endif
	
End Sub

Sub ann_highlights_block_local_area()
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Exit Sub
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	If TGlobalVariables->tTabsOptions(idTabs).multitext = 0 Then Exit Sub
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Parser","istips") = "OFF" Orelse _
	*IupConfigGetVariableStr(TGlobalVariables->hConfig,"Parser","isparser") = "OFF" Then
		
		Exit Sub
		
	Endif
	
	Dim As Integer iCurPos = Cint(IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext , SCI_GETCURRENTPOS , 0 , 0 ))
	
	Dim As Integer iCurLine , iColumn
	
	Dim As String sBlock 
	
	IupTextConvertPosToLinCol(TGlobalVariables->tTabsOptions(idTabs).multitext, iCurPos, Cast(Any Ptr, @iCurLine), Cast(Any Ptr, @iColumn))
	
	If iAcIndexLinesLocalArea Then
		
		For i As Long = 0 To iAcIndexLinesLocalArea -1
			
			If iCurLine >= tAcDimLinesLocalArea(i).iLineB Andalso iCurLine <= tAcDimLinesLocalArea(i).iLineE Then

				Select Case tAcDimLinesLocalArea(i).fType
					
					Case 1
					
						sBlock = "Function "
					
					Case 2
					
						sBlock = "Sub "
					
					Case 13
					
						sBlock = "Property "
					
					Case 10
					
						sBlock = "Constructor "
					
					Case 11
					
						sBlock = "Destructor "
					
					Case 12
					
						sBlock = "Operator "
					
				End Select
				
				Dim iBeginLine As Long
				
				If tAcDimLinesLocalArea(i).iLineBFW <> -1 Andalso tAcDimLinesLocalArea(i).iLineBFW <> -2 Then
					
					iBeginLine = tAcDimLinesLocalArea(i).iLineBFW + 1
					
				Else
				
					iBeginLine = tAcDimLinesLocalArea(i).iLineB + 1
					
				Endif
				
				sBlock &= *(tAcDimLinesLocalArea(i).pszName) & "(" & *(tAcDimLinesLocalArea(i).pszParameters) & ") " _
				& *(tAcDimLinesLocalArea(i).pszReturnParam) & Chr(10) & "Begin: " & iBeginLine & Chr(10) & _
				"End: " & tAcDimLinesLocalArea(i).iLineE + 1
				
				If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Parser" , "tips1") = "1" Then
					
					IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_CALLTIPCANCEL , 0, 0)
					
					IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext,SCI_CALLTIPSHOW, iCurPos, Strptr(sBlock))
				
				Else
					
					Dim As String sStyles = String(Len(sBlock), 45)
					
					IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_ANNOTATIONCLEARALL, 0, 0)	
					
					IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_ANNOTATIONSETTEXT, iCurLine, Strptr(sBlock))
					
					If Len(sStyles) Then
						
						IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_ANNOTATIONSETSTYLES, iCurLine, Strptr(sStyles))
						
						Exit For
						
					Endif
					
				Endif	
				
			Endif
			
		Next		
		
	Endif

End Sub

