Function gt_goto_proc () As Integer Export

	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))	

	Dim As Ihandle Ptr dlg, Vbox, hOk, hCancel, hTxt, hLbl

	Dim As Integer iLineCount = IupGetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "LINECOUNT")

	hLbl = IupLabel(NULL)
	
	Dim As String sTitle = *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"titlelinenumber") & !" [1-%d]:"

	IupSetfAttribute(hLbl, "TITLE", sTitle, iLineCount)

	hTxt = IupText(NULL)

	IupSetAttribute(hTxt, "MASK", IUP_MASK_UINT) '  /* unsigned integer numbers only */

	IupSetAttribute(hTxt, "NAME", "LINE_TEXT")

	IupSetAttribute(hTxt, "VISIBLECOLUMNS", "20")

	hOk = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"buttongotook"), NULL)

	IupSetInt(hOk, "TEXT_LINECOUNT", iLineCount)

	IupSetAttribute(hOk, "PADDING", "10x2")

	IupSetCallback(hOk, "ACTION", Cast(Any Ptr,@goto_ok_callback))

	hCancel = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"buttongotocancel"), NULL)

	IupSetCallback(hCancel, "ACTION", Cast(Any Ptr,@goto_cancel_callback))

	IupSetAttribute(hCancel, "PADDING", "10x2")

	Vbox = IupVbox(_
	hLbl,_
	hTxt,_
	IupSetAttributes(IupHbox(_
	IupFill(),_
	hOk,_
	hCancel,_
	NULL), "NORMALIZESIZE=HORIZONTAL"),_
	NULL)

	IupSetAttribute(Vbox, "MARGIN", "10x10")

	IupSetAttribute(Vbox, "GAP", "5")

	dlg = IupDialog(Vbox)

	IupSetAttribute(dlg, "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"titlegotodlg"))

	IupSetAttribute(dlg, "DIALOGFRAME", "Yes")

	IupSetAttributeHandle(dlg, "DEFAULTENTER", hOk)

	IupSetAttributeHandle(dlg, "DEFAULTESC", hCancel)

	IupPopup(dlg, IUP_CURRENT, IUP_CURRENT)

	If IupGetInt(dlg, "STATUS") = 1 Then

		Dim As Integer iLine = IupGetInt(hTxt, "VALUE")

		Dim As Integer iPos

		IupTextConvertLinColToPos(TGlobalVariables->tTabsOptions(idTabs).multitext, iLine - 1, 0, Cast(Any Ptr,@iPos))

		IupSetFocus(TGlobalVariables->tTabsOptions(idTabs).multitext)
		
		IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "CARETPOS", iPos)

		IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "SCROLLTOPOS", iPos)
	
	Else
	
		IupSetFocus(TGlobalVariables->tTabsOptions(idTabs).multitext)
	
	Endif

	IupDestroy(dlg)

	Return IUP_DEFAULT

End Function

Sub gt_goto_prevpos()
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Exit Sub
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As Integer iPos = IupGetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "DECLAREPREVPOS")
		
	Dim As Ihandle Ptr hPrevMt = Cast(iHandle Ptr ,Cast(Integer ,Val(*IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "DECLAREPREVMT"))))
	
	If hPrevMt Then
		
		IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "DECLAREPREVMT" , 0)
		
	Endif
	
	If hPrevMt Then
		
		For j As Long = 1 To IupGetChildCount(TGlobalVariables->tabs) - 1
			
			If TGlobalVariables->tTabsOptions(j).multitext = hPrevMt Then
				
				IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS" , Str(j))
				
				IupSetFocus(hPrevMt)
				
				IupFlush()
				
				If iPos <> -1 Then
					
					IupSetInt(hPrevMt, "CARETPOS" , iPos)	
					
					IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "DECLAREPREVPOS" , -1)
					
				Endif
				
				tmr_update_after_changes()
				
				Exit For
				
			Endif
			
		Next
		
	Else
	
		If iPos <> -1 Then
			
			IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "CARETPOS" , iPos)	
			
			IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "DECLAREPREVPOS" , -1)
			
		Endif
		
	Endif

End Sub
