' fill menu items_encoding
Function mn_fill_menu_items_encoding_proc(hMDoc() As Ihandle Ptr, hMFile() As Ihandle Ptr, hMFileSave() As Ihandle Ptr, iFlag As Long = 0) As Long
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As Long j , k
	
	For i As Long = 0 To 121
		
		If bEncodingBool(i) Then
			
			If iFlag Then
				
				Select Case szEncodingString(i)
						
						' UNICODE we cut off for this point
					Case "UTF-32LE" , "UTF-32BE" , "UTF-32" , "UCS-4LE" , "UCS-4BE", "UCS-4","UCS-4-INTERNAL","UCS-4-INTERNALEUC-CN",_
						"UTF-16LE" , "UTF-16BE" , "UTF-16" , "UCS-2LE" , "UCS-2BE", "UCS-2" , "UCS-2-INTERNAL"
						
					Case Else
						
						hMDoc(k) = IupItem(szEncodingString(i), NULL)
						
						IupSetCallback(hMDoc(k), "ACTION", Cast(Any Ptr,@convert_document_as_encoding_callback))
						
						IupSetStrAttribute(hMDoc(k), "IDMENUENC", szEncodingString(i))
						
						If IupGetChildCount(TGlobalVariables->tabs) > 1 Andalso _
						*IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "CURRENTENCODING") = szEncodingString(i) Then
							
							IupSetAttribute(hMDoc(k),"ACTIVE","NO")
							
						Endif	
						
						k+=1
						
				End Select				
				
			Endif
			
			hMFile(j) = IupItem(szEncodingString(i), NULL)
			
			IupSetCallback(hMFile(j), "ACTION", Cast(Any Ptr,@re_open_file_as_encoding_callback))
			
			IupSetStrAttribute(hMFile(j), "IDMENUENC", szEncodingString(i))
			
			hMFileSave(j) = IupItem(szEncodingString(i), NULL)
			
			IupSetCallback(hMFileSave(j), "ACTION", Cast(Any Ptr,@set_encoding_file_for_save_callback))
			
			IupSetStrAttribute(hMFileSave(j), "IDMENUENC", szEncodingString(i))
			
			IupSetAttribute(hMFileSave(j), "HIDEMARK" , "NO")
			
			If IupGetChildCount(TGlobalVariables->tabs) > 1 Andalso _
			*IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "CURRENTENCODING") = szEncodingString(i) Then
				
				IupSetAttribute(hMFileSave(j),"VALUE","ON")
				
			Endif	
			
			j+=1
			
		Endif
		
	Next
	
	Return j	
	
End Function

' Create Main Menu
Sub mn_create_main_menu_proc() Export
	
	Dim As IHandle Ptr main_menu , item_project_new, item_project_open, item_project_close,_
	item_file , item_new , item_open , item_save , item_save_as , item_save_all ,_
	item_encforsave , item_openfileenc , item_encnumbers , item_encsysdef , item_close , item_close_all , recent_menu ,_
	item_recent_files , item_exit , item_edit , item_undo ,item_redo , item_cut , item_copy , item_paste , item_delete ,_
	item_find ,item_find_next, item_find_prev , item_replace , item_goto , item_bookmarks , item_bookmarks_toggle ,_
	item_bookmarks_next , item_bookmarks_prev , item_bookmarks_clear_all , item_spaces ,_
	item_space_trim_trailing, item_space_trim_leading , item_space_trim_trailing_and_leading ,_
	item_space_to_tab_begin,item_space_to_tab , item_tab_to_space_begin , item_tab_to_space , item_convert_case ,_
	item_convert_lower_case, item_convert_upper_case , item_autoindent ,item_select_all , item_view, item_view_zoom , item_view_zoom_plus ,_
	item_view_zoom_minus , item_view_zoom_default , item_view_word_wrap , item_view_show_white_spaces ,_
	item_view_winside, item_view_toolbar , item_view_statusbar , item_view_line_numbers, item_project , item_project_addnew ,_
	item_project_addnew_file , item_project_addnew_module , item_project_existing , item_project_existing_file , item_project_existing_module ,_
	item_project_do_curent , item_project_del_curent , item_project_rename_curent , item_project_options , item_build , item_compile ,_
	item_run , item_compile_and_run , item_quick_run , item_debug , item_command, item_options , item_options_item_edit ,_
	item_options_item_build ,item_options_item_tools,item_options_item_help, item_options_item_plugins, item_options_encoding, item_tools , item_help
	
	
	'encoding items
	Dim As Ihandle Ptr hDimMenuFile(122), hDimMenuFileSave(122) , hDoc(0)
	
	Dim As Long iRet = mn_fill_menu_items_encoding_proc(hDoc() , hDimMenuFile(),hDimMenuFileSave())
	
	item_encforsave = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"setencforsave"),IupMenuv(@hDimMenuFileSave(0)))
	IupSetAttribute(item_encforsave, "NAME", "menuencforsave") 
	IupSetCallback(item_encforsave, "HIGHLIGHT_CB", Cast(Any Ptr , @item_highlight_cb_menuencforsave_callback))
	item_openfileenc = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"reopenfileenc"), IupMenuv(@hDimMenuFile(0))) 
	IupSetAttribute(item_openfileenc, "NAME", "menuopenfileenc")
	item_encnumbers = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"numberencinmenu"), "numbers") 
	IupSetFunction("numbers", Cast(Any Ptr , @numbers_encoding_in_the_menu_callback))
	item_encsysdef = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"setdefaultenc"), "sysdef")
	IupSetFunction("sysdef", Cast(Any Ptr , @select_default_system_menu_callback))
	
	If iRet = 0 Then
		
		IupSetAttribute(item_encforsave,"ACTIVE","NO")
		
		IupSetAttribute(item_openfileenc,"ACTIVE","NO")
		
	Endif
	
	' New
	item_new = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menunew") & !"\tCtrl+N", NULL)
	
	IupSetAttribute(item_new, "IMAGE", "img_new")
	
	IupSetCallback(item_new, "ACTION", Cast(Any Ptr , @item_new_callback))
	
	' Open
	item_open = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuopen") & !"\tCtrl+O", NULL)
	
	IupSetAttribute(item_open, "IMAGE", "img_open")
	
	IupSetCallback(item_open, "ACTION", Cast(Any Ptr , @item_open_callback))
	
	' Save
	item_save = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menusave") & !"\tCtrl+S", NULL)
	
	IupSetAttribute(item_save, "IMAGE", "img_save")
	
	IupSetCallback(item_save, "ACTION", Cast(Any Ptr , @item_save_callback))			
	
	' Save As
	item_save_as = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menusaveas") & !"\tCtrl+Alt+S", NULL)
	
	IupSetCallback(item_save_as, "ACTION", Cast(Any Ptr , @item_save_as_callback))	
	
	' Save All
	item_save_all = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menusaveall") & !"\tShift+Ctrl+S", NULL)
	
	IupSetAttribute(item_save_all, "IMAGE", "img_save_all")
	
	IupSetCallback(item_save_all, "ACTION", Cast(Any Ptr , @item_save_all_callback))
	
	' Close
	item_close = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuclose") & !"\tF4", NULL)
	
	IupSetCallback(item_close, "ACTION", Cast(Any Ptr , @item_close_callback))		
	
	' Close All
	item_close_all = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menucloseall") & !"\tCtrl+F4", NULL)
	
	IupSetCallback(item_close_all, "ACTION", Cast(Any Ptr , @item_close_all_callback))
	
	' Recent files
	recent_menu = IupMenu(NULL)
	
	item_recent_files = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menurecent") , recent_menu)
	
	IupConfigRecentInit(TGlobalVariables->hConfig, recent_menu, @config_recent_callback, 10)
	
	' Exit
	item_exit = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuexit") & !"\tAlt+F4", NULL)
	
	IupSetCallback(item_exit, "ACTION", Cast(Any Ptr , @item_exit_callback))	
	
	
	item_file = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"submenufile"), _
	IupMenu(_
	item_new ,_
	item_open ,_
	item_openfileenc ,_
	item_save , _
	item_save_as , _
	item_save_all ,_
	item_encforsave ,_
	item_close , _
	item_close_all , _
	IupSeparator(),_
	item_recent_files , _
	IupSeparator(),_
	item_exit,_
	NULL))
	
	'---------------------------		
	' Undo
	item_undo = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuundo") & !"\tCtrl+Z", NULL)
	
	IupSetAttribute(item_undo, "IMAGE", "img_undo")
	
	IupSetCallback(item_undo, "ACTION", Cast(Any Ptr , @item_undo_callback))	
	
	' Redo
	item_redo = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuredo") & !"\tCtrl+Y", NULL)
	
	IupSetAttribute(item_redo, "IMAGE", "img_redo")
	
	IupSetCallback(item_redo, "ACTION", Cast(Any Ptr , @item_redo_callback))
	
	' Cut
	item_cut = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menucut") & !"\tCtrl+X", NULL)
	
	IupSetAttribute(item_cut, "IMAGE", "img_cut")
	
	IupSetCallback(item_cut, "ACTION", Cast(Any Ptr , @item_cut_callback))
	
	' Copy
	item_copy = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menucopy") & !"\tCtrl+C", NULL)
	
	IupSetAttribute(item_copy, "IMAGE", "img_copy")
	
	IupSetCallback(item_copy, "ACTION", Cast(Any Ptr , @item_copy_callback))	
	
	' Paste
	item_paste = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menupaste") & !"\tCtrl+V", NULL)
	
	IupSetAttribute(item_paste, "IMAGE", "img_paste")
	
	IupSetCallback(item_paste, "ACTION", Cast(Any Ptr , @item_paste_callback))		
	
	' Delete
	item_delete = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menudelete") & !"\tDel", NULL)
	
	IupSetAttribute(item_delete, "IMAGE", "img_delete")
	
	IupSetCallback(item_delete, "ACTION", Cast(Any Ptr , @item_delete_callback))	
	
	' Find
	item_find = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menufind") & !"\tCtrl+F", NULL)
	
	IupSetAttribute(item_find, "IMAGE", "img_find")
	
	IupSetCallback(item_find, "ACTION", Cast(Any Ptr , @item_find_callback))	
	
	' Find next
	item_find_next = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menufindnext") & !"\tF3", NULL)
	
	IupSetCallback(item_find_next, "ACTION", Cast(Any Ptr , @item_find_next_callback))	
	
	' Find Prev
	item_find_prev = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menufindprev") & !"\tCtrl+F3", NULL)
	
	IupSetCallback(item_find_prev, "ACTION", Cast(Any Ptr , @item_find_prev_callback))		
	
	' Replace
	item_replace = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menureplace") & !"\tCtrl+R", NULL)
	
	IupSetAttribute(item_replace, "IMAGE", "img_replace")
	
	IupSetCallback(item_replace, "ACTION", Cast(Any Ptr , @item_replace_callback))		
	
	' Goto
	item_goto = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menugoto") & !"\tCtrl+G", NULL)
	
	IupSetCallback(item_goto, "ACTION", Cast(Any Ptr , @item_goto_callback))	
	
	' Toggle bookmarks
	item_bookmarks_toggle = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menutogglebook") & !"\tShift+F8", NULL)
	
	IupSetAttribute(item_bookmarks_toggle, "IMAGE", "img_set_bookmark")
	
	IupSetCallback(item_bookmarks_toggle, "ACTION", Cast(Any Ptr , @item_bookmarks_toggle_callback))	
	
	' Next bookmarks
	item_bookmarks_next = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menunextbook") & !"\tF8", NULL)
	
	IupSetAttribute(item_bookmarks_next, "IMAGE", "img_next_bookmark")
	
	IupSetCallback(item_bookmarks_next, "ACTION", Cast(Any Ptr , @item_bookmarks_next_callback))		
	
	' Prev bookmarks
	item_bookmarks_prev = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuprevbook") & !"\tCtrl+F8", NULL)
	
	IupSetAttribute(item_bookmarks_prev, "IMAGE", "img_prev_bookmark")
	
	IupSetCallback(item_bookmarks_prev, "ACTION", Cast(Any Ptr , @item_bookmarks_prev_callback))		
	
	' Clear All bookmarks
	item_bookmarks_clear_all = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuclearbook") & !"\tShift+Ctrl+F8", NULL)
	
	IupSetAttribute(item_bookmarks_clear_all, "IMAGE", "img_delete_bookmark")
	
	IupSetCallback(item_bookmarks_clear_all, "ACTION", Cast(Any Ptr , @item_bookmarks_clear_all_callback))		
	
	'submenu bookmarks
	item_bookmarks = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"submenubook"), IupMenu(_
	item_bookmarks_toggle,_
	item_bookmarks_next ,_
	item_bookmarks_prev ,_
	item_bookmarks_clear_all,_
	NULL))
	
	' Trim Spaces in trailing
	item_space_trim_trailing = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menutrimspaceintr"), NULL)
	
	IupSetCallback(item_space_trim_trailing, "ACTION", Cast(Any Ptr , @item_space_trim_trailing_callback))
	
	' Trim Spaces in leading
	item_space_trim_leading = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menutrimspaceinle"), NULL)
	
	IupSetCallback(item_space_trim_leading, "ACTION", Cast(Any Ptr , @item_space_trim_leading_callback))	
	
	' Trim Spaces in trailing and leading
	item_space_trim_trailing_and_leading = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menutrimspaceintrle"), NULL)
	
	IupSetCallback(item_space_trim_trailing_and_leading, "ACTION", Cast(Any Ptr , @item_space_trim_trailing_and_leading_callback))
	
	' Spaces to Tab in Begin
	item_space_to_tab_begin = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuspacetotabbegin"), NULL)
	
	IupSetCallback(item_space_to_tab_begin, "ACTION", Cast(Any Ptr , @item_space_to_tab_begin_callback))	
	
	' Spaces to Tab
	item_space_to_tab = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuspacetotab"), NULL)
	
	IupSetCallback(item_space_to_tab, "ACTION", Cast(Any Ptr , @item_space_to_tab_callback))	
	
	' Tab to Spaces in Begin
	item_tab_to_space_begin = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menutabtospacebegin"), NULL)
	
	IupSetCallback(item_tab_to_space_begin, "ACTION", Cast(Any Ptr , @item_tab_to_space_begin_callback))		
	
	' Tab to Spaces 
	item_tab_to_space = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menutabtospace"), NULL)
	
	IupSetCallback(item_tab_to_space, "ACTION", Cast(Any Ptr , @item_tab_to_space_callback))	
	
	'submenu Spaces
	item_spaces = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"submenuoperationswithspace"), IupMenu(_
	item_space_trim_trailing,_
	item_space_trim_leading ,_
	item_space_trim_trailing_and_leading ,_
	item_space_to_tab_begin,_
	item_space_to_tab,_
	item_tab_to_space_begin,_
	item_tab_to_space,_
	NULL))	
	
	' convert Lower Case
	item_convert_lower_case = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menulowercase") & !"\tCtrl+L", NULL)
	
	IupSetCallback(item_convert_lower_case, "ACTION", Cast(Any Ptr , @item_convert_lower_case_callback))
	
	' convert Upper Case
	item_convert_upper_case = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuuppercase") & !"\tCtrl+U", NULL)
	
	IupSetCallback(item_convert_upper_case, "ACTION", Cast(Any Ptr , @item_convert_upper_case_callback))
	
	
	'submenu Convert
	item_convert_case = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"submenuconvertsimvols") , IupMenu(_
	item_convert_upper_case,_
	item_convert_lower_case ,_
	NULL))	
	
	' AutoIndent
	item_autoindent = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuautoindent") & !"\tCtrl+Shift+F12", NULL)
	
	IupSetCallback(item_autoindent, "ACTION", Cast(Any Ptr , @item_autoindent_callback))		 
	
	' Select All
	item_select_all = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuselectall") & !"\tCtrl+A", NULL)
	
	IupSetCallback(item_select_all, "ACTION", Cast(Any Ptr , @item_select_all_callback))	
	
	
	item_edit = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"submenuedit"), _
	IupMenu(item_undo ,_
	item_redo ,_
	item_cut , _
	item_copy , _
	item_paste ,_
	item_delete , _
	item_find , _
	item_find_next,_
	item_find_prev , _
	item_replace,_
	item_goto,_
	item_bookmarks,_
	item_spaces,_
	item_convert_case,_
	item_autoindent,_
	item_select_all,_
	NULL))		
	
	'--------------------------------------------
	
	' zoom plus
	item_view_zoom_plus = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuzoomin") & !"\tCtrl_Num +", NULL)
	
	IupSetCallback(item_view_zoom_plus, "ACTION", Cast(Any Ptr , @item_view_zoom_plus_callback))
	
	' zoom minus
	item_view_zoom_minus = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuzoomout") & !"\tCtrl_Num -", NULL)
	
	IupSetCallback(item_view_zoom_minus, "ACTION", Cast(Any Ptr , @item_view_zoom_minus_callback))		
	
	' zoom default
	item_view_zoom_default = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuzoomdefault") & !"\tCtrl_Num /", NULL)
	
	IupSetCallback(item_view_zoom_default, "ACTION", Cast(Any Ptr , @item_view_zoom_default_callback))			
	
	'submenu ZOOM
	item_view_zoom = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"submenuzoom"), IupMenu(_
	item_view_zoom_plus,_
	item_view_zoom_minus ,_
	item_view_zoom_default ,_
	NULL))
	
	
	' word wrap
	item_view_word_wrap = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuwordwrap"), NULL)
	
	IupSetCallback(item_view_word_wrap, "ACTION", Cast(Any Ptr , @item_view_word_wrap_callback))	 	
	
	IupSetAttribute(item_view_word_wrap, "AUTOTOGGLE", "YES")
	
	IupSetAttribute(item_view_word_wrap, "VALUE", "OFF")
	
	IupSetAttribute(item_view_word_wrap, "NAME", "menuwordwrap")
	
	' show white spaces
	item_view_show_white_spaces = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menushowwhitespaces") , NULL)
	
	IupSetCallback(item_view_show_white_spaces, "ACTION", Cast(Any Ptr , @item_view_show_white_spaces_callback))
	
	IupSetAttribute(item_view_show_white_spaces, "AUTOTOGGLE", "YES")
	
	IupSetAttribute(item_view_show_white_spaces, "VALUE", "OFF")
	
	IupSetAttribute(item_view_show_white_spaces, "NAME", "menuwhitespaces")
	
	'View toolbar
	item_view_toolbar = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuviewtoolbar"), NULL)
	
	IupSetCallback(item_view_toolbar, "ACTION", Cast(Any Ptr , @item_view_toolbar_callback))
	
	IupSetAttribute(item_view_toolbar, "AUTOTOGGLE", "YES")
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"ChildParam","toolbarvisible") = "1" Then
		
		IupSetAttribute(item_view_toolbar, "VALUE", "ON")
		
	Else
		
		IupSetAttribute(item_view_toolbar, "VALUE", "OFF")
		
	Endif
	
	'View statusbar
	item_view_statusbar = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuviewstatusbar"), NULL)
	
	IupSetCallback(item_view_statusbar, "ACTION", Cast(Any Ptr , @item_view_statusbar_callback))
	
	IupSetAttribute(item_view_statusbar, "AUTOTOGGLE", "YES")	
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"ChildParam","statusbarvisible") = "1" Then
		
		IupSetAttribute(item_view_statusbar, "VALUE", "ON")
		
	Else
		
		IupSetAttribute(item_view_statusbar, "VALUE", "OFF")
		
	Endif
	
	'View Line Numbers
	item_view_line_numbers = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuviewlinenumbers"), NULL)
	
	IupSetCallback(item_view_line_numbers, "ACTION", Cast(Any Ptr , @item_view_line_numbers_callback))
	
	IupSetAttribute(item_view_line_numbers, "AUTOTOGGLE", "YES")	
	
	IupSetAttribute(item_view_line_numbers, "VALUE", "ON")
	
	IupSetAttribute(item_view_line_numbers, "NAME", "menuviewnumbers")		
	
	
	'View winside window
	item_view_winside = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuviewwinside"), NULL)
	
	IupSetCallback(item_view_winside, "ACTION", Cast(Any Ptr , @item_view_winside_callback))
	
	IupSetAttribute(item_view_winside, "AUTOTOGGLE", "YES")	
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"ChildParam","winsidevisible") = "1" Then
		
		IupSetAttribute(item_view_winside, "VALUE", "ON")
		
	Else
		
		IupSetAttribute(item_view_winside, "VALUE", "OFF")
		
	Endif
	
	IupSetAttribute(item_view_winside, "NAME", "menuviewnumbers")		
	
	item_view = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"submenuview") , _
	IupMenu(item_view_zoom ,_
	item_view_word_wrap ,_
	item_view_show_white_spaces , _
	item_view_winside , _
	item_view_toolbar , _
	item_view_statusbar ,_
	item_view_line_numbers , _
	NULL))


	'----------------------------------------------
	
	' New Project
	item_project_new = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuprojectnew") , NULL)
	
	IupSetCallback(item_project_new, "ACTION", Cast(Any Ptr , @item_projectnew_callback))
	
	' Open Project
	item_project_open = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuprojectopen") , NULL)
	
	IupSetCallback(item_project_open, "ACTION", Cast(Any Ptr , @item_projectopen_callback))
	
	' Close Project
	item_project_close = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuprojectclose") , NULL)
	
	IupSetCallback(item_project_close, "ACTION", Cast(Any Ptr , @item_projectclose_callback))	
	
	' project add new file
	item_project_addnew_file = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuprojectaddf") , NULL)
	
	IupSetCallback(item_project_addnew_file, "ACTION", Cast(Any Ptr , @item_project_addnewfile_callback))
	
	' project add new module
	item_project_addnew_module = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuprojectaddm") , NULL)
	
	IupSetCallback(item_project_addnew_module, "ACTION", Cast(Any Ptr , @item_project_addnewmodule_callback))
	
	' project add new
	item_project_addnew = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuprojectaddnew"), _
	IupMenu(item_project_addnew_file,_
	item_project_addnew_module,_
	NULL))
	
	' project add existing file
	item_project_existing_file = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuprojectaddf") , NULL)
	
	IupSetCallback(item_project_existing_file, "ACTION", Cast(Any Ptr , @item_project_addexfile_callback))
	
	' project add existing module
	item_project_existing_module = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuprojectaddm") , NULL)
	
	IupSetCallback(item_project_existing_module, "ACTION", Cast(Any Ptr , @item_project_addexmodule_callback))
	
	' project add existing
	item_project_existing = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuprojectaddex"), _
	IupMenu(item_project_existing_file,_
	item_project_existing_module,_
	NULL))	
	
	' project do curent to main
	item_project_do_curent = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuprojectdomain") , NULL)
	
	IupSetCallback(item_project_do_curent, "ACTION", Cast(Any Ptr , @item_project_do_curent_callback))
	
	' project delete curent
	item_project_del_curent = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuprojectdelf") , NULL)
	
	IupSetCallback(item_project_del_curent, "ACTION", Cast(Any Ptr , @item_project_deletecurent_callback))
	
	' project rename curent
	item_project_rename_curent = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuprojectrenf") , NULL)
	
	IupSetCallback(item_project_rename_curent, "ACTION", Cast(Any Ptr , @item_project_renamecurent_callback))
	
	' project options
	item_project_options = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuprojectopt") , NULL)
	
	IupSetCallback(item_project_options, "ACTION", Cast(Any Ptr , @item_project_options_callback))
	
	' project
	item_project = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuproject"), _
	IupMenu(_
	item_project_new,_
	item_project_open,_
	item_project_close,_
	IupSeparator(),_	
	item_project_addnew,_
	item_project_existing,_
	item_project_do_curent,_
	item_project_del_curent,_
	item_project_rename_curent,_
	item_project_options,_
	NULL))
	
	'----------------------------------------------
	
	' compile
	item_compile = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menucompile") & !"\tShift+Ctrl+F5", NULL)
	
	IupSetAttribute(item_compile, "IMAGE", "img_compile")
	
	IupSetCallback(item_compile, "ACTION", Cast(Any Ptr , @item_compile_callback))	
	
	' Run
	item_run = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menurun") & !"\tShift+F5", NULL)
	
	IupSetAttribute(item_run, "IMAGE", "img_run")
	
	IupSetCallback(item_run, "ACTION", Cast(Any Ptr , @item_run_callback))			
	
	' compile and run
	item_compile_and_run = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menucompileandrun") & !"\tCtrl+F5", NULL)
	
	IupSetAttribute(item_compile_and_run, "IMAGE", "img_compile_and_run")
	
	IupSetCallback(item_compile_and_run, "ACTION", Cast(Any Ptr , @item_compile_and_run_callback))
	
	' quick run
	item_quick_run = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuquickrun") & !"\tF5", NULL)
	
	IupSetAttribute(item_quick_run, "IMAGE", "img_quick_run")
	
	IupSetCallback(item_quick_run, "ACTION", Cast(Any Ptr , @item_quick_run_callback))
	
	' run with debugger
	item_debug = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menudebug"), NULL)
	
	IupSetCallback(item_debug, "ACTION", Cast(Any Ptr , @item_debug_callback))			
	
	' params for command line
	item_command = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menucommand"), NULL)
	
	IupSetCallback(item_command, "ACTION", Cast(Any Ptr , @item_command_for_exe_callback))	
	
	
	item_build = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"submenubuild"), _
	IupMenu(item_compile ,_
	item_run ,_
	item_compile_and_run , _
	item_quick_run , _
	item_debug ,_
	item_command ,_
	NULL))		
	
	'----------------------------------------------------	
	
	' TOOLS
	
	TGlobalVariables->hItemTools = IupMenu(0)
	
	item_tools = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"submenutools"),TGlobalVariables->hItemTools)		
	
	For i As Long = 1 To 100
		
		If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"TOOL", "n" & i) <> "" Then
			
			Dim As Ihandle Ptr hTempMenu = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfig,"TOOL", "n" & i), NULL)
			
			IupAppend(TGlobalVariables->hItemTools , hTempMenu)
			
			IupSetCallback(hTempMenu, "ACTION", Cast(Any Ptr , @item_tools_custom_callback))
			
			IupMap(hTempMenu)
			
		Else
			
			Exit For
			
		Endif
		
	Next			
	
	
	
	'----------------------------------------------------
	
	
	'options 
	item_options_item_edit = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionseditor"), NULL)
	
	IupSetCallback(item_options_item_edit, "ACTION", Cast(Any Ptr , @item_options_edit_callback))	
	
	item_options_item_build = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionsbuild"), NULL)	
	
	IupSetCallback(item_options_item_build, "ACTION", Cast(Any Ptr , @item_options_build_callback))		
	
	item_options_item_tools = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionstools"), NULL)	
	
	IupSetCallback(item_options_item_tools, "ACTION", Cast(Any Ptr , @item_options_tools_callback))
	
	item_options_item_help = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionshelps"), NULL)	
	
	IupSetCallback(item_options_item_help, "ACTION", Cast(Any Ptr , @item_options_helps_callback))
	
	item_options_item_plugins = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionsplugins"), NULL)	
	
	IupSetCallback(item_options_item_plugins, "ACTION", Cast(Any Ptr , @item_open_setting_dialog_plugin_callback))
	
	item_options_encoding = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionsencoding"), IupMenu(_
	item_encnumbers,_
	item_encsysdef ,_
	NULL))
	
	item_options = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"submenuoptions"), _
	IupMenu(item_options_item_edit ,item_options_item_build ,item_options_item_tools,item_options_item_help, _
	item_options_item_plugins,item_options_encoding, NULL))	
	
	
	
	
	'--------------------------------------------------
	
	'help FB
	TGlobalVariables->hItemFB = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuhelpFB"), NULL)	   
	
	IupSetCallback(TGlobalVariables->hItemFB, "ACTION", Cast(Any Ptr , @item_helps_custom_callback))
	
	'help about
	TGlobalVariables->hItemAbout = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuabout"), NULL)
	
	IupSetCallback(TGlobalVariables->hItemAbout, "ACTION", Cast(Any Ptr , @item_help_about_callback))		
	
	item_help = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"submenuhelp"), _
	IupMenu(TGlobalVariables->hItemFB ,_
	TGlobalVariables->hItemAbout,_
	NULL))			
	
	' Added help custom menu
	
	For i As Long = 1 To 100
		
		If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"HELPF",  "n" & i) <> "" Then
			
			Dim As Ihandle Ptr hTempMenu = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfig,"HELPF", "n" & i), NULL)
			
			IupInsert(IupGetParent(TGlobalVariables->hItemAbout), TGlobalVariables->hItemAbout , hTempMenu)
			
			IupSetCallback(hTempMenu, "ACTION", Cast(Any Ptr , @item_helps_custom_callback))
			
		Else
			
			Exit For
			
		Endif
		
	Next			
	
	'---------------------------------------------------	 	
	
	' main menu
	main_menu = IupMenu(item_file,item_edit,item_view,item_project,item_build,item_tools,item_options ,item_help,  NULL)
	
	IupSetHandle("MainMenu", main_menu)	
	
End Sub

Function mn_encoding_menu_popup_proc (ih As Ihandle Ptr) As Integer Export
	
	Dim As Ihandle Ptr hDimMenuDoc(122), hDimMenuFile(122), hDimMenuFileSave(122)
	
	mn_fill_menu_items_encoding_proc(hDimMenuDoc() , hDimMenuFile(),hDimMenuFileSave() ,1)
	
	Dim As Ihandle Ptr menu = IupMenu(IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"setencforsave"),IupMenuv(@hDimMenuFileSave(0))),_
	IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"convertdocenconfly"), IupMenuv(@hDimMenuDoc(0))),_
	IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"reopenfileenc"), IupMenuv(@hDimMenuFile(0))),_
	IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"numberencinmenu"), "numbers"),_
	IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"setdefaultenc"), "sysdef"),_
	NULL)
	
	IupSetFunction("numbers", Cast(Any Ptr , @numbers_encoding_in_the_menu_callback))
	
	IupSetFunction("sysdef", Cast(Any Ptr , @select_default_system_menu_callback))
	
	IupPopup(menu, IUP_MOUSEPOS, IUP_MOUSEPOS)
	
	IupDestroy(menu)
	
	Return IUP_DEFAULT
	
End Function

' BuildBox popup menu extension plugins
Sub mn_extension_menu_popup_buildbox_proc(procNew As Sub(As Ihandle Ptr) , iRootMenu As ihandle Ptr = 0) Export
	
	Static As Byte bFlag
	
	Static iItemCount As Long 
	
	Static hProc(100) As Sub(As Ihandle Ptr) 
	
	If procNew Then
		
		hProc(iItemCount) = procNew
		
		If iItemCount < 101 Then
			
			iItemCount +=1
			
		Endif
		
		bFlag = 1
		
	Else
		
		If bFlag Then
			
			For i As Long = 0 To iItemCount-1
				
				hProc(i)(iRootMenu)
				
			Next
			
		Endif
		
	Endif
	
End Sub

Sub mn_menu_popup_buildbox_proc() Export
	
	Dim As Ihandle Ptr i1,i2,i3,i4,i5,i6,menu
	
	i1 = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menupopupbbcopysel") , 0)
	
	IupSetCallback(i1, "ACTION", Cast(Any Ptr,@item_popup_buildbox_copy_sel_callback))
	
	i2 = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menupopupbbcopyall") , 0)
	
	IupSetCallback(i2, "ACTION", Cast(Any Ptr,@item_popup_buildbox_copy_all_callback))
	
	i6 = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menupopupbbclear") , 0)
	
	IupSetCallback(i6, "ACTION", Cast(Any Ptr,@item_popup_buildbox_clear_callback))
	
	If TGlobalVariables->bFlagFindInfo = 0 Then
	
		i3 = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menupopupbbonlyerr") , 0)
		
		IupSetCallback(i3, "ACTION", Cast(Any Ptr,@item_popup_buildbox_only_errors_callback))
		
		i4 = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menupopupbbonlywar") , 0)
		
		IupSetCallback(i4, "ACTION", Cast(Any Ptr,@item_popup_buildbox_only_warnings_callback))
		
		i5 = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menupopupbberrwar") , 0)
		
		IupSetCallback(i5, "ACTION", Cast(Any Ptr,@item_popup_buildbox_errors_and_warnings_callback))
	
		menu = IupMenu(i1,i2,i3,i4,i5,i6, 0)
		
	Else
	
		menu = IupMenu(i1,i2,i6, 0)
	
	Endif
	
	mn_extension_menu_popup_buildbox_proc(0 , menu)
	
	IupPopup(menu, IUP_MOUSEPOS, IUP_MOUSEPOS)
	
	IupDestroy(menu)   
	
End Sub

' Editor popup menu extension plugins
Sub mn_extension_menu_popup_editor_proc(procNew As Sub(As Ihandle Ptr) , iRootMenu As ihandle Ptr = 0) Export
	
	Static As Byte bFlag
	
	Static iItemCount As Long 
	
	Static hProc(100) As Sub(As Ihandle Ptr) 
	
	If procNew Then
		
		hProc(iItemCount) = procNew
		
		If iItemCount < 101 Then
			
			iItemCount +=1
			
		Endif
		
		bFlag = 1
		
	Else
		
		If bFlag Then
			
			For i As Long = 0 To iItemCount-1
				
				hProc(i)(iRootMenu)
				
			Next
			
		Endif
		
	Endif
	
End Sub

' Editor popup menu
Sub mn_menu_popup_editor_proc() Export
	
	Dim As Ihandle Ptr i1,i2 ,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14,i15,i16,i17 
	
	i1 = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menucopy") , 0)
	
	IupSetAttribute(i1, "IMAGE", "img_copy")
	
	IupSetCallback(i1, "ACTION", Cast(Any Ptr , @item_copy_callback))
	
	i2 = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menupaste") , 0)
	
	IupSetAttribute(i2, "IMAGE", "img_paste")
	
	IupSetCallback(i2, "ACTION", Cast(Any Ptr , @item_paste_callback))

	i3 = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menucut"), 0)
	
	IupSetAttribute(i3, "IMAGE", "img_cut")
	
	IupSetCallback(i3, "ACTION", Cast(Any Ptr , @item_cut_callback))	
	
	i4 = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuselectall") , 0)
	
	IupSetCallback(i4, "ACTION", Cast(Any Ptr,@item_select_all_callback))
	
	i5 = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"toolcomment") , 0)
	
	IupSetAttribute(i5, "IMAGE", "img_comment")
	
	IupSetCallback(i5, "ACTION", Cast(Any Ptr,@item_comment_callback()))
	
	i6 = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"tooluncomment") , 0)
	
	IupSetAttribute(i6, "IMAGE", "img_un_comment")
	
	IupSetCallback(i6, "ACTION", Cast(Any Ptr,@item_uncomment_callback()))
	
	i7 = IupItem("WIN (CRLF)" , 0)
	
	IupSetCallback(i7, "ACTION", Cast(Any Ptr,@convert_crlf_multitext_callback))  
	
	i8 = IupItem("UNIX (LF)" , 0)
	
	IupSetCallback(i8, "ACTION", Cast(Any Ptr,@convert_lf_multitext_callback))
	
	i9 = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"getdeclvar"), 0)
	
	IupSetCallback(i9, "ACTION", Cast(Any Ptr,@get_declares_var_callback))
	
	i10 = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"gettypevar"), 0)
	
	IupSetCallback(i10, "ACTION", Cast(Any Ptr,@get_type_var_callback))
	
	i11 = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"getdeclvarprev"), 0)
	
	IupSetCallback(i11, "ACTION", Cast(Any Ptr,@get_declaresprev_var_callback))

	i12 = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"getinfoproc"), 0)
	
	IupSetCallback(i12, "ACTION", Cast(Any Ptr,@get_infoproc_callback))
	
	i13 = IupItem("freebasic", 0)
	
	IupSetCallback(i13, "ACTION", Cast(Any Ptr,@set_syntax_highlighting_f_callback))
	
	i14 = IupItem("asm", 0)
	
	IupSetCallback(i14, "ACTION", Cast(Any Ptr,@set_syntax_highlighting_a_callback))
	
	i15 = IupItem("cpp", 0)
	
	IupSetCallback(i15, "ACTION", Cast(Any Ptr,@set_syntax_highlighting_c_callback))
	
	i16 = IupItem("rc", 0)
	
	IupSetCallback(i16, "ACTION", Cast(Any Ptr,@set_syntax_highlighting_r_callback))
	
	i17 = IupItem("none", 0)
	
	IupSetCallback(i17, "ACTION", Cast(Any Ptr,@set_syntax_highlighting_n_callback))	
	
	Dim As Ihandle Ptr menu = IupMenu(i1,i2,i3,i4,IupSeparator(),i5,i6,IupSeparator(), i9, i11, i10, i12, IupSeparator(), _
	IupSubmenu(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionlineend"),_
	IupMenu(i7,i8,0)),_
	IupSubmenu("lexer",_
	IupMenu(i13,i14,i15,i16,i17,0)),_
	0)
	
	mn_extension_menu_popup_editor_proc(0 , menu)
	
	IupPopup(menu, IUP_MOUSEPOS, IUP_MOUSEPOS)
	
	IupDestroy(menu)   
	
End Sub

' update items encoding in the main menu after options
Sub mn_update_mainmenu_after_options_encoding_proc()
	
	Dim As ihandle Ptr menu_enc_fs , menu_enc_open , menufs , menuop , hDel1 , hDel2
	
	menu_enc_fs = IupGetDialogChild(TGlobalVariables->dlg, "menuencforsave")
	
	menu_enc_open = IupGetDialogChild(TGlobalVariables->dlg, "menuopenfileenc")
	
	If menu_enc_fs Then
		
		hDel1 = IupGetChild(menu_enc_fs , 0)
		
	Endif
	
	If menu_enc_open Then
		
		hDel2 = IupGetChild(menu_enc_open , 0)
		
	Endif
	
	If hDel1 Then
		
		iupdestroy(hDel1)
		
	Endif
	
	If hDel2 Then
		
		iupdestroy(hDel2)
		
	Endif	
	
	If menu_enc_fs Andalso menu_enc_open Then
		
		Dim As Ihandle Ptr hDimMenuFile(122), hDimMenuFileSave(122) , hDoc(0)
		
		Dim As Long iRet = mn_fill_menu_items_encoding_proc(hDoc() , hDimMenuFile(),hDimMenuFileSave())
		
		If iRet Then
			
			IupSetAttribute(menu_enc_fs,"ACTIVE","YES")
			
			IupSetAttribute(menu_enc_open,"ACTIVE","YES")
			
			menufs = IupMenuV(@hDimMenuFileSave(0))
			
			menuop = IupMenuV(@hDimMenuFile(0))
			
			If menufs Then
				
				IupAppend(menu_enc_fs , menufs )
				
				IupMap(menufs)					
				
			Endif
			
			If menuop Then
				
				IupAppend(menu_enc_open , menuop )
				
				IupMap(menuop)					
				
			Endif
			
		Else
			
			IupSetAttribute(menu_enc_fs,"ACTIVE","NO")
			
			IupSetAttribute(menu_enc_open,"ACTIVE","NO")
			
		Endif
		
	Endif
	
End Sub

' setup flag "ON" item encoding in the main menu
Sub mn_set_flag_on_item_encoding_proc() 

	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))

	Dim As ihandle Ptr menu_enc_fs = IupGetDialogChild(TGlobalVariables->dlg, "menuencforsave")
	
	If menu_enc_fs Then
		
		Dim As ihandle Ptr submenu = IupGetChild(menu_enc_fs , 0)
		
		If submenu Then
			
			Dim As ihandle Ptr item_child = IupGetNextChild(submenu, NULL)
			
			While(item_child)

				If IupGetChildCount(TGlobalVariables->tabs) > 1 Then 

					If *IupGetAttribute(item_child , "TITLE") = *IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "CURRENTENCODING") Then

						IupSetAttribute(item_child,"VALUE","ON")
						
					Else
					
						IupSetAttribute(item_child,"VALUE","OFF")
						
					Endif
					
				Else
					
					IupSetAttribute(item_child,"VALUE","OFF")			
					
				Endif

				item_child = IupGetNextChild(submenu, item_child)
				
			Wend		
			
		Endif
		
	Endif

End Sub

Sub mn_create_project_popup_inwinside_proc()
	
	Dim As Ihandle Ptr i1,i2 ,i3
	
	' project do curent to main
	i1 = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuprojectdomain") , NULL)
	
	IupSetCallback(i1, "ACTION", Cast(Any Ptr , @item_project_do_curent_callback))
	
	' project delete curent
	i2 = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuprojectdelf") , NULL)
	
	IupSetCallback(i2, "ACTION", Cast(Any Ptr , @item_project_deletecurent_callback))
	
	' project rename curent
	i3 = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuprojectrenf") , NULL)
	
	IupSetCallback(i3, "ACTION", Cast(Any Ptr , @item_project_renamecurent_callback))     
	
	Dim As Ihandle Ptr menu = IupMenu(i1,i2,i3, 0)
	
	IupPopup(menu, IUP_MOUSEPOS, IUP_MOUSEPOS)
	
	IupDestroy(menu)	
	
End Sub

Sub mn_find_recent_proc()
	
	Dim As Ihandle Ptr m(1 To 11)
		
	If tRecentFindInfo Andalso tRecentFindInfo->iIndex Then
	
		Dim As TQueueList Ptr pTemp = tRecentFindInfo->pF
		
		For i As Long = 1 To tRecentFindInfo->iIndex
			
			If pTemp Andalso pTemp->psPath Then
				
				m(i) = IupItem(pTemp->psPath , NULL)
				
				IupSetCallback(m(i), "ACTION", Cast(Any Ptr , @item_find_recent_callback))
				
				IupSetStrAttribute(m(i) , "mID" , Str(i))
				
				pTemp = pTemp->p
				
			Endif
			
		Next

		Dim As Ihandle Ptr menu = IupMenuv(@m(1))
		
		IupPopup(menu, IUP_MOUSEPOS, IUP_MOUSEPOS)
		
		IupDestroy(menu)
	
	Endif	
	
End Sub