#Include "../tlist.bi"
#include "../declarations.bi"

#Ifdef __FB_WIN32__
	
	Dim pDll As  Any Ptr
	
	Dim Shared mn_extension_menu_popup_editor_proc as Sub (p as sub(As Ihandle Ptr) , iRootMenu as ihandle ptr = 0) 
	
	Dim Shared mn_extension_menu_popup_buildbox_proc as Sub (p as sub(As Ihandle Ptr) , iRootMenu as ihandle ptr = 0) 
	
	pDll = DylibLoad("../fbnp.exe")
	
	If pDll <> 0 Then
		
		mn_extension_menu_popup_editor_proc = DylibSymbol(pDll, "MN_EXTENSION_MENU_POPUP_EDITOR_PROC")
		
		mn_extension_menu_popup_buildbox_proc = DylibSymbol(pDll, "MN_EXTENSION_MENU_POPUP_BUILDBOX_PROC")
		
	EndIf

#else

	declare Sub mn_extension_menu_popup_editor_proc(p as sub(As Ihandle Ptr) , iRootMenu as ihandle ptr = 0)
	
	declare Sub mn_extension_menu_popup_buildbox_proc(p as sub(As Ihandle Ptr) , iRootMenu as ihandle ptr = 0)
	
#EndIf



dim shared as T_GlobalVariables Ptr TGlobalVariablesDll

Function item_testproc_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	IupMessage("Information","This is a test item popup")
	
	return IUP_DEFAULT
	
End Function

sub AddMenu(pRoot as Ihandle Ptr ) export
	
	dim as ihandle ptr pPlugItem = IupItem("Test Plugin", NULL)
	
	IupSetCallback(pPlugItem, "ACTION", cast(any ptr , @item_testproc_callback))
	
	IupAppend( pRoot, pPlugItem ) 
	
	IupMap(pPlugItem)		

End Sub

function InitPluginProc(TGlobalVariables as T_GlobalVariables Ptr , pszDimErrors() as zstring ptr , bEncodingBool() as byte , szEncodingString as any ptr) as Integer export
	
	if TGlobalVariables = 0 then return 0
	
	TGlobalVariablesDll = TGlobalVariables

	mn_extension_menu_popup_editor_proc(@AddMenu()) ' for editor popup
	
	mn_extension_menu_popup_buildbox_proc(@AddMenu()) ' for buildbox popup
	
	return 1	
	
End Function