Function prj_dialog_proc(iOptionNew As Long = 1) As Ihandle Ptr Export
	
	Dim As Ihandle Ptr lblname , lblpath , lblparam , lblenc ,_
	textname , textpath , textparam , combo, btnok , btnpath , _
	btncancel , vbox , hboxbtn , hboxpath, dlg
	
	lblname = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"prjname"))
	
	lblpath = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"prjpath"))
	
	lblparam = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"submenubuild"))
	
	lblenc = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"toolencoding"))
	
	textname = IupText(0)
	
	textpath = IupText(0)
	
	textparam = IupText(0)
	
	btnpath = IupButton("...", 0)
	
	btnok = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionbtnok"), 0)
	
	btncancel = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionbtncancel"), 0)
	
	combo = IupList(NULL)
	
	IupSetAttributes(combo, "DROPDOWN=YES")	
	
	IupSetAttributes(combo, "EXPAND=HORIZONTAL")	
	
	IupSetAttribute(combo, "NAME" , "comboprj")
	
	IupSetAttribute(textname , "MINSIZE" , "300x30")
	
	IupSetAttribute(textpath , "MINSIZE" , "265x30")
	
	IupSetAttribute(textparam , "MINSIZE" , "300x30")
	
	IupSetAttribute(textname , "NAME" , "txtprjname")
	
	IupSetAttribute(textpath , "NAME" , "txtprjpath")
	
	IupSetAttribute(textparam , "NAME" , "txtprjparam")
	
	If iOptionNew Then
		
		IupSetAttribute(textparam , "VALUE" , "-s gui")
		
		IupSetAttribute(btnok , "NEW" , "1")
		
		Dim As Long j = 1
		
		For i As Long = 0 To 121
			
			If bEncodingBool(i) Then
				
				IupSetAttribute(combo , Str(j) , szEncodingString(i))
				
				j+=1
				
			Endif
			
		Next
		
	Else
		
		#ifdef __fb_win32__
			
			Dim As String sNameTemp , sPathTemp
			
			sNameTemp = enc_encode_path_proc(*(pProject.pszNameProject),1)
			
			sPathTemp = enc_encode_path_proc(*(pProject.pszPathProject),1)
			
			IupSetStrAttribute(textname , "VALUE" , Strptr(sNameTemp))
			
			IupSetStrAttribute(textpath , "VALUE" , Strptr(sPathTemp))
			
		#else
			
			IupSetAttribute(textname , "VALUE" , *(pProject.pszNameProject))
			
			IupSetAttribute(textpath , "VALUE" , *(pProject.pszPathProject))
			
		#endif
		
		IupSetStrAttribute(textname , "OLDNAME" , *(pProject.pszNameProject))
		
		IupSetAttribute(textparam , "VALUE" , pProject.pszParamProject)
		
		IupSetAttribute(combo , "1" , pProject.pszEncProject)
		
		IupSetAttribute(textpath , "ACTIVE" , "NO")
		
		IupSetAttribute(btnpath , "ACTIVE" , "NO")
		
		IupSetAttribute(combo , "ACTIVE" , "NO")
		
	Endif
	
	IupSetAttribute(combo , "VALUE" , "1")
	
	IupSetAttribute(btnpath , "MAXSIZE" , "x30")
	
	IupSetAttribute(btnpath , "MINSIZE" , "30x30")
	
	IupSetAttribute(btnok , "MINSIZE" , "100x30")
	
	IupSetAttribute(btncancel , "MINSIZE" , "100x30")
	
	IupSetCallback(btnpath , "ACTION" , Cast(Any Ptr, @project_btn_path_callback()))
	
	IupSetCallback(btnok , "ACTION" , Cast(Any Ptr, @project_btn_ok_callback()))
	
	IupSetCallback(btncancel , "ACTION" , Cast(Any Ptr, @project_btn_cancel_callback()))
	
	hboxpath = IupHbox(textpath , btnpath,0)
	
	hboxbtn = IupHbox(iupfill() , btnok , iupfill(), btncancel, iupfill()  ,0)
	
	vbox = IupvBox(lblname , textname , lblpath, hboxpath , lblparam , textparam , lblenc , combo , hboxbtn , 0)
	
	IupSetAttribute(vbox , "GAP" , "10")
	
	IupSetAttribute(vbox , "NMARGIN" , "10x10")
	
	IupSetAttribute(vbox , "EXPANDCHILDREN" , "YES")
	
	dlg = IupDialog(vbox)
	
	IupSetCallback(dlg, "CLOSE_CB", Cast(Any Ptr , @project_dlgoption_close_callback))
	
	If iOptionNew Then
		
		IupSetAttribute(dlg, "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"prjnew"))
		
	Else
		
		IupSetAttribute(dlg, "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"prjopt"))
		
	Endif
	
	IupSetAttribute(dlg, "DIALOGFRAME", "Yes")
	
	IupShow(dlg)	
	
	Return dlg
	
End Function

Function prj_dialog_add_file_proc(iModule As Long ) As Ihandle Ptr Export
	
	Dim As Ihandle Ptr textname , btnok , btncancel , vbox , hboxbtn , dlg
	
	textname = IupText(0)
	
	btnok = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionbtnok"), 0)
	
	btncancel = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionbtncancel"), 0)
	
	IupSetAttribute(textname , "MINSIZE" , "300x30")
	
	IupSetAttribute(textname , "NAME" , "txtprjname")
	
	If iModule Then
		
		IupSetAttribute(btnok , "MODULE" , "1")
		
	Endif
	
	IupSetAttribute(btnok , "MINSIZE" , "100x30")
	
	IupSetAttribute(btncancel , "MINSIZE" , "100x30")
	
	IupSetCallback(btnok , "ACTION" , Cast(Any Ptr, @project_btn_ok_add_callback()))
	
	IupSetCallback(btncancel , "ACTION" , Cast(Any Ptr, @project_btn_cancel_add_callback()))
	
	hboxbtn = IupHbox(iupfill() , btnok , iupfill(), btncancel, iupfill()  ,0)
	
	vbox = IupvBox( textname , hboxbtn , 0)
	
	IupSetAttribute(vbox , "GAP" , "10")
	
	IupSetAttribute(vbox , "NMARGIN" , "10x10")
	
	IupSetAttribute(vbox , "EXPANDCHILDREN" , "YES")
	
	dlg = IupDialog(vbox)
	
	IupSetCallback(dlg, "CLOSE_CB", Cast(Any Ptr , @project_dlgoption_close_callback))
	
	If iModule Then
		
		IupSetAttribute(dlg, "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"prjaddm"))
		
	Else
		
		IupSetAttribute(dlg, "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"prjaddf"))
		
	Endif
	
	IupSetAttribute(dlg, "DIALOGFRAME", "Yes")
	
	IupShow(dlg)	
	
	Return dlg
	
End Function

Function prj_dialog_rename_file_proc(iModule As Long  , sFile As String) As Ihandle Ptr
	
	Dim As Ihandle Ptr textname , btnok , btncancel , vbox , hboxbtn , dlg
	
	textname = IupText(0)
	
	btnok = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionbtnok"), 0)
	
	btncancel = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionbtncancel"), 0)
	
	IupSetAttribute(textname , "MINSIZE" , "300x30")
	
	IupSetAttribute(textname , "NAME" , "txtprjname")
	
	#ifdef __fb_win32__
		Dim As String sSep = "\"
	#else
		Dim As String sSep = "/"
	#endif
	
	Dim As Long iFindSep = Instrrev(sFile , sSep)
	
	If iFindSep Then
		
		Dim As String sPath = Mid(sFile , 1 , iFindSep)
		
		Dim As String sName = Mid(sFile , iFindSep+1)
		
		IupSetStrAttribute(textname , "VALUE" , Strptr(sName))
		
		IupSetStrAttribute(textname , "OLDNAME" , Strptr(sName))
		
		IupSetStrAttribute(textname , "PATH" , Strptr(sPath))	
		
	Else
		
		IupSetStrAttribute(textname , "VALUE" , Strptr(sFile))
		
		IupSetStrAttribute(textname , "OLDNAME" , Strptr(sFile))
		
	Endif
	
	If iModule Then
		
		IupSetAttribute(btnok , "MODULE" , "1")
		
	Endif
	
	IupSetAttribute(btnok , "MINSIZE" , "100x30")
	
	IupSetAttribute(btncancel , "MINSIZE" , "100x30")
	
	IupSetCallback(btnok , "ACTION" , Cast(Any Ptr, @project_btn_ok_rename_callback()))
	
	IupSetCallback(btncancel , "ACTION" , Cast(Any Ptr, @project_btn_cancel_rename_callback()))
	
	hboxbtn = IupHbox(iupfill() , btnok , iupfill(), btncancel, iupfill()  ,0)
	
	vbox = IupvBox( textname , hboxbtn , 0)
	
	IupSetAttribute(vbox , "GAP" , "10")
	
	IupSetAttribute(vbox , "NMARGIN" , "10x10")
	
	IupSetAttribute(vbox , "EXPANDCHILDREN" , "YES")
	
	dlg = IupDialog(vbox)
	
	IupSetCallback(dlg, "CLOSE_CB", Cast(Any Ptr , @project_dlgoption_close_callback))
	
	IupSetAttribute(dlg, "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"prjrename"))
	
	IupSetAttribute(dlg, "DIALOGFRAME", "Yes")
	
	IupShow(dlg)	
	
	Return dlg	
	
End Function

Sub prj_create_or_edit_proc(ih As Ihandle Ptr)
	
	Dim As Ihandle Ptr dlg = IupGetDialog(ih)
	
	Dim As Ihandle Ptr combo = IupGetDialogChild(dlg, "comboprj")
	
	Dim As String sPath = *IupGetAttribute(IupGetDialogChild(dlg, "txtprjpath") , "VALUE")
	
	Dim As String sNameForRecent
	
	Dim As String sOldName = *IupGetAttribute(IupGetDialogChild(dlg, "txtprjname") , "OLDNAME")
	
	#ifdef __fb_win32__
		
		sPath = enc_encode_path_proc(sPath, 0)
		
		Dim As String sSep = "\"
		
	#else
		
		Dim As String sSep = "/"
		
	#endif
	
	If Len(sPath) = 0 Then
		
		IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitlewarning"),_
		*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgpatherror"))
		
		Exit Sub
		
	Endif
	
	Dim As String sName = *IupGetAttribute(IupGetDialogChild(dlg, "txtprjname") , "VALUE")
	
	#ifdef __fb_win32__
		
		sName = enc_encode_path_proc(sName, 0)
		
	#endif
	
	If Len(sName) = 0 Then
		
		IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitlewarning"),_
		*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgnameerror"))
		
		Exit Sub	
		
	Endif
	
	Dim As String sParam = *IupGetAttribute(IupGetDialogChild(dlg, "txtprjparam") , "VALUE")
	
	Dim As String sEnc = *IupGetAttribute(combo , *IupGetAttribute(combo , "VALUE"))
	
	If *IupGetAttribute(ih , "NEW") = "1" Then
		
		pProject.pszNameProject = Callocate(Len(sName)+1)
		
		*(pProject.pszNameProject) = sName
		
		pProject.pszPathProject = Callocate(Len(sPath & sSep & sName) +1)
		
		*(pProject.pszPathProject) = sPath & sSep & sName
		
		pProject.pszParamProject = Callocate(Len(sParam)+1)
		
		*(pProject.pszParamProject) = sParam
		
		pProject.pszEncProject = Callocate(25)
		
		*(pProject.pszEncProject) = sEnc		
		
	Else
		
		Deallocate(pProject.pszNameProject)
		
		Deallocate(pProject.pszParamProject)
		
		pProject.pszNameProject = Callocate(Len(sName)+1)
		
		pProject.pszParamProject = Callocate(Len(sParam)+1)
		
		*(pProject.pszNameProject) = sName
		
		*(pProject.pszParamProject) = sParam
		
		Dim As String sPathDir , sPathTitle
		
		Dim As Long iCurentTab = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
		
		sPathDir = *(pProject.pszPathProject) & sSep
		
		#ifdef __fb_win32__
			
			sPathTitle = sPathDir & *IupGetAttribute(TGlobalVariables->tTabsOptions(iCurentTab).multitext, "FILENAME")
			
			sPathTitle = enc_encode_path_proc(sPathTitle, 1)
			
		#else
			
			sPathTitle = sPathDir & *IupGetAttribute(TGlobalVariables->tTabsOptions(iCurentTab).multitext, "FILENAME")		
			
		#endif
		
		IupSetAttribute(TGlobalVariables->dlg, "TITLE", "IUP_FB_Editor - " & sPathTitle)
		
		For i As Long = 0 To 1000
			
			For j As Long = 1 To IupGetChildCount(TGlobalVariables->tabs) - 1
				
				If TGlobalVariables->tTabsOptions(j).multitext = pProject.tBasFiles(i).mt Orelse _
				TGlobalVariables->tTabsOptions(j).multitext = pProject.tBiFiles(i).mt Orelse _
				(i < 101 Andalso TGlobalVariables->tTabsOptions(j).multitext = pProject.tRcFiles(i).mt) Then
					
					IupSetStrAttribute(TGlobalVariables->tTabsOptions(j).multitext, "FILEPATH", Strptr(sPathDir))
					
				Endif
				
			Next
			
		Next		
		
	Endif
	
	If *IupGetAttribute(ih , "NEW") = "1" Then
		
		If fl_save_project_proc(1) = 0 Then
			
			Deallocate(pProject.pszNameProject)
			
			Deallocate(pProject.pszParamProject)
			
			Deallocate(pProject.pszPathProject)
			
			Deallocate(pProject.pszEncProject)
			
			Exit Sub
			
		Endif
		
	Endif
	
	tRecentProjectInfo->AddQueue(enc_encode_path_proc(*(pProject.pszPathProject) & sSep & *(pProject.pszNameProject) & ".prj" , 1))
	
	pProject.iProjectLoad = 1
	
	tb_fill_combobuild_proc()
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"btnprjsidewin") , "VALUE") = "ON" Then
		
		winside_addInfo_prj_inlist_proc()
		
		winside_setactiveitem_prj_proc(Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS")))
		
	Endif
	
	If *IupGetAttribute(ih , "NEW") = "1" Then
		
		fl_save_project_proc(0)
		
	Else
		
		fl_save_project_proc(0 , sOldName)
		
	Endif
	
	IupDestroy(dlg)
	
End Sub

Function prj_isDoudleName_proc(sName As String) As Long
	
	Static As String szWarning
	
	szWarning = enc_encode_path_proc(sName,1) & Chr(10) & *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgprjnamedouble")
	
	For i As Long = 0 To 1000
		
		If pProject.tBasFiles(i).pszFile Then
			
			If misc_case_utf8(*(pProject.tBasFiles(i).pszFile)) = misc_case_utf8(sName) Then
				
				IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitlewarning"),_
				Strptr(szWarning))
				
				Return 1
				
			Endif
			
		Endif
		
		If pProject.tBiFiles(i).pszFile Then
			
			If misc_case_utf8(*(pProject.tBiFiles(i).pszFile)) = misc_case_utf8(sName) Then
				
				IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitlewarning"),_
				Strptr(szWarning))
				
				Return 1
				
			Endif
			
		Endif
		
		If i < 101 Andalso pProject.tRcFiles(i).pszFile Then
			
			If misc_case_utf8(*(pProject.tRcFiles(i).pszFile)) = misc_case_utf8(sName) Then
				
				IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitlewarning"),_
				Strptr(szWarning))
				
				Return 1		
				
			Endif
			
		Endif
		
	Next	
	
End Function

Sub prj_add_file_in_project_proc(ih As Ihandle Ptr)
	
	#ifdef __fb_win32__
		Dim As String sSep = "\"
		Dim As String sSepFalse = "/"
	#else
		Dim As String sSep = "/"
		Dim As String sSepFalse = "\"
	#endif
	
	Dim As Ihandle Ptr dlg = IupGetDialog(ih)
	
	Dim As String sName = Trim(*IupGetAttribute(IupGetDialogChild(dlg, "txtprjname") , "VALUE"), Any " " & Chr(9) & sSep & sSepFalse)
	
	sName = misc_replace_string_proc(sName , sSepFalse , sSep , ,1)
	
	While 1
		
		sName = misc_replace_string_proc(sName , sSep & sSep , sSep , ,1)
		
		If Instr(sName , sSep & sSep) = 0 Then
			
			Exit While
			
		Endif
		
	Wend
	
	#ifdef __fb_win32__
		
		sName = enc_encode_path_proc(sName , 0)
		
	#endif
	
	If Len(sName) = 0 Then
		
		IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitlewarning"),_
		*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgnameerror"))
		
		Exit Sub
		
	Endif
	
	If *IupGetAttribute(ih , "MODULE") = "1" Then
		
		If Lcase(Right(sName , 4)) <> ".bas" Then
			
			sName &= ".bas"
			
		Endif
		
		If prj_isDoudleName_proc(sName) Then
			
			Exit Sub
			
		Endif
		
		fl_new_file_project_proc(sName , 0)
		
	Else
		
		If Instr(sName, ".") = 0 Then
			
			sName &= ".bi"
			
		Endif
		
		If prj_isDoudleName_proc(sName) Then
			
			Exit Sub
			
		Endif
		
		If Lcase(Right(sName , 3)) = ".rc" Then
			
			fl_new_file_project_proc(sName , 2)
			
		Else
			
			fl_new_file_project_proc(sName , 1)
			
		Endif
		
	Endif
	
	fl_save_project_proc(0)
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"btnprjsidewin") , "VALUE") = "ON" Then
		
		winside_addInfo_prj_inlist_proc()
		
		winside_setactiveitem_prj_proc(Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS")))
		
	Endif
	
	IupDestroy(dlg)
	
End Sub

Redim Shared As String sDimPrjFilesAdded(0)

Function prj_get_filenames_proc(sFiles As String) As Long
	
	#ifdef __fb_win32__	
	#else
		
		Dim As String*10000 szPath2
		
		For i As Long = 0 To Len(sFiles)-1
			
			If sFiles[i] = &h25 Then
				
				Var szSimvol = "&h" & Chr(sFiles[i+1], sFiles[i+2])
				
				Var iSimvol = Val(szSimvol)
				
				szPath2 &= Chr(iSimvol)
				
				i+=2
			Else
				
				szPath2 &= Chr(sFiles[i])
				
			Endif
			
		Next
		
		sFiles = szPath2
		
	#endif
	
	If Right(sFiles,1) = "|" Then
		
		Dim As Long iPosSpl = Instr (sFiles,"|")
		
		Dim As Zstring*1000 sztPath , sztName
		
		#ifdef __fb_win32__
			
			sztPath = Mid(sFiles,1,iPosSpl-1) & "\"
			
		#else
			
			sztPath = Mid(sFiles,1,iPosSpl-1) & "/"
			
		#endif
		
		sDimPrjFilesAdded(1001) = sztPath
		
		Dim As Long iIndex
		
		While 1
			
			Dim As Long iPosEndSpl = Instr (iPosSpl+1,sFiles,"|")
			
			sztName = Mid(sFiles,iPosSpl+1,iPosEndSpl-(iPosSpl+1))
			
			iPosSpl = iPosEndSpl
			
			Dim As String sTempCheck = sztPath & sztName
			
			If fl_is_file_proc(Strptr(sTempCheck)) = 0 Then
				
				Return 0
				
			Endif
			
			sDimPrjFilesAdded(iIndex) = sztName
			
			iIndex +=1
			
			If iPosEndSpl = Len(sFiles) Then Exit While
			
		Wend
		
		Return iIndex
		
	Else
		
		#ifdef __fb_win32__
			
			Dim As Long iPosSpl = Instrrev (sFiles,"\")
			
		#else
			
			Dim As Long iPosSpl = Instrrev (sFiles,"/")
			
		#endif
		
		If fl_is_file_proc(Strptr(sFiles)) = 0 Then
			
			Return 0
			
		Endif
		
		Dim As Zstring*1000 sztPath, sztName
		
		If iPosSpl = 0 Then
			
			sztPath = ""
			
		Else
			
			sztPath = Mid(sFiles,1,iPosSpl)
			
		Endif
		
		sztName = Mid(sFiles,iPosSpl+1,Len(sFiles)-iPosSpl)
		
		sDimPrjFilesAdded(1001) = sztPath
		
		sDimPrjFilesAdded(0) = sztName
		
		Return 1
		
	Endif
	
End Function

Sub prj_add_EX_file_in_project_proc(iModule As Long)
	
	Dim As String sFiles = *fdlg_open_dialog_files_proc()
	
	If Len(sFiles) = 0 Then Exit Sub
	
	Redim As String sDimPrjFilesAdded(1001)
	
	Dim As Long iCountFiles = prj_get_filenames_proc(sFiles)
	
	If iCountFiles Then
		
		#ifdef __fb_win32__
			
			Dim As String sSep = "\"
			
		#else
			
			Dim As String sSep = "/"
			
		#endif
		
		Dim As String sPathDir = *(pProject.pszPathProject) & sSep & "tempdir"
		
		Mkdir(sPathDir)
		
		For i As Long = 0 To iCountFiles-1
			
			If prj_isDoudleName_proc(sDimPrjFilesAdded(i)) Then
				
				Exit Sub
				
			Endif
			
			If enc_check_encoding_project_proc(sDimPrjFilesAdded(1001) & sDimPrjFilesAdded(i) , sDimPrjFilesAdded(i)) = 0 Then
				
				fl_delete_folder_proc(sPathDir)
				
				Exit Sub
				
			Endif
			
		Next
		
		For i As Long = 0 To iCountFiles-1
			
			Filecopy(sPathDir & sSep & sDimPrjFilesAdded(i) , *(pProject.pszPathProject) & sSep & sDimPrjFilesAdded(i))
			
			If iModule Then
				
				fl_new_file_project_proc( sDimPrjFilesAdded(i) , 0 , 1)
				
			Else
				
				If Lcase(Right(sDimPrjFilesAdded(i) , 3)) = ".rc" Then
					
					fl_new_file_project_proc(sDimPrjFilesAdded(i) , 2 , 1)
					
				Else
					
					fl_new_file_project_proc(sDimPrjFilesAdded(i) , 1 , 1)
					
				Endif				
				
			Endif
			
		Next
		
		fl_save_project_proc(0)
		
		If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"btnprjsidewin") , "VALUE") = "ON" Then
			
			winside_addInfo_prj_inlist_proc()
			
			winside_setactiveitem_prj_proc(Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS")))
			
		Endif
		
		fl_delete_folder_proc(sPathDir)
		
	Endif
	
End Sub

Sub prj_free_mem_proc()
	
	If pProject.pszEncProject Then
		
		Deallocate(pProject.pszEncProject)
		
		pProject.pszEncProject = 0
		
	Endif
	
	If pProject.pszNameProject Then
		
		Deallocate(pProject.pszNameProject)
		
		pProject.pszNameProject = 0
		
	Endif
	
	If pProject.pszParamProject Then
		
		Deallocate(pProject.pszParamProject)
		
		pProject.pszParamProject = 0
		
	Endif
	
	If pProject.pszPathProject Then
		
		Deallocate(pProject.pszPathProject)
		
		pProject.pszPathProject = 0
		
	Endif
	
	pProject.iCurentMainFile = 0
	
	pProject.iProjectLoad = 0
	
	For i As Long = 0 To 1000
		
		If pProject.tBasFiles(i).pszFile Then
			
			Deallocate(pProject.tBasFiles(i).pszFile)
			
			pProject.tBasFiles(i).pszFile = 0
			
			pProject.tBasFiles(i).mt = 0
			
		Endif
		
		If pProject.tBiFiles(i).pszFile Then
			
			Deallocate(pProject.tBiFiles(i).pszFile)
			
			pProject.tBiFiles(i).pszFile = 0
			
			pProject.tBiFiles(i).mt = 0
			
		Endif
		
		If i < 101 Andalso pProject.tRcFiles(i).pszFile Then
			
			Deallocate(pProject.tRcFiles(i).pszFile)
			
			pProject.tRcFiles(i).pszFile = 0
			
			pProject.tRcFiles(i).mt = 0
			
		Endif
		
	Next
	
End Sub

Sub prj_close_proc()
	
	Dim As Long  ic = IupGetChildCount(TGlobalVariables->tabs) , iChanges
	
	If ic > 1 Then
		
		For i As Long = 0 To 1000
			
			If pProject.tBasFiles(i).mt Andalso *IupGetAttribute(pProject.tBasFiles(i).mt, "ISCHANGES") = "YES" Then
				
				iChanges = 1
				
				Exit For
				
			Endif
			
			If pProject.tBiFiles(i).mt Andalso *IupGetAttribute(pProject.tBiFiles(i).mt, "ISCHANGES") = "YES" Then
				
				iChanges = 1
				
				Exit For
				
			Endif
			
			If i < 101 Andalso pProject.tRcFiles(i).mt Andalso *IupGetAttribute(pProject.tRcFiles(i).mt, "ISCHANGES") = "YES" Then
				
				iChanges = 1
				
				Exit For
				
			Endif
			
		Next	
		
		If iChanges Then
			
			Select Case IupAlarm(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitlewarning") ,_
			*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgprjnotsave") ,_
			"YES" , "NO" , "CANCEL")
					
				Case 1
					
					For j As Long = 1 To ic-1
						
						If *IupGetAttribute(TGlobalVariables->tTabsOptions(j).multitext, "ISCHANGES") = "YES" Then
							
							For i As Long = 0 To 1000
								
								If pProject.tBasFiles(i).mt Andalso pProject.tBasFiles(i).mt = TGlobalVariables->tTabsOptions(j).multitext Then
									
									If fl_save_proc(j , 1) Then
										
										Exit For
										
									Else
										
										IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS",Str(j))
										
										IupSetAttribute(TGlobalVariables->hTimer, "RUN", "YES")
										
										IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitlewarning"),_
										*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgprjerrsave"))
										
										Exit Sub
										
									Endif
									
								Endif
								
								If pProject.tBiFiles(i).mt Andalso pProject.tBiFiles(i).mt = TGlobalVariables->tTabsOptions(j).multitext Then
									
									If fl_save_proc(j , 1) Then
										
										Exit For
										
									Else
										
										IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS",Str(j))
										
										IupSetAttribute(TGlobalVariables->hTimer, "RUN", "YES")
										
										IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitlewarning"),_
										*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgprjerrsave"))
										
										Exit Sub
										
									Endif
									
								Endif
								
								If i < 101 Andalso pProject.tRcFiles(i).mt Andalso pProject.tRcFiles(i).mt = TGlobalVariables->tTabsOptions(j).multitext Then
									
									If fl_save_proc(j , 1) Then
										
										Exit For
										
									Else
										
										IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS",Str(j))
										
										IupSetAttribute(TGlobalVariables->hTimer, "RUN", "YES")
										
										IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitlewarning"),_
										*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgprjerrsave"))
										
										Exit Sub
										
									Endif
									
								Endif
								
							Next							
							
						Endif
						
					Next
					
				Case 0 , 3
					
					Exit Sub
					
			End Select
			
		Endif
		
		IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS",Str(IupGetChildCount(TGlobalVariables->tabs) -1))
		
		For j As Long = ic-1 To 1 Step -1
			
			For i As Long = 0 To 1000
				
				If pProject.tBasFiles(i).mt Andalso pProject.tBasFiles(i).mt = TGlobalVariables->tTabsOptions(j).multitext Then
					
					IupSetAttribute(TGlobalVariables->tTabsOptions(j).multitext, "ISCHANGES" , "NO")
					
					tbs_item_close_proc(j , 1)
					
					Exit For
					
				Endif
				
				If pProject.tBiFiles(i).mt Andalso pProject.tBiFiles(i).mt = TGlobalVariables->tTabsOptions(j).multitext Then
					
					IupSetAttribute(TGlobalVariables->tTabsOptions(j).multitext, "ISCHANGES" , "NO")
					
					tbs_item_close_proc(j , 1)
					
					Exit For
					
				Endif
				
				If i < 101 Andalso pProject.tRcFiles(i).mt = TGlobalVariables->tTabsOptions(j).multitext Then
					
					IupSetAttribute(TGlobalVariables->tTabsOptions(j).multitext, "ISCHANGES" , "NO")
					
					tbs_item_close_proc(j , 1)
					
					Exit For
					
				Endif
				
			Next							
			
		Next		
		
	Endif
	
	prj_free_mem_proc()
	
	tb_fill_combobuild_proc()
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"btnprjsidewin") , "VALUE") = "ON" Then
		
		winside_addInfo_prj_inlist_proc()
		
	Endif
	
	If IupGetChildCount(TGlobalVariables->tabs) > 1 Then
		
		IupSetAttribute(TGlobalVariables->hTimer, "RUN", "YES")
		
	Endif
	
End Sub

Function prj_parsedata_project_proc(pszData As Zstring Ptr , iStartFind As Long , Byref pszDest As Zstring Ptr) As Long
	
	Dim As Long iFindEnd
	
	Dim As String sTemp
	
	iFindEnd = Instr(iStartFind , *pszData , Chr(10))
	
	If iFindEnd Then
		
		sTemp = Trim(Mid(*pszData , iStartFind , iFindEnd - iStartFind) , Chr(13))
		
		If Len(sTemp) Then
			
			pszDest = Callocate(Len(sTemp)+1)
			
			*pszDest = sTemp
			
		Endif
		
		Return iFindEnd + 1
		
	Else
		
		IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitlewarning"),_
		*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dljprjerrdata"))
		
	Endif	
	
End Function

Function prj_parsedata2_project_proc(pszData As Zstring Ptr , iFindStart As Long , pszDest() As TPROJECTCHILD) As Long
	
	Dim As Zstring Ptr pszFiles
	
	Dim As Long iEndStart
	
	iEndStart = prj_parsedata_project_proc(*pszData , iFindStart , pszFiles)
	
	If iEndStart = 0 Then
		
		prj_free_mem_proc()
		
		Return 0
		
	Endif
	
	If pszFiles Andalso Len(*pszFiles) Then
		
		Dim As Long iStartPos = 1 , iEndPos
		
		For i As Long = 0 To 1000
			
			iEndPos = Instr(iStartPos , *pszFiles , "|")
			
			If iEndPos Then
				
				Dim As String sTemp = Mid(*pszFiles , iStartPos , iEndPos - iStartPos)
				
				If Len(sTemp) Then
					
					pszDest(i).pszFile = Callocate(Len(sTemp)+1)
					
					*(pszDest(i).pszFile) = sTemp
					
				Endif
				
				iStartPos = iEndPos+1
				
			Else
				
				Exit For
				
			Endif
			
		Next
		
		Deallocate(pszFiles)
		
	Endif
	
	Return iEndStart
	
End Function

Function prj_open_project_proc(sFileInput As String) As Long
	
	Dim As String sFileNameProject  , sSep
	
	#ifdef __fb_win32__
		
		sSep = "\"
		
	#else
		
		sSep = "/"
		
	#endif
	
	Dim As Zstring Ptr pszData , pszMaskBas , pszMaskBi , pszMaskRc
	
	Dim As Long iSizeFile , iFindStart = 1
	
	If Len(sFileInput) = 0 Then
		
		sFileNameProject = fdlg_dlg_open_proc(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuprojectopen") , _
		"PRJ files|*.prj*|" , TGlobalVariables->dlg)
		
	Else
		
		If Lcase(Right(sFileInput , 4)) = ".prj" Then
			
			sFileNameProject = sFileInput
			
		Endif
		
	Endif
	
	If Len(sFileNameProject) Then
		
		pszData = fl_read_file_proc(Strptr(sFileNameProject) , iSizeFile)
		
		If pszData Then
			
			Dim As Long iInstr = Instrrev(sFileNameProject , sSep)
			
			If iInstr > 1 Then
				
				Dim As String sPath = Left(sFileNameProject , iInstr-1)
				
				pProject.pszPathProject = Callocate(Len(sPath)+1)
				
				*(pProject.pszPathProject) = sPath
				
			Endif
			
			iFindStart = prj_parsedata_project_proc(*pszData , iFindStart , pProject.pszNameProject)
			
			If iFindStart = 0 Then
				
				Return 0
				
			Endif
			
			iFindStart = prj_parsedata_project_proc(*pszData , iFindStart , pProject.pszParamProject)
			
			If iFindStart = 0 Then
				
				prj_free_mem_proc()
				
				Return 0
				
			Endif
			
			iFindStart = prj_parsedata_project_proc(*pszData , iFindStart , pProject.pszEncProject)
			
			If iFindStart = 0 Then
				
				prj_free_mem_proc()
				
				Return 0
				
			Endif
			
			iFindStart = prj_parsedata2_project_proc(*pszData , iFindStart , pProject.tBasFiles())
			
			If iFindStart = 0 Then
				
				prj_free_mem_proc()
				
				Return 0
				
			Endif
			
			iFindStart = prj_parsedata_project_proc(*pszData , iFindStart , pszMaskBas)
			
			If iFindStart = 0 Then
				
				prj_free_mem_proc()
				
				Return 0
				
			Endif
			
			iFindStart = prj_parsedata2_project_proc(*pszData , iFindStart , pProject.tBiFiles())
			
			If iFindStart = 0 Then
				
				prj_free_mem_proc()
				
				Return 0
				
			Endif
			
			iFindStart = prj_parsedata_project_proc(*pszData , iFindStart , pszMaskBi)
			
			If iFindStart = 0 Then
				
				If pszMaskBas Then Deallocate(pszMaskBas)
				
				prj_free_mem_proc()
				
				Return 0
				
			Endif
			
			iFindStart = prj_parsedata2_project_proc(*pszData , iFindStart , pProject.tRcFiles())
			
			If iFindStart = 0 Then
				
				If pszMaskBas Then Deallocate(pszMaskBas)
				
				If pszMaskBi Then Deallocate(pszMaskBi)
				
				prj_free_mem_proc()
				
				Return 0
				
			Endif
			
			iFindStart = prj_parsedata_project_proc(*pszData , iFindStart , pszMaskRc)
			
			If iFindStart = 0 Then
				
				If pszMaskBas Then Deallocate(pszMaskBas)
				
				If pszMaskBi Then Deallocate(pszMaskBi)
				
				prj_free_mem_proc()
				
				Return 0
				
			Endif
			
			pProject.iCurentMainFile = Val(Mid(*pszData , iFindStart))
			
			pProject.iProjectLoad = 1
			
			For i As Long = 0 To 1000
				
				If pProject.tBasFiles(i).pszFile Then
					
					If (*pszMaskBas)[i] = &h31 Then '"1"
						
						Dim As String sPath = *(pProject.pszPathProject) & sSep & *(pProject.tBasFiles(i).pszFile)
						
						fl_open_file_project_proc(Strptr(sPath) , 0 , i )
						
					Endif
					
				Else
					
					Exit For
					
				Endif
				
			Next
			
			For i As Long = 0 To 1000
				
				If pProject.tBiFiles(i).pszFile Then
					
					If (*pszMaskBi)[i] = &h31 Then '"1"
						
						Dim As String sPath = *(pProject.pszPathProject) & sSep & *(pProject.tBiFiles(i).pszFile)
						
						fl_open_file_project_proc(Strptr(sPath) , 1 , i)
						
					Endif
					
				Else
					
					Exit For
					
				Endif
				
			Next
			
			For i As Long = 0 To 100
				
				If pProject.tRcFiles(i).pszFile Then
					
					If (*pszMaskRc)[i] = &h31 Then '"1"
						
						Dim As String sPath = *(pProject.pszPathProject) & sSep & *(pProject.tRcFiles(i).pszFile)
						
						fl_open_file_project_proc(Strptr(sPath) , 2 , i)
						
					Endif
					
				Else
					
					Exit For
					
				Endif
				
			Next
			
			Deallocate(pszData)
			
			If pszMaskBas Then Deallocate(pszMaskBas)
			
			If pszMaskBi Then Deallocate(pszMaskBi)
			
			If pszMaskRc Then Deallocate(pszMaskRc)
			
			tRecentProjectInfo->AddQueue(enc_encode_path_proc(*(pProject.pszPathProject) & sSep & *(pProject.pszNameProject) & ".prj" , 1))
			
			If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"btnprjsidewin") , "VALUE") = "ON" Then
				
				winside_addInfo_prj_inlist_proc()
				
			Endif
			
			Return 1
			
		Endif
		
	Endif
	
End Function

Sub prj_winside_dblclick_fileopen(iItem As Integer , psText As Zstring Ptr)
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"btnprjsidewin") , "VALUE") = "ON" Then
		
		If pProject.iProjectLoad Then
			
			Dim As String sItem
			
			Dim As String sSep
			
			Dim As String sText = *psText
			
			#ifdef __fb_win32__
				
				sSep = "\"
				
				sText = enc_encode_path_proc(sText , 0)
				
			#else
				
				sSep = "/"
				
			#endif
			
			Select Case Right(sText , 2)
					
				Case "M-"
					
					If Left(sText , 1) = "(" Then
						
						sItem = Mid(sText , 2 , Len(sText)-5)
						
					Else
						
						sItem = Left(sText , Len(sText)-3)
						
					Endif
					
					For i As Long = 0 To 1000
						
						If pProject.tBasFiles(i).pszFile Andalso *(pProject.tBasFiles(i).pszFile) = sItem Then
							
							Dim As String sPath = *(pProject.pszPathProject) & sSep & *(pProject.tBasFiles(i).pszFile)
							
							fl_open_file_project_proc(Strptr(sPath) , 0 , i )
							
							winside_addInfo_prj_inlist_proc()
							
							fl_save_project_proc(0)
							
							Exit For
							
						Endif
						
					Next
					
				Case " -"
					
					sItem = Left(sText , Len(sText)-2)
					
					For i As Long = 0 To 1000
						
						If pProject.tBiFiles(i).pszFile Andalso *(pProject.tBiFiles(i).pszFile) = sItem Then
							
							Dim As String sPath = *(pProject.pszPathProject) & sSep & *(pProject.tBiFiles(i).pszFile)
							
							fl_open_file_project_proc(Strptr(sPath) , 1 , i )
							
							winside_addInfo_prj_inlist_proc()
							
							fl_save_project_proc(0)
							
							Exit For
							
						Endif
						
						If i < 101 Andalso pProject.tRcFiles(i).pszFile Andalso *(pProject.tRcFiles(i).pszFile) = sItem Then
							
							Dim As String sPath = *(pProject.pszPathProject) & sSep & *(pProject.tRcFiles(i).pszFile)
							
							fl_open_file_project_proc(Strptr(sPath) , 2 , i )
							
							winside_addInfo_prj_inlist_proc()
							
							fl_save_project_proc(0)
							
							Exit For
							
						Endif
						
					Next					
					
			End Select
			
		Else
			
			If tRecentProjectInfo Andalso tRecentProjectInfo->iIndex Then
				
				Dim As Long iPos = Val(*IupGetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"listboxsidewin"), "VALUE"))
				
				If iPos > 3 Andalso iPos < 14 Then
					
					iPos -= 3
					
					If iPos > tRecentProjectInfo->iIndex Then Exit Sub					
					
					Dim As TQueueList Ptr pTemp = tRecentProjectInfo->pF
					
					For i As Long = 1 To tRecentProjectInfo->iIndex
						
						If pTemp Andalso pTemp->psPath Then
							
							If iPos = i Then
								
								Dim As String sFile = tRecentProjectInfo->GetPath(pTemp->psPath)
								
								If Fileexists(sFile) = -1 Then
									
									tRecentProjectInfo->move(iPos)
									
									winside_add_info_recent_prj_proc(IupGetDialogChild(TGlobalVariables->dlg,"listboxsidewin"))
									
									prj_open_project_proc(sFile)
									
								Endif
								
								Exit For
								
							Endif
							
							pTemp = pTemp->p
							
						Endif
						
					Next
					
				Endif
				
			Endif			
			
		Endif
		
	Endif	
	
End Sub

Sub prj_set_main_curent()
	
	If pProject.iProjectLoad Then
		
		Dim As Long iFlagNotInfoPrjFromWinside
		
		If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"btnprjsidewin") , "VALUE") = "ON" Then
			
			Dim As String sItem = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"listboxsidewin"), "VALUE")
			
			If Len(sItem) Then
				
				Dim As String sText = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"listboxsidewin"), sItem)
				
				If Len(sText) Then
					
					#ifdef __fb_win32__
						
						sText = enc_encode_path_proc(sText, 0)
						
					#endif
					
					Select Case Right(sText , 2)
							
						Case "M+" , "M-"
							
							If Left(sText , 1) = "(" Then
								
								sItem = Mid(sText , 2 , Len(sText)-5)
								
							Else
								
								sItem = Left(sText , Len(sText)-3)
								
							Endif
							
							For i As Long = 0 To 1000
								
								If pProject.tBasFiles(i).pszFile Andalso *(pProject.tBasFiles(i).pszFile) = sItem Then
									
									pProject.iCurentMainFile = i
									
									winside_addInfo_prj_inlist_proc()
									
									fl_save_project_proc(0)
									
									Exit For
									
								Endif
								
							Next
							
					End Select
					
				Endif
				
			Else
				
				iFlagNotInfoPrjFromWinside = 1
				
			Endif
			
		Else
			
			iFlagNotInfoPrjFromWinside = 1
			
		Endif
		
		If iFlagNotInfoPrjFromWinside Then
			
			Dim As Integer iCount , iCurent
			
			iCount = IupGetChildCount(TGlobalVariables->tabs)
			
			If iCount < 2 Then Exit Sub
			
			iCurent = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
			
			For i As Long = 0 To 1000
				
				If pProject.tBasFiles(i).mt Andalso TGlobalVariables->tTabsOptions(iCurent).multitext = pProject.tBasFiles(i).mt Then
					
					pProject.iCurentMainFile = i
					
					If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"btnprjsidewin") , "VALUE") = "ON" Then
						
						winside_addInfo_prj_inlist_proc()
						
					Endif
					
					fl_save_project_proc(0)
					
					Exit For
					
				Endif
				
			Next			
			
		Endif
		
	Endif
	
End Sub

Function prj_get_file_from_winside_or_tabs(Byref iModule As Long , iItem As Long = 0) As String
	
	If pProject.iProjectLoad Then
		
		Dim As Long iFlagNotInfoPrjFromWinside
		
		If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"btnprjsidewin") , "VALUE") = "ON" Then
			
			Dim As String sItem
			
			If iItem Then
				
				sItem = Str(iItem)
				
			Else	
				
				sItem = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"listboxsidewin"), "VALUE")
				
			Endif
			
			If Len(sItem) Then
				
				Dim As String sText = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"listboxsidewin"), sItem)
				
				If Len(sText) Then
					
					Select Case Right(sText , 2)
							
						Case "M+" , "M-"
							
							If Left(sText , 1) = "(" Then
								
								sItem = Mid(sText , 2 , Len(sText)-5)
								
							Else
								
								sItem = Left(sText , Len(sText)-3)
								
							Endif
							
							iModule = 1
							
							Return sItem
							
						Case Else
							
							sItem = Left(sText , Len(sText)-2)
							
							Return sItem
							
					End Select
					
				Endif
				
			Else
				
				iFlagNotInfoPrjFromWinside = 1
				
			Endif
			
		Else
			
			iFlagNotInfoPrjFromWinside = 1
			
		Endif
		
		If iFlagNotInfoPrjFromWinside Then
			
			Dim As Integer iCount , iCurent
			
			iCount = IupGetChildCount(TGlobalVariables->tabs)
			
			If iCount < 2 Then Return ""
			
			iCurent = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
			
			For i As Long = 0 To 1000
				
				If pProject.tBasFiles(i).mt Andalso TGlobalVariables->tTabsOptions(iCurent).multitext = pProject.tBasFiles(i).mt Then
					
					iModule = 1
					
					Return *IupGetAttribute(pProject.tBasFiles(i).mt, "FILENAMETAB")
					
				Endif
				
				If pProject.tBiFiles(i).mt Andalso TGlobalVariables->tTabsOptions(iCurent).multitext = pProject.tBiFiles(i).mt Then
					
					Return *IupGetAttribute(pProject.tBiFiles(i).mt, "FILENAMETAB")
					
				Endif
				
				If i < 101 Andalso pProject.tRcFiles(i).mt Andalso TGlobalVariables->tTabsOptions(iCurent).multitext = pProject.tRcFiles(i).mt Then
					
					Return *IupGetAttribute(pProject.tRcFiles(i).mt, "FILENAMETAB")
					
				Endif					
				
			Next			
			
		Endif
		
	Endif	
	
End Function

Sub prj_rename_file(ih As iHandle Ptr)
	
	Dim As iHandle Ptr dlg , text
	
	dlg = IupGetDialog(ih)
	
	text = IupGetDialogChild(dlg,"txtprjname")
	
	Dim As String sModule = *IupGetAttribute(ih , "MODULE")
	
	Dim As String sOldName = *IupGetAttribute(text , "OLDNAME")
	
	Dim As String sNewName = *IupGetAttribute(text , "VALUE")
	
	Dim As String sPathSubFolder
	
	If IupGetAttribute(text , "PATH") Then
		
		sPathSubFolder = *IupGetAttribute(text , "PATH")
		
	Endif
	
	Dim As String sNameForTab = sPathSubFolder & sNewName
	
	#ifdef __fb_win32__
		
		Dim As String sSep = "\"
		
		sOldName = enc_encode_path_proc(sOldName , 0)
		
		sNewName = enc_encode_path_proc(sNewName , 0)
		
		If Len(sPathSubFolder) Then
			
			sPathSubFolder = enc_encode_path_proc(sPathSubFolder , 0)
			
		Endif
		
		sNameForTab = enc_encode_path_proc(sPathSubFolder & sNewName , 1)
		
	#else
		
		Dim As String sSep = "/"
		
	#endif
	
	If sOldName = sNewName Then 
		
		IupDestroy(dlg)
		
		Exit Sub
		
	Endif
	
	If Instr(sNewName , "\") Orelse _
	Instr(sNewName , "/")  Orelse _
	Instr(sNewName , ":")  Orelse _
	Instr(sNewName , ";")  Orelse _
	Instr(sNewName , "*")  Orelse _
	Instr(sNewName , "?")  Orelse _
	Instr(sNewName , """")  Orelse _
	Instr(sNewName , "<")  Orelse _
	Instr(sNewName , ">")  Orelse _
	Instr(sNewName , "|")  Orelse _
	Instr(sNewName , "+")  Orelse _
	Instr(sNewName , "%")  Orelse _
	Instr(sNewName , "!")  Orelse _
	Instr(sNewName , "@")  Orelse _
	Instr(sNewName , "&")  Orelse _
	Instr(sNewName , "$")  Orelse _
	Instr(sNewName , "#")  Orelse _
	Instr(sNewName , "=")  Orelse _
	Instr(sNewName , "`")  Orelse _
	Instr(sNewName , "'")  Orelse _
	Instr(sNewName , "^")  Orelse _
	Instr(sNewName , ",")  Then
		
		IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitlewarning"),_
		*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgnamenotcorrect"))
		
		IupSetFocus(text)
		
		Exit Sub
		
	Endif
	
	If Len(sPathSubFolder) Then
		
		sNewName = sPathSubFolder & sNewName
		
		sOldName = sPathSubFolder & sOldName
		
	Endif
	
	If prj_isDoudleName_proc(sNewName) Then
		
		IupSetFocus(text)
		
		Exit Sub
		
	Endif
	
	Dim As Long iChanges
	
	For i As Long = 0 To 1000
		
		If sModule = "1" Then
			
			If pProject.tBasFiles(i).pszFile Andalso *(pProject.tBasFiles(i).pszFile) = sOldName Then
				
				If Lcase(Right(sNewName , 4)) <> ".bas" Then
					
					sNewName &= ".bas"
					
				Endif
				
				For j As Long = 1 To IupGetChildCount(TGlobalVariables->tabs) - 1
					
					If TGlobalVariables->tTabsOptions(j).multitext = pProject.tBasFiles(i).mt Then
						
						IupSetStrAttribute(pProject.tBasFiles(i).mt, "FILENAME", sNewName)
						
						IupSetStrAttribute(pProject.tBasFiles(i).mt, "FILENAMETAB", sNameForTab )
						
						IupSetAttributeId(TGlobalVariables->tabs, "TABTITLE", j ,IupGetAttribute(pProject.tBasFiles(i).mt, "FILENAMETAB"))
						
						Deallocate(pProject.tBasFiles(i).pszFile)
						
						pProject.tBasFiles(i).pszFile = Callocate(Len(sNewName)+1)
						
						*(pProject.tBasFiles(i).pszFile) = sNewName
						
						iChanges = 1
						
						Exit For ,For
						
					Endif
					
				Next
				
			Endif
			
		Else
			
			If pProject.tBiFiles(i).pszFile Andalso *(pProject.tBiFiles(i).pszFile) = sOldName Then
				
				For j As Long = 1 To IupGetChildCount(TGlobalVariables->tabs) - 1
					
					If TGlobalVariables->tTabsOptions(j).multitext = pProject.tBiFiles(i).mt Then
						
						IupSetStrAttribute(pProject.tBiFiles(i).mt, "FILENAME", sNewName)
						
						IupSetStrAttribute(pProject.tBiFiles(i).mt, "FILENAMETAB", sNameForTab )
						
						IupSetAttributeId(TGlobalVariables->tabs, "TABTITLE", j ,IupGetAttribute(pProject.tBiFiles(i).mt, "FILENAMETAB"))
						
						Deallocate(pProject.tBiFiles(i).pszFile)
						
						pProject.tBiFiles(i).pszFile = Callocate(Len(sNewName)+1)
						
						*(pProject.tBiFiles(i).pszFile) = sNewName
						
						iChanges = 1
						
						Exit For ,For
						
					Endif
					
				Next
				
			Endif
			
			If i < 101 Andalso pProject.tRcFiles(i).pszFile Andalso *(pProject.tRcFiles(i).pszFile) = sOldName Then
				
				For j As Long = 1 To IupGetChildCount(TGlobalVariables->tabs) - 1
					
					If TGlobalVariables->tTabsOptions(j).multitext = pProject.tRcFiles(i).mt Then
						
						IupSetStrAttribute(pProject.tRcFiles(i).mt, "FILENAME", sNewName)
						
						IupSetStrAttribute(pProject.tRcFiles(i).mt, "FILENAMETAB", sNameForTab )
						
						IupSetAttributeId(TGlobalVariables->tabs, "TABTITLE", j ,IupGetAttribute(pProject.tRcFiles(i).mt, "FILENAMETAB"))
						
						Deallocate(pProject.tRcFiles(i).pszFile)
						
						pProject.tRcFiles(i).pszFile = Callocate(Len(sNewName)+1)
						
						*(pProject.tRcFiles(i).pszFile) = sNewName
						
						iChanges = 1
						
						Exit For ,For
						
					Endif
					
				Next
				
			Endif
			
		Endif
		
	Next
	
	If iChanges Then
		
		Dim As String sPathOldTitle = *iupGetAttribute(TGlobalVariables->dlg , "TITLE")
		
		Dim As String sPathFileOld = *(pProject.pszPathProject) & sSep & sOldName
		
		Dim As String sPathFile = *(pProject.pszPathProject) & sSep & sNewName		
		
		#ifdef __fb_win32__
			
			Dim As String sPathFileForTitle = enc_encode_path_proc(sPathFile , 1)
			
			sPathOldTitle = enc_encode_path_proc(sPathOldTitle , 0)
			
		#else
			
			Dim As String sPathFileForTitle = sPathFile
			
			sPathFile = misc_replace_string_proc(sPathFile , " " , "\ " ,  , 1)
			
			sPathFileOld = misc_replace_string_proc(sPathFileOld , " " , "\ " ,  , 1)
			
		#endif
		
		fl_rename_file(sPathFileOld , sPathFile)
		
		If Instr(sPathOldTitle , sOldName) Then
			
			IupSetAttribute(TGlobalVariables->dlg, "TITLE", "IUP_FB_Editor - " & sPathFileForTitle)
			
		Endif
		
		If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"btnprjsidewin") , "VALUE") = "ON" Then
			
			winside_addInfo_prj_inlist_proc()
			
		Endif
		
		fl_save_project_proc(0)
		
		winside_setactiveitem_prj_proc(Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS")))
		
	Endif
	
	IupDestroy(dlg)
	
End Sub

Sub prj_delete_file(sFile As String)
	
	Dim As String sMessage = *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgisdelete") & " " & sFile &"?"
	
	Dim As String sCurrent = *(pProject.tBasFiles(pProject.iCurentMainFile).pszFile)
	
	#ifdef __fb_win32__
		
		sFile = enc_encode_path_proc(sFile , 0)
		
	#endif
	
	Dim As Long iFlag
	
	Select Case IupAlarm(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitlewarning") ,_
	sMessage , "YES" , "NO" , 0)
			
		Case 1
			
			For i As Long = 0 To 1000
				
				If pProject.tBasFiles(i).pszFile Andalso *(pProject.tBasFiles(i).pszFile) = sFile Then
					
					If pProject.iCurentMainFile = i Then
						
						IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitlewarning"),_
						*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgcurnotdel"))
						
						Exit Sub
						
					Endif
					
					For j As Long = 1 To IupGetChildCount(TGlobalVariables->tabs) - 1
						
						If TGlobalVariables->tTabsOptions(j).multitext = pProject.tBasFiles(i).mt Then
							
							tbs_item_close_proc(j , 1)
							
							Exit For
							
						Endif
						
					Next
					
					If i = 1000 Then
						
						Deallocate(pProject.tBasFiles(i).pszFile)
						
						pProject.tBasFiles(i).pszFile = 0
						
						pProject.tBasFiles(i).mt = 0
						
					Else
						
						For j As Long = i To 999
							
							pProject.tBasFiles(j).pszFile = pProject.tBasFiles(j+1).pszFile
							
							pProject.tBasFiles(j).mt = pProject.tBasFiles(j+1).mt
							
						Next
						
					Endif
					
					iFlag = 1
					
				Endif
				
				If pProject.tBiFiles(i).pszFile Andalso *(pProject.tBiFiles(i).pszFile) = sFile Then
					
					For j As Long = 1 To IupGetChildCount(TGlobalVariables->tabs) - 1
						
						If TGlobalVariables->tTabsOptions(j).multitext = pProject.tBiFiles(i).mt Then
							
							tbs_item_close_proc(j , 1)
							
							Exit For
							
						Endif
						
					Next
					
					If i = 1000 Then
						
						Deallocate(pProject.tBiFiles(i).pszFile)
						
						pProject.tBiFiles(i).pszFile = 0
						
						pProject.tBiFiles(i).mt = 0
						
					Else
						
						For j As Long = i To 999
							
							pProject.tBiFiles(j).pszFile = pProject.tBiFiles(j+1).pszFile
							
							pProject.tBiFiles(j).mt = pProject.tBiFiles(j+1).mt
							
						Next
						
					Endif
					
					iFlag = 1
					
				Endif
				
				If i < 101 Andalso pProject.tRcFiles(i).pszFile Andalso *(pProject.tRcFiles(i).pszFile) = sFile Then
					
					For j As Long = 1 To IupGetChildCount(TGlobalVariables->tabs) - 1
						
						If TGlobalVariables->tTabsOptions(j).multitext = pProject.tRcFiles(i).mt Then
							
							tbs_item_close_proc(j , 1)
							
							Exit For
							
						Endif
						
					Next
					
					If i = 100 Then
						
						Deallocate(pProject.tRcFiles(i).pszFile)
						
						pProject.tRcFiles(i).pszFile = 0
						
						pProject.tRcFiles(i).mt = 0
						
					Else
						
						For j As Long = i To 99
							
							pProject.tRcFiles(j).pszFile = pProject.tRcFiles(j+1).pszFile
							
							pProject.tRcFiles(j).mt = pProject.tRcFiles(j+1).mt
							
						Next
						
					Endif
					
					iFlag = 1
					
				Endif
				
			Next
			
			If iFlag Then
				
				For i As Long = 0 To 1000
					
					If *(pProject.tBasFiles(i).pszFile) = sCurrent Then
						
						pProject.iCurentMainFile = i
						
					Endif
					
				Next
				
				If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"btnprjsidewin") , "VALUE") = "ON" Then
					
					winside_addInfo_prj_inlist_proc()
					
				Endif
				
				fl_save_project_proc(0)
				
				#ifdef __fb_win32__
					
					Dim As String sPathFile = *(pProject.pszPathProject) & "\" & sFile
					
				#else
					
					Dim As String sPathFile = *(pProject.pszPathProject) & "/" & sFile
					
				#endif
				
				If Fileexists(sPathFile)  = -1 Then
					
					Kill(sPathFile)
					
				Endif
				
				winside_setactiveitem_prj_proc(Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS")))
				
				If IupGetChildCount(TGlobalVariables->tabs) > 1 Then
					
					IupSetAttribute(TGlobalVariables->hTimer, "RUN", "YES")
					
				Endif
				
			Endif
			
		Case Else
			
			Exit Sub
			
	End Select
	
End Sub