Sub sb_set_visual_params_statusbar_proc(iParam As Byte = 0) export
	
	Dim As ZString*100 szFont
	
	If iParam = 0 Then
		
		szFont = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Fonts","status")
		
   	If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "lineends") = "WIN" Then
   	   
   	   IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "EOLLBL"), "TITLE" , "EOL: WIN (CRLF)")
   	   
   	Else
   	   
   	   IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "EOLLBL"), "TITLE" , "EOL: UNIX (LF)")
   	   
   	EndIf			
		
		
	Else
		
		szFont = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions,"ftxtstatus"),"VALUE")
		
   	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "radiowin") , "VALUE") =  "ON" Then
   		
   		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "EOLLBL"), "TITLE" , "EOL: WIN (CRLF)")
   		
   	Else
   		
   		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "EOLLBL"), "TITLE" , "EOL: UNIX (LF)")
   		
   	EndIf		
		
	EndIf

	If InStr(szFont, " Bold ") Then 
	   
	   szFont = misc_replace_string_proc(szFont , " Bold " , " " )	   
	   
	EndIf
	
	If InStr(szFont, " Italic ") Then 
	   
	   szFont = misc_replace_string_proc(szFont , " Italic " , " " )	   
	   
	EndIf
	
	If InStr(szFont, " Underline ") Then 
	   
	   szFont = misc_replace_string_proc(szFont , " Underline " , " " )	   
	   
	EndIf
	
	If InStr(szFont, " Strikeout ") Then 
	   
	   szFont = misc_replace_string_proc(szFont , " Strikeout " , " " )	   
	   
	EndIf	
	
	Dim As Integer iPosSpace = InStrRev(szFont , " ")
	
	TGlobalVariables->szFontStatusSize = Mid(szFont , iPosSpace , (Len(szFont) - iPosSpace)+1)
	
	TGlobalVariables->szFontStatus = RTrim(Mid(szFont , 1 , iPosSpace) , Any " ,")	
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "LINELBL"), "FONTFACE" , TGlobalVariables->szFontStatus)
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "LINELBL"), "FONTSIZE" , TGlobalVariables->szFontStatusSize)
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "SELLBL"), "FONTFACE" , TGlobalVariables->szFontStatus)
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "SELLBL"), "FONTSIZE" , TGlobalVariables->szFontStatusSize)	
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "INSLBL"), "FONTFACE" , TGlobalVariables->szFontStatus)
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "INSLBL"), "FONTSIZE" , TGlobalVariables->szFontStatusSize)
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "EOLLBL"), "FONTFACE" , TGlobalVariables->szFontStatus)
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "EOLLBL"), "FONTSIZE" , TGlobalVariables->szFontStatusSize)
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "ENCLBL"), "FONTFACE" , TGlobalVariables->szFontStatus)
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "ENCLBL"), "FONTSIZE" , TGlobalVariables->szFontStatusSize)
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "CHANGLBL"), "FONTFACE" , TGlobalVariables->szFontStatus)
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "CHANGLBL"), "FONTSIZE" , TGlobalVariables->szFontStatusSize)	
	
	
End Sub

Function sb_Create_statusBar_proc() As IHandle Ptr export
	
	dim as Ihandle Ptr lbl_lc , lbl_sel, lbl_ins , lbl_eol , lbl_enc , lbl_chang ,_
	lbl_sep1 , lbl_sep2 , lbl_sep3 , lbl_sep4 , lbl_sep5 , hbox 
	
	lbl_lc = IupLabel("Lin 1, Col 0")

	IupSetAttribute(lbl_lc, "NAME", "LINELBL")

	IupSetAttribute(lbl_lc, "EXPAND", "HORIZONTAL")

	IupSetAttribute(lbl_lc, "PADDING", "10x5")
	
	
	lbl_sel = IupLabel("Sel:")

	IupSetAttribute(lbl_sel, "NAME", "SELLBL")

	IupSetAttribute(lbl_sel, "EXPAND", "HORIZONTAL")

	IupSetAttribute(lbl_sel, "PADDING", "10x5")
	
	
	lbl_ins = IupLabel("Ins")

	IupSetAttribute(lbl_ins, "NAME", "INSLBL")

	IupSetAttribute(lbl_ins, "EXPAND", "HORIZONTAL")

	IupSetAttribute(lbl_ins, "PADDING", "10x5")	
	
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "lineends") = "WIN" Then
	   
	   lbl_eol = IupLabel("EOL: WIN (CRLF)")
	   
	Else
	   
	   lbl_eol = IupLabel("EOL: UNIX (LF)")
	   
	EndIf
	
	IupSetAttribute(lbl_eol, "NAME", "EOLLBL")

	IupSetAttribute(lbl_eol, "EXPAND", "HORIZONTAL")

	IupSetAttribute(lbl_eol, "PADDING", "10x5")	
   
	   
	lbl_enc = IupLabel(" ")

	IupSetAttribute(lbl_enc, "NAME", "ENCLBL")

	IupSetAttribute(lbl_enc, "EXPAND", "HORIZONTAL")

	IupSetAttribute(lbl_enc, "PADDING", "10x5")
	
			
	lbl_chang = IupLabel(" ")

	IupSetAttribute(lbl_chang, "NAME", "CHANGLBL")

	IupSetAttribute(lbl_chang, "EXPAND", "HORIZONTAL")

	IupSetAttribute(lbl_chang, "PADDING", "10x5")	
	
   
   lbl_sep1 = IupLabel("")
   
   IupSetAttribute(lbl_sep1, "SEPARATOR", "VERTICAL")
   
   lbl_sep2 = IupLabel("")
   
   IupSetAttribute(lbl_sep2, "SEPARATOR", "VERTICAL")  
   
   lbl_sep3 = IupLabel("")
   
   IupSetAttribute(lbl_sep3, "SEPARATOR", "VERTICAL")
   
   lbl_sep4 = IupLabel("")
   
   IupSetAttribute(lbl_sep4, "SEPARATOR", "VERTICAL")    
   
   lbl_sep5 = IupLabel("")
   
   IupSetAttribute(lbl_sep5, "SEPARATOR", "VERTICAL")      
   
   
   hbox = IupHbox(lbl_lc , IupFill() , lbl_sep1 , IupFill() , lbl_sel ,IupFill() ,_
    lbl_sep2 , IupFill() , lbl_ins , IupFill() , lbl_sep3 , IupFill() , lbl_eol , _
    IupFill() , lbl_sep4 , IupFill() , lbl_enc , IupFill() , lbl_sep5 , IupFill() , lbl_chang , 0 )
   
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"ChildParam","statusbarvisible") = "1" Then
	
		IupSetAttribute(hbox, "FLOATING", "NO" )
	
		IupSetAttribute(hbox, "VISIBLE", "YES")
	
	Else
		
		IupSetAttribute(hbox, "FLOATING", "YES" )
	
		IupSetAttribute(hbox, "VISIBLE", "NO")		
	
	EndIf	
	
	IupSetAttribute(hbox, "MINSIZE", "x30")
	
	Return hbox
	
End Function
