Function tbs_item_close_proc (idTabs As Long , iFlagCloseProject As Long = 0 , iFlagDeInitFilePrj As Long = 0) As Integer Export
	
	Dim As Integer ic = IupGetChildCount(TGlobalVariables->tabs)
	
	If ic < 2 Then Return IUP_DEFAULT
	
	Dim As Long iBeg,iEnd,iPositionActive
	
	If idTabs = 0 Then
		
		iBeg = ic - 1
		
		iEnd = 1
		
	Else
		
		iBeg = idTabs
		
		iEnd = idTabs	
		
		If (idTabs - 1) > 0 Then		
			
			iPositionActive = idTabs - 1	
			
		Else
			
			If ic > 2 Then
				
				iPositionActive = idTabs
				
			Endif
			
		Endif
		
	Endif
	
	For i As Long = iBeg To iEnd Step -1
		
		Dim As iHandle Ptr mt = TGlobalVariables->tTabsOptions(i).multitext
		
		If *IupGetAttribute(TGlobalVariables->tTabsOptions(i).multitext, "ISCHANGES") = "YES" Then
			
			IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS",Str(i))
			
			Dim As Integer iRet = msdlg_dialog_message_yes_no_proc(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,_
			"dlgwarningtitle"),*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgissavemess"))
			
			If iRet = 1 Then
				
				If fl_save_proc(i) = 0 Then Continue For
				
			Elseif iRet = 3 Then	
				
				Return IUP_IGNORE
				
			Endif
			
		Endif
		
		'if you do not clear the text in the tab, then pango will send a warning, similar to an error in the IUP library
		IupSetAttributeId(TGlobalVariables->tabs, "TABTITLE", i ," ") 
		
		IupDestroy(IupGetChild(TGlobalVariables->tabs, i))
		
		IupRefreshChildren(TGlobalVariables->split)	
		
		For j As Long = i To ic - 1
			
			TGlobalVariables->tTabsOptions(j).multitext = TGlobalVariables->tTabsOptions(j+1).multitext	
			
		Next
		
		If iFlagDeInitFilePrj Then
			
			For i As Long = 0 To 1000
				
				If pProject.tBasFiles(i).mt = mt Then
					
					pProject.tBasFiles(i).mt = 0
					
					Exit For
					
				Elseif pProject.tBiFiles(i).mt = mt Then
					
					pProject.tBiFiles(i).mt = 0
					
					Exit For
					
				Elseif i < 101 Andalso pProject.tRcFiles(i).mt = mt Then
					
					pProject.tRcFiles(i).mt = 0
					
					Exit For
					
				Endif
				
			Next
			
			If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"btnprjsidewin") , "VALUE") = "ON" Then
				
				winside_addInfo_prj_inlist_proc()
				
				fl_save_project_proc(0)
				
			Endif
			
		Endif
		
		TGlobalVariables->tTabsOptions(ic).multitext = 0	
		
	Next
	
	If iPositionActive Then
		
		If iFlagCloseProject = 0 Then
			
			IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS",Str(iPositionActive))
			
			IupSetAttribute(TGlobalVariables->hTimer, "RUN", "YES")
			
		Endif
		
	Else
		
		IupSetAttribute(TGlobalVariables->dlg, "TITLE", "IUP_FB_Editor")
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "EOLLBL"), "TITLE" , " ")
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "ENCLBL"), "TITLE" , " ")
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "INSLBL"), "TITLE" , "Ins")
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "CHANGLBL"), "TITLE", " ")
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "SELLBL"), "TITLE" , "Sel: ")
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "LINELBL"), "TITLE", "Lin 0, Col 0")
		
	Endif
	
	tmr_update_after_changes()	
	
	Return IUP_DEFAULT
	
End Function

Function tbs_create_tabs_proc() As IHandle Ptr Export
	
	Dim As Ihandle Ptr lbl = IupLabel(0)
	
	IupSetAttribute(lbl, "EXPAND", "YES")
	
	Dim As Ihandle Ptr vBox = IupVbox(lbl, null)
	
	#ifdef __fb_win32__
		
		Dim As IHandle Ptr tabs = IupFlatTabs(vBox,null)
		
		IupSetAttribute(tabs, "FORECOLOR", "0 0 0")
		
		IupSetAttribute(tabs, "BGCOLOR", "230 230 230")
		
	#else
	
		#ifdef __fb_64bit__
			
			Dim As IHandle Ptr tabs = IupFlatTabs(vBox,null)
			
			IupSetAttribute(tabs, "FORECOLOR", "0 0 0")
			
			IupSetAttribute(tabs, "BGCOLOR", "230 230 230")
			
		#else
			
			Dim As IHandle Ptr tabs = IupTabs(vBox,null)
			
		#endif		
		
	#endif
	
	IupSetAttribute(tabs, "TABVISIBLE0", "NO")
	
	IupSetAttribute(tabs, "SHOWCLOSE", "Yes")
	
	'IupSetAttribute(tabs, "TABSFONTSIZE", "12")
	
	IupSetAttribute(tabs, "TABSFONT", *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Fonts","tabs"))
	
	IupSetAttribute(tabs, "TABSPADDING", "x2" )
	
	IupSetCallback(tabs, "TABCHANGEPOS_CB", Cast(Any Ptr,@tab_change_pos_callback))
	
	IupSetCallback(tabs, "TABCLOSE_CB", Cast(Any Ptr,@tab_close_callback))
	
	IupSetCallback(tabs, "FLAT_BUTTON_CB", Cast(Any Ptr, @tab_flat_button_callback))
	
	Return tabs
	
End Function

Sub tbs_setfont_tab_proc(iParam As Long) Export
	
	If iParam = 0 Then
		
		Dim As String szFont
		
		szFont = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Fonts","tabs")
		
		If Len(szFont) Then
			
			IupSetStrAttribute(TGlobalVariables->tabs, "TABSFONT", Strptr(szFont))
			
		Endif
		
	Else
		
		Dim As Zstring Ptr pSz = IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions,"ftxttabs"),"VALUE")
		
		If pSz Andalso Len(*pSz) Then
			
			IupSetStrAttribute(TGlobalVariables->tabs, "TABSFONT", pSz)
			
		Endif
		
	Endif
	
End Sub

Sub tbs_next_tab_proc() Export
	
	Dim As Integer iCount , iCurent
	
	iCount = IupGetChildCount(TGlobalVariables->tabs)
	
	If iCount < 2 Then Exit Sub
	
	iCurent = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	If iCurent + 1 >= iCount Then Exit Sub
	
	IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS" , Str(iCurent + 1))
	
	tmr_update_after_changes()
	
End Sub


Sub tbs_prev_tab_proc() Export
	
	Dim As Integer iCount , iCurent
	
	iCount = IupGetChildCount(TGlobalVariables->tabs)
	
	If iCount < 2 Then Exit Sub
	
	iCurent = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	If (iCurent - 1) < 1 Then Exit Sub
	
	IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS" , Str(iCurent - 1))
	
	tmr_update_after_changes()
	
End Sub

function tbs_set_activetab_from_winside(ih As iHandle Ptr) as long
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"btnprjsidewin") , "VALUE") = "ON" Then
		
		If pProject.iProjectLoad Then
			
			Dim As Long iItem = Val(*IupGetAttribute(ih, "VALUE"))
			
			Dim As String sItem , sText
			
			sText = *IupGetAttribute(ih, Str(iItem))
			
			#ifdef __fb_win32__
				
				sText = enc_encode_path_proc(sText , 0)
				
			#endif
			
			Select Case Right(sText , 2)
					
				Case "M+"
					
					If Left(sText , 1) = "(" Then
						
						sItem = Mid(sText , 2 , Len(sText)-5)
						
					Else
						
						sItem = Left(sText , Len(sText)-3)
						
					Endif
					
					For i As Long = 0 To 1000
						
						If pProject.tBasFiles(i).pszFile Andalso *(pProject.tBasFiles(i).pszFile) = sItem Then
							
							For j As Long = 1 To IupGetChildCount(TGlobalVariables->tabs) - 1
								
								If pProject.tBasFiles(i).mt Andalso TGlobalVariables->tTabsOptions(j).multitext = pProject.tBasFiles(i).mt Then
									
									IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS" , Str(j))
									
									return 1
									
								Endif
								
							Next
							
							Exit For
							
						Endif
						
					Next
					
				Case " +"
					
					sItem = Left(sText , Len(sText)-2)
					
					For i As Long = 0 To 1000
						
						If pProject.tBiFiles(i).pszFile Andalso *(pProject.tBiFiles(i).pszFile) = sItem Then
								
							For j As Long = 1 To IupGetChildCount(TGlobalVariables->tabs) - 1
								
								If pProject.tBiFiles(i).mt Andalso TGlobalVariables->tTabsOptions(j).multitext = pProject.tBiFiles(i).mt Then
									
									IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS" , Str(j))
									
									return 1
									
								Endif
								
							Next
							
							Exit For
							
						Endif
						
						If i < 101 Andalso pProject.tRcFiles(i).pszFile Andalso *(pProject.tRcFiles(i).pszFile) = sItem Then
							
							For j As Long = 1 To IupGetChildCount(TGlobalVariables->tabs) - 1
								
								If pProject.tRcFiles(i).mt Andalso TGlobalVariables->tTabsOptions(j).multitext = pProject.tRcFiles(i).mt Then
									
									IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS" , Str(j))
									
									return 1
									
								Endif
								
							Next							
							
							Exit For
							
						Endif
						
					Next					
					
			End Select
			
		Endif
		
	Endif	
	
End function
