
' ######################################Callback######################################
' ####################################################################################
' ####################################################################################


' Close main dialog
Function close_dialog_callback Cdecl(dlg As Ihandle Ptr) As Integer
	
	If tbs_item_close_proc (0) = IUP_IGNORE Then Return IUP_IGNORE
	
	init_deinitialization_proc()
	
	Return IUP_CLOSE
	
End Function

Function resize_dialog_callback Cdecl ( ih As Ihandle Ptr , w As Integer , h As Integer) As Integer
	
	Dim As iHandle Ptr list = IupGetDialogChild(ih,"listboxsidewin")
	
	' высота горизонтального сплитера
	Dim As String sTemp = *IupGetAttribute(TGlobalVariables->split, "RASTERSIZE")
	
	Dim As Long iHeightSizeSplit = Val(Mid(sTemp , Instr(sTemp , "x")+1))
	
	
	' текущее соотношение горизонтального сплитера
	Dim As Long iSplitPercent =  Val(*IupGetAttribute(TGlobalVariables->split, "VALUE"))
	
	' позиция statusbar по Y
	sTemp = *IupGetAttribute(TGlobalVariables->statusbar, "POSITION") 
	
	Dim As Long iStatusBarSizePosY = Val(Mid(sTemp , Instr(sTemp , ",")+1))	
	
	
	' размеры buildbox
	sTemp = *IupGetAttribute(TGlobalVariables->buildbox, "RASTERSIZE")
	
	Dim As Long iBuildBoxSizeH = Val(Mid(sTemp , Instr(sTemp , "x")+1))
	
	Dim As Long iBuildBoxSizeW = Val(Mid(sTemp , 1 , Instr(sTemp , "x")))	
	
	' размер combobox по высоте	
	sTemp = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"combosidewin"), "RASTERSIZE")
	
	Dim As Long iRasterSizeCombo = Val(Mid(sTemp , Instr(sTemp , "x")+1)) + 1	
	
	Dim As Long iHB = h\3
	
	IupSetStrAttribute(TGlobalVariables->buildbox, "MAXSIZE" , "x" & iHB )
	
	IupSetStrAttribute(TGlobalVariables->buildbox, "RASTERSIZE" , w & "x" & iHB)
	
	iBuildBoxSizeH = iHB
	
	' если statusbar не видно
	If  iStatusBarSizePosY > h Then 
		
		iSplitPercent = 1000- ((iBuildBoxSizeH+10)*1000)\(h-50)
		
		IupSetstrAttribute(TGlobalVariables->split, "VALUE" , Str(iSplitPercent))
		
		' размер listboxsidewin
		Dim As Long iPercent = (iHeightSizeSplit * iSplitPercent)\1000 
		
		IupSetAttributes(list, "MAXSIZE=x" & iPercent - iRasterSizeCombo)
		
	Else
		
		' размер listboxsidewin
		Dim As Long iPercent =  (iHeightSizeSplit * iSplitPercent)\1000 
		
		IupSetAttributes(list, "MAXSIZE=x" & iPercent - iRasterSizeCombo)			
		
	Endif	
	
	IupRefresh(TGlobalVariables->dlg)
	
	Return IUP_DEFAULT
	
End Function

Function show_dialog_callback Cdecl ( ih As Ihandle Ptr , iState As Integer) As Integer
	
	If iState = IUP_MAXIMIZE Orelse iState = IUP_RESTORE Then
		
		If TGlobalVariables->bFlagInitEditor_ForCallbacks = 1 Then
			
			Dim As Ihandle Ptr hTimer = IUPtimer()
			
			IupSetAttribute(hTimer, "TIME", "20")
			
			IupSetCallback(hTimer, "ACTION_CB", Cast(Any Ptr,@timer_update_size_winside_callback()))		
			
			IupSetAttribute(hTimer, "RUN", "YES")
			
		Endif
		
	Endif
	
	Return IUP_DEFAULT
	
End Function


' ############################# MENU and TOOLBAR

' New
Function item_new_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) > 98 Then
		
		IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorendtitle"), _
		*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorcounttab"))
		
		Return IUP_DEFAULT
		
	Endif
	
	fl_new_file_proc()
	
	IupSetAttribute(TGlobalVariables->hTimerUpdateBiFiles, "RUN", "YES")
	
	Return IUP_DEFAULT
	
End Function

' Open
Function item_open_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	Dim As Zstring Ptr pszPath = fdlg_open_dialog_files_proc()
	
	fl_open_file_proc (pszPath)
	
	IupSetAttribute(TGlobalVariables->hTimerUpdateBiFiles, "RUN", "YES")	
	
	Return IUP_DEFAULT
	
End Function

' Open in the another encoding
Function item_highlight_cb_menuencforsave_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	mn_set_flag_on_item_encoding_proc()	
	
	Return IUP_DEFAULT
	
End Function

' Save as
Function item_save_as_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	fl_save_as_proc(idTabs)
	
	Return IUP_DEFAULT
	
End Function

' Save
Function item_save_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	fl_save_proc(idTabs)
	
	Return IUP_DEFAULT
	
End Function

' Save all
Function item_save_all_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	fl_save_all_proc()
	
	Return IUP_DEFAULT
	
End Function

' Close
Function item_close_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	IupSetAttribute(TGlobalVariables->hTimerUpdateBiFiles, "RUN", "YES")
	
	If pProject.iProjectLoad Then
		
		Return tbs_item_close_proc(Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS")),,1)
		
	Else
		
		Return tbs_item_close_proc(Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS")))
		
	Endif
	
End Function

' Close all
Function item_close_all_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	IupSetAttribute(TGlobalVariables->hTimerUpdateBiFiles, "RUN", "YES")
	
	If pProject.iProjectLoad Then
		
		Return tbs_item_close_proc (0 , , 1)
		
	Else
		
		Return tbs_item_close_proc (0)
		
	Endif
	
End Function

'Recent files
Function config_recent_callback Cdecl (ih As Ihandle Ptr) As Long
	
	Dim As Zstring Ptr pszFilename = IupGetAttribute(ih, "TITLE")
	
	Dim As Zstring*256 szTempBufPath = *pszFilename
	
	Dim As Zstring*2 szEncZero = ""
	
	Dim As Integer iSizeRet
	
	Dim As Zstring Ptr pszEncPath = Cast(Zstring Ptr,enc_encode_buffer_proc(Strptr(szEncZero),"UTF-8", Cast(Byte Ptr,@szTempBufPath), Len(szTempBufPath) , iSizeRet))
	
	If Fileexists(*pszEncPath) = -1 Then
		
		fl_open_file_proc(pszEncPath)
		
	Endif
	
	If pszEncPath Then Deallocate (pszEncPath)
	
	Return IUP_DEFAULT
	
End Function

' Exit
Function item_exit_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	init_deinitialization_proc()
	
	Return IUP_CLOSE
	
End Function

' Undo
Function item_undo_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	If IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_CANUNDO, 0,  0) Then
		
		IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext  , "UNDO", "YES")		
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

' Redo
Function item_redo_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	If IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_CANREDO, 0,  0) Then
		
		IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext  , "REDO", "YES")
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

' Cut
Function item_cut_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_CUT,  0 ,  0 ) 
	
	Return IUP_DEFAULT
	
End Function

' Copy
Function item_copy_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_COPY,  0 ,  0 ) 
	
	Return IUP_DEFAULT
	
End Function

' Paste
Function item_paste_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_PASTE,  0 ,  0 ) 
	
	Return IUP_DEFAULT
	
End Function

' Delete
Function item_delete_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "SELECTEDTEXT", "")
	
	Return IUP_DEFAULT
	
End Function

' Bookmarks Toggle
Function item_bookmarks_toggle_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As Integer iPos = IupGetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "CARETPOS")
	
	Dim As Integer iLine, iColumn
	
	IupTextConvertPosToLinCol(TGlobalVariables->tTabsOptions(idTabs).multitext, iPos, Cast(Any Ptr,@iLine), Cast(Any Ptr,@iColumn))
	
	mrk_toggle_marker_proc(TGlobalVariables->tTabsOptions(idTabs).multitext, iLine, 1)
	
	Return IUP_DEFAULT
	
End Function

' Bookmarks Next
Function item_bookmarks_next_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Return mrk_bookmark_next_prev_proc(ih , 1)
	
End Function

' Bookmarks Prev
Function item_bookmarks_prev_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Return mrk_bookmark_next_prev_proc(ih , 0)
	
End Function

' Bookmarks Clear All
Function item_bookmarks_clear_all_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "MARKERDELETEALL", 0)
	
	Return IUP_DEFAULT
	
End Function

' TRIM spaces in trailing
Function item_space_trim_trailing_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "BEGIN")
	
	tbspc_remove_trailing_spaces_proc(TGlobalVariables->tTabsOptions(idTabs).multitext)
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "END")
	
	Return IUP_DEFAULT
	
End Function

' TRIM spaces in leading
Function item_space_trim_leading_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "BEGIN")
	
	tbspc_remove_leading_spaces_proc(TGlobalVariables->tTabsOptions(idTabs).multitext)
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "END")
	
	Return IUP_DEFAULT
	
End Function

' TRIM spaces in trailing and leading
Function item_space_trim_trailing_and_leading_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "BEGIN")
	
	tbspc_remove_leading_spaces_proc(TGlobalVariables->tTabsOptions(idTabs).multitext)
	
	tbspc_remove_trailing_spaces_proc(TGlobalVariables->tTabsOptions(idTabs).multitext)
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "END")	
	
	Return IUP_DEFAULT
	
End Function

' Spaces to Tabs begin
Function item_space_to_tab_begin_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "BEGIN")
	
	tbspc_tab_to_spaces_begin_proc()
	
	tbspc_spaces_to_tab_begin_proc()
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "END")
	
	Return IUP_DEFAULT
	
End Function

' Spaces to Tabs
Function item_space_to_tab_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "BEGIN")
	
	tbspc_tab_to_spaces_proc()
	
	tbspc_spaces_to_tab_proc()
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "END")
	
	Return IUP_DEFAULT
	
End Function

' Tabs to Spaces
Function item_tab_to_space_begin_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "BEGIN")
	
	tbspc_tab_to_spaces_begin_proc()
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "END")
	
	Return IUP_DEFAULT
	
End Function

' Tabs to Spaces
Function item_tab_to_space_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "BEGIN")
	
	tbspc_tab_to_spaces_proc()
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "END")
	
	Return IUP_DEFAULT
	
End Function

' Simvols to lowercase
Function item_convert_lower_case_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	cnv_convert_lower_or_upper_case_proc(0)
	
	Return IUP_DEFAULT
	
End Function

' Simvols to uppercase
Function item_convert_upper_case_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	cnv_convert_lower_or_upper_case_proc(1)
	
	Return IUP_DEFAULT
	
End Function

' Select all text
Function item_select_all_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetFocus(TGlobalVariables->tTabsOptions(idTabs).multitext)
	
	Dim As Integer count = IupGetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "COUNT")
	
	IupSetStrf(TGlobalVariables->tTabsOptions(idTabs).multitext, "SELECTIONPOS", !"%d:%d", 0, count)
	
	Return IUP_DEFAULT
	
End Function

' autoindent
Function item_autoindent_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	atc_autoindent_proc()
	
	Return IUP_DEFAULT
	
End Function

' Zoom plus
Function item_view_zoom_plus_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "ZOOMIN", "10")
	
	Return IUP_DEFAULT
	
End Function

' Zoom minus
Function item_view_zoom_minus_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "ZOOMOUT", "10")
	
	Return IUP_DEFAULT
	
End Function

' Zoom default
Function item_view_zoom_default_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "ZOOM", "0")	
	
	Return IUP_DEFAULT
	
End Function

' Word Wrap
Function item_view_word_wrap_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	If (IupGetInt(ih, "VALUE")) Then
		
		IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "WORDWRAP", "WORD")
		
	Else
		
		IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "WORDWRAP", "NONE")
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

' Show White Spaces
Function item_view_show_white_spaces_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	If (IupGetInt(ih, "VALUE")) Then
		
		IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "WHITESPACEVIEW", "VISIBLEALWAYS")
		
	Else
		
		IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "WHITESPACEVIEW", "INVISIBLE")
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

' View WinSide Window
Function item_view_winside_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetInt(ih, "VALUE") = 1 Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig, "ChildParam", "winsidevisible", "1")
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"DialogSize","vertsplitsize" , "800")
		
		IupSetAttribute(TGlobalVariables->vertsplit, "VALUE", "800")	
		
		TGlobalVariables->dTimeUpdateListSideWin = Timer
		
		TGlobalVariables->bUpdateListSideWin = 0				
		
	Else
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig, "ChildParam", "winsidevisible", "0")
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"DialogSize","vertsplitsize" , "1000")
		
		IupSetAttribute(TGlobalVariables->vertsplit, "VALUE", "1000")	
		
	Endif
	
	IupRefresh(TGlobalVariables->dlg)
	
	Return IUP_DEFAULT
	
End Function

' View toolbar
Function item_view_toolbar_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	widvis_child_widget_visibility_proc(TGlobalVariables->toolbar,ih)
	
	If *IupGetAttribute(TGlobalVariables->toolbar, "VISIBLE") = "YES" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig, "ChildParam", "toolbarvisible", "1")
		
	Else
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig, "ChildParam", "toolbarvisible", "0")
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

' View statusbar
Function item_view_statusbar_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	widvis_child_widget_visibility_proc(TGlobalVariables->statusbar,ih)
	
	If *IupGetAttribute(TGlobalVariables->statusbar, "VISIBLE") = "YES" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig, "ChildParam", "statusbarvisible", "1")
		
	Else
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig, "ChildParam", "statusbarvisible", "0")
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

' View Line Numbers
Function item_view_line_numbers_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	If (IupGetInt(ih, "VALUE")) Then
		
		If IupVersionNumber() >= 323000 Then
			
			IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "MARGINWIDTH0", 30)
			
		Else
			
			IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "MARGINWIDTH0", Val(TGlobalVariables->szFontEditorSize)*5)
			
		Endif
		
		IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "MARGINWIDTH1", 15)
		
		If TGlobalVariables->bFlagFolding = 1 Then
			
			IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "MARGINWIDTH2", 15)
			
		Endif
		
	Else
		
		IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "MARGINWIDTH0", 0)
		
		IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "MARGINWIDTH1", 0)
		
		If TGlobalVariables->bFlagFolding = 1 Then
			
			IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "MARGINWIDTH2", 0)
			
		Endif
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

' Compile
Function item_compile_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	cmp_prepare_compile_proc()
	
	Return IUP_DEFAULT
	
End Function

' Run
Function item_run_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	cmp_start_program_proc()
	
	Return IUP_DEFAULT
	
End Function

' Compile and Run
Function item_compile_and_run_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	Dim As Ihandle Ptr list_combo = IupGetDialogChild(TGlobalVariables->toolbar, "comboselectbuild")
	
	Dim As Integer iPosCombo = Val(*IupGetAttribute(list_combo , "VALUE"))
	
	Dim As Zstring Ptr pszTempOptions = Cast(Any Ptr,IupConfigGetVariableStr(TGlobalVariables->hConfig,"BUILD","c" & iPosCombo))
	
	If cmp_prepare_compile_proc() Then
		
		If pszTempOptions Then
			
			If Instr(Trim(Lcase(*pszTempOptions)) , "-lib") Orelse _
			Instr(Trim(Lcase(*pszTempOptions)) , "-dylib") Orelse _
			Instr(Trim(Lcase(*pszTempOptions)) , "-dll") Then
				
			Else
				
				cmp_start_program_proc()
				
			Endif			
			
		Endif
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

' Quick Run
Function item_quick_run_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	cmp_quick_run_proc()
	
	Return IUP_DEFAULT
	
End Function

' Run with debugger
Function item_debug_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	cmp_run_with_debug_proc()
	
	Return IUP_DEFAULT
	
End Function

' Options for EXE Command
Function item_command_for_exe_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	cmp_command_for_exe_proc()
	
	Return IUP_DEFAULT
	
End Function

' TOOLS CUSTOM
Function item_tools_custom_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	Dim As Integer iPos = IupGetChildPos(IupGetParent(ih),ih)
	
	If iPos = -1 Then 
		
		Return IUP_DEFAULT
		
	Else
		
		Dim As String sPath = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"TOOL","c" & (iPos+1))
		
		Dim As String sCurDir , sNewDir
		
		If Len(sPath) Then
			
			sPath = enc_encode_path_proc(sPath , 0)
			
			Dim As Long iPosDir = Instr(sPath , "$D")
			
			If iPosDir Then
			    
			    sCurDir = Curdir
			    
			    sNewDir = Mid(sPath ,iPosDir + 2)
			    
			    sPath = Left(sPath ,iPosDir - 1)
			    
                sNewDir = misc_replace_string_proc(sNewDir , "$A" , Exepath() , , 1)
                
                #ifndef __fb_win32__
                    
                    sNewDir = misc_replace_string_proc(sNewDir , " " , "\ " , , 1)
                    
                #endif
                
                Chdir(sNewDir)
			    
			Endif
			
			Dim As String sFilePathFromEditor , sFileNameFromEditor , sExtNameFile , sSep 
			
			Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS")) , iPosParam
			
			Dim As Ihandle Ptr mt = TGlobalVariables->tTabsOptions(idTabs).multitext
			
			If IupGetChildCount(TGlobalVariables->tabs) > 1 Then
				
				#ifdef __fb_win32__
					
					sSep = "\"
					
				#else
					
					sSep = "/"
					
				#endif
				
				If IupGetAttribute(mt, "FILEPATH") Then
					
					sFilePathFromEditor = *IupGetAttribute(mt, "FILEPATH")
					
					If Right(sFilePathFromEditor , 1) = sSep Then
						
						sFilePathFromEditor = Left(sFilePathFromEditor , Len(sFilePathFromEditor)-1)
						
					Endif
					
				Endif
				
				If IupGetAttribute(mt, "FILENAME") Then
					
					sFileNameFromEditor = *IupGetAttribute(mt, "FILENAME")
					
					Dim iPos As Long = Instrrev(sFileNameFromEditor , ".")
					
					If iPos Then
						
						sExtNameFile = Mid(sFileNameFromEditor , iPos)
						
						sFileNameFromEditor = Left(sFileNameFromEditor , iPos - 1)
						
					Endif
					
				Endif
				
				sPath = misc_replace_string_proc(sPath , "$PATH" , sFilePathFromEditor , , 1)
				
				sPath = misc_replace_string_proc(sPath , "$FILE" , sFileNameFromEditor , , 1)
				
				sPath = misc_replace_string_proc(sPath , "$EXT" , sExtNameFile , , 1)
				
			Endif
			
			sPath = misc_replace_string_proc(sPath , "$A" , Exepath() , , 1)
			
			#ifndef __fb_win32__
				
				sPath = misc_replace_string_proc(sPath , " " , "\ " , , 1)
				
			#endif
			
			iPosParam = Instr(sPath , "$C")
			
			If iPosParam Then
				
				IupExecute(Left(sPath ,iPosParam - 1) , Mid(sPath ,iPosParam + 2))
				
			Else
				
				IupExecute(sPath, "")
				
			Endif
			
			If iPosDir Then
                
                Chdir(sCurDir)
			    
			Endif
			
		Endif	
		
	Endif	
	
	Return IUP_DEFAULT
	
End Function

' Help for FB help and custom helps
Function item_helps_custom_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	Dim As Integer iPos = IupGetChildPos(IupGetParent(ih),ih)
	
	Dim As String szExePath = misc_replace_string_proc(Exepath , " " , "\ " , , 1)
	
	If iPos = -1 Then 
		
		Return IUP_DEFAULT
		
	Elseif iPos = 0 Then
		
		#ifdef __fb_win32__
			
			If GetSystemDefaultLangID() = 1049 Then
				
				IupExecute(Exepath() & "/help/ifer.chm", "")
				
			Else
			
				IupExecute(Exepath() & "/help/ife.chm", "")
				
			Endif
			
		#else
			
			If Environ("LANGUAGE") = "ru" Then
				
				IupExecute(szExePath & "/tools/chmviewer/CHMVIEW", szExePath & "/help/ifer.chm -e UTF-8")
				
			Else
			
				IupExecute(szExePath & "/tools/chmviewer/CHMVIEW", szExePath & "/help/ife.chm -e UTF-8")
				
			Endif
			
		#endif
		
	Else
		
		Dim As String sPath = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"HELPF","c" & iPos)
		
		If Len(sPath) Then
			
			sPath = enc_encode_path_proc(sPath , 0)
			
			sPath = misc_replace_string_proc(sPath ,  "$A" , Exepath())
			
			#ifdef __fb_win32__
				
				IupExecute(sPath, "")
				
			#else
				
				Dim As String szPathParam = hlp_trim_path(sPath)
				
				Dim As String szPathParamCopy = szPathParam
				
				szPathParam = misc_replace_string_proc(szPathParam , " " , "\ " , , 1)
				
				sPath = misc_replace_string_proc(sPath , szPathParamCopy , szPathParam )
				
				If Lcase(Right(sPath , 5)) = ".html" Orelse Lcase(Right(sPath , 4)) = ".htm" Then
					
					Dim As String sBrowser = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathbrowser")
					
					If Len(sBrowser) Then

						If Left(sBrowser , 2) = "$A" Then
							
							sBrowser = Exepath() & Mid(sBrowser , 3)
							
						Endif
						
						IupExecute(misc_replace_string_proc(sBrowser , " " , "\ " , , 1) , sPath)			
						
					Endif
				
				Elseif Lcase(Right(hlp_trim_path(sPath) , 4)) = ".chm" Then
					
					IupExecute(szExePath & "/tools/chmviewer/CHMVIEW", sPath)
					
				Else
					
					IupExecute(sPath, "")
					
				Endif
				
			#endif
			
		Endif
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

' Help About
Function item_help_about_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menuabout"),_
	*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"aboutmessage"))
	
	Return IUP_DEFAULT
	
End Function


' ##################################### MARGIN ####################################

'marginclick
Function marginclick_callback Cdecl (ih As Ihandle Ptr, iMargin As Integer, iLine As Integer, pszStatus As Zstring Ptr) As Integer
	
	If iMargin = 1 Then
		
		mrk_toggle_marker_proc(ih, iLine, iMargin)
		
	Elseif TGlobalVariables->bFlagFolding = 1 Andalso iMargin = 2 Then	
		
		IupSetfAttribute(ih, "FOLDTOGGLE", "%d", iLine)
		
	Else
		
		Return IUP_IGNORE
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

' ##################################### GOTO ####################################

Function  goto_ok_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Integer iLineCount = IupGetInt(ih, "TEXT_LINECOUNT")
	
	Dim As Ihandle Ptr hTxt = IupGetDialogChild(ih, "LINE_TEXT")
	
	Dim As Integer iLine = IupGetInt(hTxt, "VALUE")
	
	If iLine < 1 Orelse iLine > iLineCount Then
		
		IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorendtitle"),_
		*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"errorgoto"))
		
		Return IUP_DEFAULT
		
	Endif
	
	IupSetAttribute(IupGetDialog(ih), "STATUS", "1")
	
	Return IUP_CLOSE
	
End Function

Function goto_cancel_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	IupSetAttribute(IupGetDialog(ih), "STATUS", "0")
	
	Return IUP_CLOSE
	
End Function

' Goto
Function item_goto_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	gt_goto_proc ()
	
	Return IUP_DEFAULT
	
End Function


' ##################################### FIND | REPLACE ####################################

' Find
Function item_find_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	fnd_find_replace_visibility_proc(0)	
	
	Return IUP_DEFAULT
	
End Function

' Find Next
Function item_find_next_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->find_dlg, "FIND_DOWN") , "VALUE" , "ON")
	
	If fnd_find_proc(0) = 2 Then
		
		tmr_update_after_changes()
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

' Find Prev
Function item_find_prev_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->find_dlg, "FIND_UP") , "VALUE" , "ON")
	
	If fnd_find_proc(0) = 2 Then
	
		tmr_update_after_changes()
	
	Endif
	
	Return IUP_DEFAULT
	
End Function

' Find Recent
Function item_find_recent_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	Dim As Ihandle Ptr txtFind = IupGetDialogChild(TGlobalVariables->find_dlg, "FIND_TXTFIND")
	
	Dim As Zstring Ptr pszItemtext = IupGetAttribute( ih , "TITLE")
	
	If pszItemtext Andalso Len(*pszItemtext) Then
		
		IupSetStrAttribute( txtFind , "VALUE" , pszItemtext)
		
		tRecentFindInfo->move(Val(*IupGetAttribute(ih , "mID")))
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

' Replace
Function item_replace_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	fnd_find_replace_visibility_proc(1)	
	
	Return IUP_DEFAULT
	
End Function

Function find_close_action_callback Cdecl(dlg As Ihandle Ptr) As Integer
	
	IupHide(dlg)
	
	Return IUP_DEFAULT
	
End Function

Function find_cancel_action_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	IupHide(TGlobalVariables->find_dlg)
	
	Return IUP_DEFAULT
	
End Function

Function find_btnfind_action_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	If fnd_find_proc(0) = 2 Then
	
		tmr_update_after_changes()
	
	Endif
	
	Return IUP_DEFAULT
	
End Function

Function find_btnfindall_action_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	fnd_find_proc(1)
	
	Return IUP_DEFAULT
	
End Function

Function find_btnreplace_action_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	fnd_replace_proc()
	
	Return IUP_DEFAULT
	
End Function

Function find_btnreplaceall_action_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	fnd_replace_all_proc()
	
	Return IUP_DEFAULT
	
End Function

Function find_btnrecent_action_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	mn_find_recent_proc()
	
	Return IUP_DEFAULT
	
End Function

Function find_option_proc_action_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As Integer iCaretPos = Cint(IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext , SCI_GETCURRENTPOS , 0 , 0 ))
	
	Dim As Integer iCurentLine  , iCurentColumn  , iFlag
	
	If iAcIndexLinesLocalArea Then
		
		IupTextConvertPosToLinCol(TGlobalVariables->tTabsOptions(idTabs).multitext,_
		iCaretPos, Cast(Any Ptr, @iCurentLine), Cast(Any Ptr, @iCurentColumn))
		
		For i As Long = 0 To iAcIndexLinesLocalArea-1
			
			If iCurentLine > tAcDimLinesLocalArea(i).iLineB Andalso iCurentLine < tAcDimLinesLocalArea(i).iLineE Then
				
				iFlag = 1
				
				Exit For
				
			Endif
			
		Next
		
	Endif
	
	If iFlag = 0 Then
		
		IupSetAttribute(IupGetDialogChild(IupGetDialog(ih) , "FIND_FILEALL"), "VALUE" ,"ON")
		
	Endif
	
	Return IUP_DEFAULT
	
End Function


' ##################################### INDENT ####################################

' Indent
Function item_indent_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "BEGIN")
	
	indt_indent_proc()
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "END")
	
	Return IUP_DEFAULT
	
End Function

' No Indent
Function item_no_indent_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "BEGIN")
	
	indt_outdent_proc()
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "END")
	
	Return IUP_DEFAULT
	
End Function

' #################################### COMMENTS ##############################################

' Comment
Function item_comment_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	cmt_comment_proc()
	
	Return IUP_DEFAULT
	
End Function

' UnComment
Function item_uncomment_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	cmt_uncomment_proc()
	
	Return IUP_DEFAULT
	
End Function

' ######################################## CARET_CB ####################################

Function multitext_caret_callback Cdecl ( ih As Ihandle Ptr, iLine As Integer, iColumn As Integer) As Integer
	
	TGlobalVariables->dTimeUpdateListSideWin = Timer
	
	TGlobalVariables->bUpdateListSideWin = 0
	
	TGlobalVariables->bUpdateAutoCompletion = 0
	
	TGlobalVariables->bUpdateTips = 0	
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	If TGlobalVariables->bFlagAutoComplect = 1 Andalso TGlobalVariables->bLineAutocomplect = 1 Then
		
		atc_autocomplect_proc(iLine - 1)
		
		TGlobalVariables->bLineAutocomplect = 0
		
	Elseif TGlobalVariables->bLineAutocomplect = 1 Then
		
		atc_cursor_on_column_proc(iLine - 1 , "")
		
		TGlobalVariables->bLineAutocomplect = 0
		
	Endif
	
	Dim As Integer iPos = IupGetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "CARETPOS")
	
	Dim As Integer iPosEnd = IupGetIntId( TGlobalVariables->tTabsOptions(idTabs).multitext, "BRACEMATCH", iPos - 1 )
	
	If (iPosEnd >= 0) Then
		
		IupScintillaSendMessage( TGlobalVariables->tTabsOptions(idTabs).multitext ,2351 , iPos-1 , Cast(Any Ptr,iPosEnd)) 'SCI_BRACEHIGHLIGHT = 2351
		
	Else
		
		IupScintillaSendMessage( TGlobalVariables->tTabsOptions(idTabs).multitext ,2351 , -1 , Cast(Any Ptr,-1))
		
	Endif 
	
	If *(IupConfigGetVariableStr(TGlobalVariables->hConfig, "Parser","isdelaytips")) = "OFF" Then
		
		If bFlag_F6_OnPressed = 0 Then
			
			ann_start_proc()
			
		Endif
		
	Endif
	
	bFlag_F6_OnPressed = 0
	
	ac_start_proc(TGlobalVariables->tTabsOptions(idTabs).multitext)
	
	Return IUP_DEFAULT
	
End Function

' ######################################## ACTION MULTITEXT ####################################

Function action_multitext_callback Cdecl ( ih As Ihandle Ptr, iInsert As Integer, iPos As Integer , iLenght As Integer , szText As Zstring Ptr) As Integer
	
	Return IUP_DEFAULT
	
End Function

' ######################################## BUTTON_CB MULTITEXT ####################################

Function button_cb_multitext_callback Cdecl ( ih As Ihandle Ptr, iButton As Integer, iPressed As Integer , ix As Integer , iy As Integer , pszStatus As Zstring Ptr) As Integer
	
	If iPressed = 0 Then
		
		If iButton = IUP_BUTTON3 Then
			
			mn_menu_popup_editor_proc()
			
		Elseif iButton = IUP_BUTTON1 Then  
			
			If iup_iscontrol(pszStatus) Then
				
				' if you call fl_open_include_files_proc () here directly,
				' then IupScintilla appears to be waiting for a message to be returned.
				' And on blocking calls (for example, IupMessage dialogs),
				' the mouse is constantly changing the cursor. There is a problem somewhere, but where ????
				' Therefore, it was decided: to let the button_cb_multitext_callback () function complete,
				' and call the fl_open_include_files_proc () function via the callback Timer
				
				Dim As Ihandle Ptr hTimer = IUPtimer()
				
				IupSetAttribute(hTimer, "TIME", "30")
				
				IupSetCallback(hTimer, "ACTION_CB", Cast(Any Ptr,@timer_open_include_callback()))
				
				IupSetAttribute(hTimer, "RUN", "YES")
				
				'fl_open_include_files_proc()
				
			Endif
			
		Endif
		
	Else
		
		If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Parser" , "tips1") = "1" Then
			
			IupScintillaSendMessage(ih, SCI_CALLTIPCANCEL , 0, 0)
			
		Else
		
			IupScintillaSendMessage(ih, SCI_ANNOTATIONCLEARALL, 0, 0)
			
		Endif
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

' ######################################## CONVERT CRLF\LF MULTITEXT ####################################

Function convert_crlf_multitext_callback Cdecl ( ih As Ihandle Ptr) As Integer
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As Ihandle Ptr mt = TGlobalVariables->tTabsOptions(idtabs).multitext
	
	IupScintillaSendMessage(mt, SCI_SETEOLMODE,  SC_EOL_CRLF ,  0 )
	
	IupScintillaSendMessage(mt, SCI_CONVERTEOLS,  SC_EOL_CRLF ,  0 )   
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "EOLLBL"), "TITLE" , "EOL: WIN (CRLF)")
	
	Return IUP_DEFAULT
	
End Function

Function convert_lf_multitext_callback Cdecl ( ih As Ihandle Ptr) As Integer
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As Ihandle Ptr mt = TGlobalVariables->tTabsOptions(idtabs).multitext   
	
	IupScintillaSendMessage(mt, SCI_SETEOLMODE,  SC_EOL_LF ,  0 )
	
	IupScintillaSendMessage(mt, SCI_CONVERTEOLS,  SC_EOL_LF ,  0 ) 
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "EOLLBL"), "TITLE" , "EOL: UNIX (LF)")		  
	
	Return IUP_DEFAULT
	
End Function


' ###################### GET DECLARES OR TYPES VARIABLE IN THE EDITOR ###############################################

Function get_declares_var_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	ac_get_var_declares_proc()
	
	Return IUP_DEFAULT
	
End Function

Function get_declaresprev_var_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	gt_goto_prevpos()
	
	Return IUP_DEFAULT
	
End Function

Function get_type_var_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	ac_user_action_get_type_proc()
	
	Return IUP_DEFAULT
	
End Function

Function get_infoproc_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	ann_highlights_block_local_area()
	
	Return IUP_DEFAULT
	
End Function


' ###################### SYNTAX_HIGHLIGHTING ###############################################

Function set_syntax_highlighting_f_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	mtxt_set_syntax_highlighting(0,"freebasic")
	
	Return IUP_DEFAULT
	
End Function

Function set_syntax_highlighting_a_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	mtxt_set_syntax_highlighting(0,"asm")
	
	Return IUP_DEFAULT
	
End Function

Function set_syntax_highlighting_c_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	mtxt_set_syntax_highlighting(0,"cpp")
	
	Return IUP_DEFAULT
	
End Function

Function set_syntax_highlighting_r_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	mtxt_set_syntax_highlighting(0,"rc")
	
	Return IUP_DEFAULT
	
End Function

Function set_syntax_highlighting_n_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	mtxt_set_syntax_highlighting(0,"none")
	
	Return IUP_DEFAULT
	
End Function

' ###################### CHANGED EDITORS ###############################################

Function multitext_valuechanged_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	IupSetAttribute(ih, "ISCHANGES", "YES")
	
	Return IUP_DEFAULT
	
End Function

' ###################### UPDATE AFTER SCROLL EDITOR ####################################

Function updatevscroll_cb_multitext_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	Dim As Zstring Ptr pszPointer = iupGetAttribute(ih , "WIDTH_NUM_VIEW")
	
	Dim As Integer iLen , iCurIndent
	
	If pszPointer Then
		
		iCurIndent = Val(*pszPointer)
		
	Endif
	
	pszPointer = IupGetAttribute(ih,"FIRSTVISIBLELINE")
	
	If pszPointer Then
		
		iLen = Val(*pszPointer) + 1
		
	Endif
	
	pszPointer = IupGetAttribute(ih,"VISIBLELINESCOUNT")
	
	If pszPointer Then
		
		iLen += Val(*pszPointer) 
		
	Endif
	
	iLen = Len(Str(iLen))
	
	If iLen < 3 Then iLen = 3
	
	If iCurIndent <> iLen Then
		
		IupSetInt(ih, "MARGINWIDTH0", Val(TGlobalVariables->szFontEditorSize)*iLen)
		
		iupSetStrAttribute(ih , "WIDTH_NUM_VIEW" , Str(iLen))
		
	Endif	
	
	Return IUP_DEFAULT
	
End Function


'############################# DROPFILES ##############################################
Function dropfiles_callback Cdecl (ih As Ihandle Ptr , pszFileName As Zstring Ptr) As Integer
	
	If pProject.iProjectLoad = 0 Andalso Lcase(Right(*pszFileName, 4)) = ".prj" Then
		
		Select Case IupAlarm(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitlewarning") ,_
		*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgopenprjorfile") , "YES" , "NO" , 0)
				
			Case 1
				
				Dim As String sPath = *pszFileName
				
				#ifdef __fb_win32__	
				#else
				
					sPath = fl_prepare_path(sPath)
					
				#endif
				
				prj_open_project_proc(sPath)
				
			Case Else
				
				fl_open_file_proc(pszFileName)
				
		End Select
		
	Else
		
		fl_open_file_proc(pszFileName)
		
	Endif
	
	Return IUP_DEFAULT
	
End Function



'############################# Window Output INFO ##############################################

' ' Processing Click in the window output info (compilation , search)
Function buildbox_button_callback Cdecl ( ih As Ihandle Ptr, button As Integer , pressed As Integer, x As Integer , y As Integer , pszStatus As Zstring Ptr) As Integer
	
	winout_processing_click_mouse_buildbox_proc( ih , button , pressed , x ,y , pszStatus )
	
	Return IUP_DEFAULT
	
End Function

'List combo (compilier options)
Function list_combo_build_callback Cdecl (ih As Ihandle Ptr, pszText As Zstring Ptr, iItem As Integer, iState As Integer) As Integer
	
	If iState = 1 Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig, "BUILD" , "current" , Str(iItem))
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

' popup menu buildbox copy text from select items
Function item_popup_buildbox_copy_sel_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	winout_copy_text_from_buildbox_proc ( 0 )
	
	Return IUP_DEFAULT
	
End Function

' popup menu buildbox copy text from all items
Function item_popup_buildbox_copy_all_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	winout_copy_text_from_buildbox_proc ( 1 )
	
	Return IUP_DEFAULT
	
End Function

' popup menu buildbox show only errors
Function item_popup_buildbox_only_errors_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	winout_popup_buildbox_only_errors_proc ()
	
	Return IUP_DEFAULT
	
End Function

' popup menu buildbox show only warnings
Function item_popup_buildbox_only_warnings_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	winout_popup_buildbox_only_warnings_proc ()
	
	Return IUP_DEFAULT
	
End Function

' popup menu buildbox show warnings and errors
Function item_popup_buildbox_errors_and_warnings_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	winout_popup_buildbox_errors_and_warnings_proc ()
	
	Return IUP_DEFAULT
	
End Function

' popup menu buildbox clear items
Function item_popup_buildbox_clear_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	IupSetfAttribute(TGlobalVariables->buildbox , "REMOVEITEM", "ALL")
	
	Return IUP_DEFAULT
	
End Function

' ############################################## Split #############################################

Function value_changed_split_callback Cdecl ( ih As Ihandle Ptr) As Integer
	
	Dim As iHandle Ptr list = IupGetDialogChild(TGlobalVariables->dlg,"listboxsidewin")
	
	Dim As String sTemp = *IupGetAttribute(ih, "RASTERSIZE")
	
	Dim As Long iHeightSplit = Val(Mid(sTemp , Instr(sTemp , "x")+1))
	
	Dim As Long iSplitSize =  Val(*IupGetAttribute(ih, "VALUE"))
	
	sTemp = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"combosidewin"), "RASTERSIZE")
	
	Dim As Long iRasterSizeCombo = Val(Mid(sTemp , Instr(sTemp , "x")+1)) + 1	
	
	Dim As Long iSplitVertSize = (iHeightSplit * iSplitSize)\1000 - iRasterSizeCombo
	
	IupSetAttributes(list, "MAXSIZE=x" & iSplitVertSize) 
	
	sTemp = *IupGetAttribute(TGlobalVariables->statusbar, "POSITION") 
	
	Dim As Long iStatusBarSizePosY = Val(Mid(sTemp , Instr(sTemp , ",")+1))	
	
	sTemp = *IupGetAttribute(TGlobalVariables->dlg, "CLIENTSIZE") 
	
	Dim As Long iHclient = Val(Mid(sTemp , Instr(sTemp , "x")+1))
	
	If iStatusBarSizePosY > iHclient Then
		
		IupSetStrAttribute(TGlobalVariables->buildbox, "MAXSIZE" , "x" & iHclient\3 )  
		
		IupRefresh(TGlobalVariables->buildbox)
		
	Else
		
		IupSetStrAttribute(TGlobalVariables->buildbox, "MAXSIZE" , "x" &  iHeightSplit - (iSplitSize*iHeightSplit)\1000)
		
	Endif
	
	Return IUP_DEFAULT
	
End Function


' ############################################## Window Side List #############################################

Function listbox_winside_callback Cdecl ( ih As Ihandle Ptr, iButton As Integer, iPressed As Integer , ix As Integer , iy As Integer , pszStatus As Zstring Ptr) As Integer
	
	If iButton = IUP_BUTTON1 Andalso iPressed  = 0 Then
		
		If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
		
		If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"btnprjsidewin") , "VALUE") = "OFF" Then
			
			Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
			
			If TGlobalVariables->tTabsOptions(idTabs).multitext = 0 Then Return IUP_DEFAULT
			
			Dim As Integer iPos , iPos2 , iLenLine 
			
			Dim As Long iItem = Val(*IupGetAttribute(ih, "VALUE"))
			
			If iItem Andalso iItem < IupGetInt(ih, "COUNT") Then
				
				iLenLine = Len(Rtrim(*IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext , "LINE" & (tDimInfoSideList(iItem-1).iLine )), Any Chr(13) & Chr(10) ))
				
				IupTextConvertLinColToPos(TGlobalVariables->tTabsOptions(idTabs).multitext, tDimInfoSideList(iItem-1).iLine, 0, Cast(Any Ptr,@iPos))
				
				iPos2 = iPos + iLenLine
				
				If tDimInfoSideList(iItem-1).iExtLine <> -1 Andalso tDimInfoSideList(iItem-1).iExtLine <> -2 Then
					
					IupTextConvertLinColToPos(TGlobalVariables->tTabsOptions(idTabs).multitext, tDimInfoSideList(iItem-1).iExtLine, 0, Cast(Any Ptr,@iPos))
					
				Endif
				
				IupSetFocus(TGlobalVariables->tTabsOptions(idTabs).multitext)
				
				IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_SETXOFFSET , 0, 0)
				
				IupSetStrf(TGlobalVariables->tTabsOptions(idTabs).multitext, "SELECTIONPOS", !"%d:%d", iPos2, iPos)
				
				mtxt_line_display_proc(TGlobalVariables->tTabsOptions(idTabs).multitext,_
				Cast(Integer , IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_LINEFROMPOSITION , iPos2 , Cast(Integer , 0))))
				
			Endif
			
		Else
			
			If tbs_set_activetab_from_winside(ih) Then
				
				tmr_update_after_changes()
				
			Endif
			
		Endif
		
	Elseif iButton = IUP_BUTTON3 Andalso iPressed  = 0 Then
		
		If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"btnprjsidewin") , "VALUE") = "ON" Then
			
			If pProject.iProjectLoad Then
				
				Dim As String sItem = *IupGetAttribute(ih, "VALUE")
				
				If Len(sItem) Then
					
					mn_create_project_popup_inwinside_proc()
					
				Endif
				
			Endif
			
		Endif
		
	Endif
	
	Return IUP_DEFAULT
	
End Function


Function listbox_winside_dblclick_callback Cdecl (ih As Ihandle Ptr , iItem As Integer , sText As Zstring Ptr) As Integer
	
	prj_winside_dblclick_fileopen(iItem , sText )
	
	Return IUP_DEFAULT
	
End Function


Function btn_sort_winside_callback Cdecl ( ih As Ihandle Ptr) As Integer
	
	IupSetAttribute(ih,"iChanges", "1")	
	
	TGlobalVariables->dTimeUpdateListSideWin = Timer
	
	TGlobalVariables->bUpdateListSideWin = 0	
	
	Return IUP_DEFAULT
	
End Function

Function btn_prj_winside_callback Cdecl ( ih As Ihandle Ptr) As Integer
	
	If *IupGetAttribute(ih , "VALUE") = "ON" Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"btnsortsidewin") , "ACTIVE" , "NO")
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"combosidewin") , "ACTIVE" , "NO")
		
		winside_addInfo_prj_inlist_proc()
		
		winside_setactiveitem_prj_proc(Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS")))
		
		Return IUP_DEFAULT
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"btnsortsidewin") , "ACTIVE" , "YES")
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"combosidewin") , "ACTIVE" , "YES")
		
	Endif
	
	TGlobalVariables->dTimeUpdateListSideWin = Timer
	
	TGlobalVariables->bUpdateListSideWin = 0
	
	Return IUP_DEFAULT
	
End Function


' ############################################## Timers #############################################

Function timer_activate_multitext_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then 
		
		IupSetAttribute(TGlobalVariables->hTimer, "RUN", "NO")
		
		Return IUP_DEFAULT
		
	Endif
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	If TGlobalVariables->tTabsOptions(idtabs).multitext = 0 Then
		
		IupSetAttribute(TGlobalVariables->hTimer, "RUN", "NO")
		
		Return IUP_DEFAULT
		
	Endif
	
	IupSetFocus(TGlobalVariables->tTabsOptions(idtabs).multitext)
	
	Static As String szPath
	
	szPath = "IUP_FB_Editor - " & _
	*IupGetAttribute(TGlobalVariables->tTabsOptions(idtabs).multitext,"FILEPATH") & _
	*IupGetAttribute(TGlobalVariables->tTabsOptions(idtabs).multitext,"FILENAME")
	
	If *IupGetAttribute(TGlobalVariables->tTabsOptions(idtabs).multitext,"FILEPATH") <> "" Then
		
		szPath = enc_encode_path_proc(szPath , 1 )
		
		IupSetAttribute(TGlobalVariables->dlg, "TITLE", szPath)
		
	Else
		
		IupSetAttribute(TGlobalVariables->dlg, "TITLE", "IUP_FB_Editor - New")
		
	Endif
	
	If IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idtabs).multitext, SCI_GETEOLMODE, 0  ,  0 ) = SC_EOL_CRLF Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "EOLLBL"), "TITLE" , "EOL: WIN (CRLF)")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "EOLLBL"), "TITLE" , "EOL: UNIX (LF)")
		
	Endif
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "ENCLBL"), "TITLE" , _
	*IupGetAttribute(TGlobalVariables->tTabsOptions(idtabs).multitext, "CURRENTENCODING"))
	
	If IupGetInt(TGlobalVariables->tTabsOptions(idtabs).multitext, "MARGINWIDTH1") = 0 Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "menuviewnumbers"), "VALUE", "OFF")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "menuviewnumbers"), "VALUE", "ON")
		
	Endif
	
	If *IupGetAttribute(TGlobalVariables->tTabsOptions(idtabs).multitext, "WHITESPACEVIEW") =  "INVISIBLE" Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "menuwhitespaces"), "VALUE", "OFF")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "menuwhitespaces"), "VALUE", "ON")
		
	Endif
	
	If *IupGetAttribute(TGlobalVariables->tTabsOptions(idtabs).multitext, "WORDWRAP") =  "NONE" Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "menuwordwrap"), "VALUE", "OFF")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "menuwordwrap"), "VALUE", "ON")
		
	Endif
	
	If *IupGetAttribute(TGlobalVariables->tTabsOptions(idtabs).multitext , "OVERWRITE") = "ON" Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "INSLBL"), "TITLE" , "Ovr")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "INSLBL"), "TITLE" , "Ins")
		
	Endif
	
	If pProject.iProjectLoad Then
		
		tb_fill_combobuild_proc()
		
		winside_setactiveitem_prj_proc(idTabs)
		
	Endif
	
	IupSetAttribute(TGlobalVariables->hTimer, "RUN", "NO")	
	
	Return IUP_DEFAULT	
	
End Function

Function timer_update_statusbar_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	If TGlobalVariables->tTabsOptions(idTabs).multitext = 0 Then Return IUP_DEFAULT
	
	Dim As Integer iBegPos , iEndPos , iRange , iLine , iColumn  , iChanges
	
	Static As Integer iRangeb , iLineb , iColumnb , iChangesb = 1
	
	iBegPos = Cint(IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext , SCI_GETSELECTIONSTART, 0,  0))
	
	iEndPos = Cint(IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext , SCI_GETSELECTIONEND, 0 ,  0))
	
	iRange =  Cint(IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext , SCI_COUNTCHARACTERS, Cast(Uinteger,iBegPos) , Cast(Any Ptr,iEndPos) ))
	
	If iRangeb <> iRange Then
		
		iRangeb = iRange
		
		Static As Zstring*15 szSel 
		
		szSel = "Sel: " & iRange
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "SELLBL"), "TITLE" , szSel)
		
	Endif  
	
	Dim As String sResultCaret = *IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext , "CARET" )
	
	Dim As Long iPosF = Instr(sResultCaret , ",")
	
	If iPosF = 0 Then Return IUP_DEFAULT
	
	iLine = Val( Mid( sResultCaret  , 1 , iPosF -1 ) )
	
	iColumn = Val( Mid( sResultCaret  , iPosF + 1  ) )
	
	If iLine <> iLineb Orelse iColumn <> iColumnb Then
		
		iLineb = iLine
		
		iColumnb = iColumn
		
		IupSetfAttribute(IupGetDialogChild(TGlobalVariables->dlg, "LINELBL"), "TITLE", !"Lin %d, Col %d", iLine+1, iColumn)
		
	Endif
	
	If *IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "ISCHANGES") = "YES" Then
		
		iChanges = 1
		
	Else
		
		iChanges = 0
		
	Endif
	
	If iChangesb <> iChanges Then
		
		iChangesb = iChanges
		
		If iChangesb Then
			
			IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "CHANGLBL"), "TITLE", _
			*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"statuschangesyes"))
			
			IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "CHANGLBL"),"FGCOLOR" , "#FF0000")
			
		Else
			
			IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "CHANGLBL"), "TITLE", _
			*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"statuschangesno"))
			
			IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "CHANGLBL"),"FGCOLOR" , "#000000")	      
			
		Endif
		
	Endif
	
	Return IUP_DEFAULT	
	
End Function


Function timer_add_Info_In_List_winside_callback Cdecl (ih As Ihandle Ptr) As Integer 
	
	Static iItem As Long
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"btnprjsidewin") , "VALUE") = "ON" Then
		
		Return IUP_DEFAULT
		
	Endif	
	
	If *(IupConfigGetVariableStr(TGlobalVariables->hConfig, "ChildParam", "winsidevisible")) = "0" Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"listboxsidewin"), "1" , 0)
		
		Return IUP_DEFAULT
		
	Endif
	
	Dim As iHandle Ptr combo = IupGetDialogChild(TGlobalVariables->dlg,"combosidewin")
	
	If iItem <> Val(*IupGetAttribute(combo , "VALUE")) Then
		
		iItem = Val(*IupGetAttribute(combo , "VALUE"))
		
		winside_addInfo_inlist_proc()
		
		TGlobalVariables->bUpdateListSideWin = 1		
		
	Endif
	
	Dim As Double dTime = Val(*IupConfigGetVariableStr(TGlobalVariables->hConfig,"Parser" , "winsidems"))/1000
	
	If dTime < 0.05 Orelse  dTime > 100 Then
		
		dTime = 0.7
		
	Endif
	
	If TGlobalVariables->bUpdateListSideWin = 0 Andalso _
	Timer - TGlobalVariables->dTimeUpdateListSideWin > dTime Then
		
		winside_addInfo_inlist_proc()
		
		TGlobalVariables->bUpdateListSideWin = 1
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

Function timer_update_size_winside_callback Cdecl (ih As Ihandle Ptr) As Integer 
	
	Static iCountFlag As Long
	
	If iCountFlag < 30 Then
		
		Dim As iHandle Ptr list = IupGetDialogChild(TGlobalVariables->dlg,"listboxsidewin")
		
		' Размер горизонтального сплитера по высоте
		Dim As String sTemp = *IupGetAttribute(TGlobalVariables->split, "RASTERSIZE")
		
		Dim As Long iHeightSizeSplit = Val(Mid(sTemp , Instr(sTemp , "x")+1))
		
		' соотношение сплитера
		Dim As Long iSplitPercent =  Val(*IupGetAttribute(TGlobalVariables->split, "VALUE"))
		
		' позиция статусбара
		sTemp = *IupGetAttribute(TGlobalVariables->statusbar, "POSITION") 
		
		Dim As Long iStatusBarSizePosY = Val(Mid(sTemp , Instr(sTemp , ",")+1))	
		
		' размер клиентской части по высоте
		sTemp = *IupGetAttribute(TGlobalVariables->dlg, "CLIENTSIZE") 
		
		Dim As Long ihDialogHeightClient = Val(Mid(sTemp , Instr(sTemp , "x")+1))
		
		Dim As Long ihDialogWidthClient = Val(Mid(sTemp ,1 , Instr(sTemp , "x")))
		
		' размер combobox по высоте
		sTemp = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"combosidewin"), "RASTERSIZE")
		
		Dim As Long iRasterSizeCombo = Val(Mid(sTemp , Instr(sTemp , "x")+1)) + 1	
		
		Dim As Long iHB = ihDialogHeightClient\3
		
		IupSetStrAttribute(TGlobalVariables->buildbox, "MAXSIZE" , "x" & iHB )
		
		IupSetStrAttribute(TGlobalVariables->buildbox, "RASTERSIZE" , ihDialogWidthClient & "x" & iHB)
		
		' если statusbar не видно
		''if  iStatusBarSizePosY > ihDialogHeightClient then 
		
		iSplitPercent = 1000 - ((iHB+10)*1000)\(ihDialogHeightClient-50)
		
		IupSetstrAttribute(TGlobalVariables->split, "VALUE" , Str(iSplitPercent))
		
		' размер listboxsidewin
		Dim As Long iPercent = (iHeightSizeSplit * iSplitPercent)\1000 
		
		IupSetAttributes(list, "MAXSIZE=x" & iPercent - iRasterSizeCombo)
		
		'else
		
		'' размер listboxsidewin
		'dim as Long iPercent =  (iHeightSizeSplit * iSplitPercent)\1000 
		'
		'IupSetAttributes(list, "MAXSIZE=x" & iPercent - iRasterSizeCombo)			
		'
		'EndIf	
		
		IupRefresh(TGlobalVariables->dlg)
		
		iCountFlag+=1
		
	Else
		
		IupSetAttribute(ih, "RUN", "NO")
		
		IupDestroy(ih)
		
		iCountFlag = 0
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

Function timer_parser_proc_callback Cdecl (ih As Ihandle Ptr) As Integer 
	
	Dim As Double dTimeParser = Val(*IupConfigGetVariableStr(TGlobalVariables->hConfig,"Parser" , "parserms"))/1000
	
	Dim As Double dTimeTips = Val(*IupConfigGetVariableStr(TGlobalVariables->hConfig,"Parser" , "tipsms"))/1000
	
	If dTimeParser < 0.05 Orelse  dTimeParser > 100 Then
		
		dTimeParser = 0.05
		
	Endif
	
	If dTimeTips < 0 Orelse  dTimeTips > 100 Then
		
		dTimeTips = 0
		
	Endif	
	
	If *(IupConfigGetVariableStr(TGlobalVariables->hConfig, "Parser","isdelaytips")) = "ON" Then
		
		If TGlobalVariables->bUpdateTips = 0 Andalso Timer - TGlobalVariables->dTimeUpdateListSideWin > dTimeTips Then
			
			If bFlag_F6_OnPressed = 0 Then
			
				ann_start_proc()
			
			Endif
			
			TGlobalVariables->bUpdateTips = 1
			
		Endif			
		
	Endif
	
	If TGlobalVariables->bUpdateAutoCompletion = 0 Andalso Timer - TGlobalVariables->dTimeUpdateListSideWin > dTimeParser Then
		
		ac_parserdoc_proc()
		
		TGlobalVariables->bUpdateAutoCompletion = 1
		
	Endif
	
	Return IUP_DEFAULT   
	
End Function

Function timer_scroll_after_openerrorfile_callback Cdecl (ih As Ihandle Ptr) As Integer 
	
	Static iCount As Long
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then 
		
		Return IUP_DEFAULT
		
	Endif
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))	
	
	IupSetFocus(TGlobalVariables->tTabsOptions(idTabs).multitext)
	
	Dim As Integer iIndexList = Val(*IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "SCROLLAFTERERROR"))	
	
	If iIndexList = 0 Then Return IUP_DEFAULT
	
	IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext , SCI_GOTOLINE , iIndexList -1 , 0)
	
	If iCount > 1 Then
		
		iCount=0
		
		Dim As Integer iPos , iPos2 , iLenLine
		
		iLenLine = Len(Rtrim(*IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext , "LINE" & (iIndexList -1)), Any Chr(13) & Chr(10) ))
		
		IupTextConvertLinColToPos(TGlobalVariables->tTabsOptions(idTabs).multitext, iIndexList - 1, 0, Cast(Any Ptr,@iPos))
		
		iPos2 = iPos + iLenLine	
		
		IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_SETXOFFSET , 0, 0)
		
		IupSetStrf(TGlobalVariables->tTabsOptions(idTabs).multitext, "SELECTIONPOS", !"%d:%d", iPos, iPos2)
		
		mtxt_line_display_proc(TGlobalVariables->tTabsOptions(idTabs).multitext,_
		Cast(Integer , IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_LINEFROMPOSITION , iPos , Cast(Integer , 0))))
		
		IupSetAttribute(ih, "RUN", "NO")
		
		IupSetFocus(TGlobalVariables->buildbox)
		
		IupDestroy(ih) ' можно так или нет не знаю!
		
	Else
		
		iCount+=1
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

Function timer_update_bi_files_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then 
		
		Return IUP_DEFAULT
		
	Endif
	
	TGlobalVariables->bFlagBiFilesSignalUpdate = 1
	
	IupSetAttribute(ih, "RUN", "NO")
	
	Return IUP_DEFAULT
	
End Function

Function timer_init_editor_sizemaximize_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	Static i As Long
	
	If i < 20 Then
		
		IupSetstrAttribute(TGlobalVariables->split, "VALUE", IupConfigGetVariableStr(TGlobalVariables->hConfig,"DialogSize","splitsize"))
		
		Dim As iHandle Ptr list = IupGetDialogChild(TGlobalVariables->dlg,"listboxsidewin")
		
		Dim As String sTemp = *IupGetAttribute(TGlobalVariables->split, "RASTERSIZE")
		
		Dim As Long iRasterSize = Val(Mid(sTemp , Instr(sTemp , "x")+1))
		
		Dim As Long iSplitSize =  Val(*IupGetAttribute(TGlobalVariables->split, "VALUE"))
		
		sTemp = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"combosidewin"), "RASTERSIZE")
		
		Dim As Long iRasterSizeCombo = Val(Mid(sTemp , Instr(sTemp , "x")+1)) + 1	
		
		iRasterSize = (iRasterSize * iSplitSize)\1000 - iRasterSizeCombo
		
		IupSetAttributes(list, "MAXSIZE=x" & iRasterSize) 
		
		IupRefresh(TGlobalVariables->dlg)		
		
		i+=1		
		
	Else
		
		IupSetAttribute(ih, "RUN", "NO")
		
		IupDestroy(ih)
		
		TGlobalVariables->bFlagInitEditor_ForCallbacks = 1		
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

Function timer_open_include_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	IupSetAttribute(ih, "RUN", "NO")
	
	IupDestroy(ih)
	
	fl_open_include_files_proc()
	
	Return IUP_DEFAULT
	
End Function


' ############################################# KEYS ################################################

Function k_any_multitext_callback Cdecl ( ih As Ihandle Ptr, c As Integer) As Integer
	
	If c = K_INS Then
		
		If *IupGetAttribute(ih , "OVERWRITE") = "OFF" Then
			
			IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "INSLBL"), "TITLE" , "Ovr")
			
		Else
			
			IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "INSLBL"), "TITLE" , "Ins")
			
		Endif
		
	Elseif c = K_CR Then
		
		Dim As String sLine = *IupGetAttribute(ih , "LINEVALUE")
		
		If atc_check_simbol_underscore_proc(sLine) = 0 Then
			
			TGlobalVariables->bLineAutocomplect = 1
			
		Endif
		
	Elseif c = K_cS Then
		
		item_save_callback(0)
		
		Return IUP_IGNORE
		
	Else 
		
		ac_parser_keys_proc(ih , c)
		
	Endif
	
	Return IUP_CONTINUE
	
End Function

Function k_any_dialog_callback Cdecl ( ih As Ihandle Ptr, c As Integer) As Integer
	
	hkey_hotkeys_proc(c)
	
	Select Case c
			#ifdef __fb_win32__
				Case K_cL , K_cU , K_F3 , K_cF3
			#else
				Case K_cL , K_cU , 805371424 , K_cZ , K_cY , K_cX , K_cC , K_cV , K_cA , K_F3 , K_cF3
			#endif
			
			Return IUP_IGNORE
			
	End Select
	
	Return IUP_CONTINUE
	
End Function

' ############################################# TABS ################################################


Function tab_change_pos_callback Cdecl ( ih As Ihandle Ptr, new_tab As Integer, old_tab As Integer) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	tmr_update_after_changes()
	
	IupSetStrAttribute(TGlobalVariables->tTabsOptions(new_tab).multitext, "PRGNOACTIVE", "0")
	
	Return IUP_DEFAULT
	
End Function

' close tabs
Function tab_close_callback Cdecl ( ih As Ihandle Ptr, iPos As Integer) As Integer
	
	If pProject.iProjectLoad Then
		
		tbs_item_close_proc(iPos , , 1)
		
	Else
		
		tbs_item_close_proc(iPos)
		
	Endif
	
	IupSetAttribute(TGlobalVariables->hTimerUpdateBiFiles, "RUN", "YES")
	
	Return IUP_IGNORE
	
End Function

' move tab
Function tab_flat_button_callback Cdecl (ih As Ihandle Ptr, ibutton As Integer, ipressed As Integer, ix As Integer, iy As Integer, pszstatus As Zstring Ptr ) As Integer
	
	If ibutton = IUP_BUTTON1 Then
		
		Dim As Long iPos_2 = IupConvertXYToPos(ih, ix, iy)
		
		If iPressed = 1 Then ''' moving tab
			
			IupSetInt(ih, "positondrag1", iPos_2)
			
			IupSetAttribute(ih, "CURSOR" , "MOVE")
			
		Elseif iPressed = 0 Then
			
			Dim As Integer iPos_1 = IupGetInt(ih, "positondrag1")
			
			If (iPos_1 <> -1 And iPos_2 <> -1) And (iPos_1 <> iPos_2) Then
				
				Dim As Integer iPos_10, iPos_20
				
				Dim As Integer iStep = Iif(iPos_1 < iPos_2, 1, -1)
				
				If iPos_1 > Ubound(TGlobalVariables->tTabsOptions) Orelse _
				iPos_2 > Ubound(TGlobalVariables->tTabsOptions) Orelse _
				iPos_1 < 0 Orelse iPos_2 < 0 Then 
					
					Return IUP_DEFAULT
					
				Endif
				
				For j As Integer = iPos_1 To iPos_2 - iStep Step iStep
					
					iPos_10 = j
					iPos_20 = j+iStep
					
					Dim As Ihandle Ptr vboxParentTab1, vboxParentTab2
					
					Dim As String sTitleTab1 = *IupGetAttributeId(ih, "TABTITLE", iPos_10)				
					Dim As String sTitleTab2 = *IupGetAttributeId(ih, "TABTITLE", iPos_20)
					
					If TGlobalVariables->tTabsOptions(iPos_10).multitext = 0 Orelse _
					TGlobalVariables->tTabsOptions(iPos_20).multitext = 0 Orelse _
					Len(sTitleTab1) = 0 Orelse Len(sTitleTab2) = 0 Then
						
						Exit For
						
					Endif
					
					vboxParentTab1 = IupGetParent(TGlobalVariables->tTabsOptions(iPos_10).multitext)
					vboxParentTab2 = IupGetParent(TGlobalVariables->tTabsOptions(iPos_20).multitext)	
					
					If vboxParentTab1 = 0 Orelse vboxParentTab2 = 0 Then
						
						Exit For
						
					Endif
					
					IupReparent(TGlobalVariables->tTabsOptions(iPos_10).multitext, vboxParentTab2, NULL)
					IupReparent(TGlobalVariables->tTabsOptions(iPos_20).multitext, vboxParentTab1, NULL)
					
					Swap TGlobalVariables->tTabsOptions(iPos_10),TGlobalVariables->tTabsOptions(iPos_20)
					
					IupSetStrAttributeId(ih, "TABTITLE", iPos_10, sTitleTab2 )
					IupSetStrAttributeId(ih, "TABTITLE", iPos_20, sTitleTab1 )
					
					IupRefresh(ih)						
					
				Next			
				
				IupSetInt(ih, "VALUEPOS", iPos_2)
				
				IupSetInt(ih, "positondrag1", -1)
				
				IupUpdate(ih)
				
			Endif
			
			IupSetAttribute(ih, "CURSOR" , "ARROW")
			
		Endif
		
	Endif
	
	Return IUP_DEFAULT
	
End Function



' ################################## ENCODIND #########################################


Function select_default_system_menu_callback Cdecl ( ih As Ihandle Ptr) As Integer
	
	enc_select_default_system_encoding_dialog_proc ()
	
	Return IUP_DEFAULT
	
End Function

Function re_open_file_as_encoding_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	fl_re_open_file_proc(IupGetAttribute(ih, "IDMENUENC"))
	
	Return IUP_DEFAULT
	
End Function

Function set_encoding_file_for_save_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	IupSetStrAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "CURRENTENCODING", IupGetAttribute(ih, "IDMENUENC"))
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "ENCLBL"), "TITLE" , *IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "CURRENTENCODING"))
	
	Return IUP_DEFAULT
	
End Function

' Convert the editor text in the selecting encoding on fly
Function convert_document_as_encoding_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return IUP_DEFAULT
	
	Return enc_convert_document_as_encoding_proc(ih)
	
End Function

Function numbers_encoding_in_the_menu_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	enc_encoding_dialog_proc ()
	
	Return IUP_DEFAULT
	
End Function

' Create\Call Popup menu "Encoding"
Function encoding_menu_popup_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	Return mn_encoding_menu_popup_proc(ih)
	
End Function

' Processing checkboxs from dialogue "count encodings in the menu"
Function encoding_check_callback Cdecl(ih As Ihandle Ptr, state As Integer) As Integer
	
	If state = 1 Then
		
		bEncodingBool(Val(*IupGetAttribute(ih, "IDCHECKBUTTONS"))) = 1
		
	Else
		
		bEncodingBool(Val(*IupGetAttribute(ih, "IDCHECKBUTTONS"))) = 0
		
	Endif
	
	Dim As Zstring*123 szCountEncodeItems 
	
	For i As Long = 0 To 121
		
		szCountEncodeItems &= bEncodingBool(i)
		
	Next
	
	IupConfigSetVariableStr(TGlobalVariables->hConfig,"CountEncodeItems","CountEncode",szCountEncodeItems)
	
	Return IUP_DEFAULT
	
End Function

' Processing radiobuttons from dialogue "system default encoding"
Function encoding_radio_check_callback Cdecl(ih As Ihandle Ptr, state As Integer) As Integer
	
	If state = 1 Then
		
		TGlobalVariables->szDefaultSystemEncoding = szEncodingString(Val(*IupGetAttribute(ih, "IDCHECKBUTTONS")))
		
	Endif
	
	IupConfigSetVariableStr(TGlobalVariables->hConfig,"SystemDefaultEncode","DefaultEncode",TGlobalVariables->szDefaultSystemEncoding)
	
	Return IUP_DEFAULT
	
End Function

' Destroy dialogs "System default encoding" OR "Count encodings in the menu"
Function encoding_check_exit_action_callback Cdecl(ih As Ihandle Ptr ) As Integer
	
	mn_update_mainmenu_after_options_encoding_proc()
	
	IupDestroy(ih)
	
	Return IUP_IGNORE
	
End Function


' ############################### Options ######################################

' Options menu Edit
Function item_options_edit_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	optdlg_create_dialog_proc()
	
	Return IUP_DEFAULT
	
End Function

' Options menu Build
Function item_options_build_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If TGlobalVariables->tool_dlg = 0 Then
		
		optdlg_create_tool_dialog_proc(1)
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

' Options menu TOOLS
Function item_options_tools_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If TGlobalVariables->tool_dlg = 0 Then
		
		optdlg_create_tool_dialog_proc(3)
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

' Options menu HELP
Function item_options_helps_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If TGlobalVariables->tool_dlg = 0 Then
		
		optdlg_create_tool_dialog_proc(2)
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

' Options checkbox (font style group)
Function action_checkbox_style_group_callback Cdecl (ih As Ihandle Ptr , iState As Integer) As Integer
	
	optdlg_set_checkbox_style_font_group_proc(ih , iState)
	
	Return IUP_DEFAULT
	
End Function

'--------------------------- colors \theme------------------------------

' ' Processing "color" buttons for setting COLOR
Function options_select_color_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	Dim As String szColor = optdlg_get_color_dlg_proc(*IupGetAttribute(ih, "BGCOLOR"))
	
	If szColor = "" Then Return IUP_DEFAULT
	
	Dim As String szNamebtn = *IupGetAttribute(ih ,"NAME")
	
	Dim As String szTheme
	
	Dim As Zstring Ptr pszColTheme , pszColAlpha , pszColThemeAnother
	
	Dim As Long iIndex = Val(Mid(szNamebtn,4))
	
	If iIndex > 8 Then
		
		iIndex = (Val(Mid(szNamebtn,2,1))-1)*2 + (iIndex-8) + 32
		
	Else
		
		iIndex = (Val(Mid(szNamebtn,2,1))-1)*8 + iIndex
		
	Endif
	
	TGlobalVariables->szColorbtn(iIndex) = szColor
	
	IupSetAttribute(ih, "BGCOLOR" , TGlobalVariables->szColorbtn(iIndex))
	
	szTheme = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "VALUE")
	
	pszColTheme = IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme"),"b" & szTheme)	
	
	pszColThemeAnother = IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme"),"f" & szTheme)
	
	For i As Long = 1 To 8
		
		Mid( *pszColTheme , (i-1)*16+1 , 7) = TGlobalVariables->szColorbtn(i)
		
		Mid( *pszColTheme , (i-1)*16+9 , 7) = TGlobalVariables->szColorbtn(i+8)
		
		Mid( *pszColTheme , (i-1)*16+129 , 7) =  TGlobalVariables->szColorbtn(i+16)
		
		Mid( *pszColTheme , (i-1)*16+137 , 7) =  TGlobalVariables->szColorbtn(i+24)			
		
	Next
	
	For i As Long = 1 To 2
		
		Mid( *pszColThemeAnother , (i-1)*16+1 , 7) = TGlobalVariables->szColorbtn(i+32)
		
		Mid( *pszColThemeAnother , (i-1)*16+9 , 7) = TGlobalVariables->szColorbtn(i+34)
		
		Mid( *pszColThemeAnother , (i-1)*16+33 , 7) =  TGlobalVariables->szColorbtn(i+36)
		
		Mid( *pszColThemeAnother , (i-1)*16+41 , 7) =  TGlobalVariables->szColorbtn(i+38)			
		
	Next		
	
	Return IUP_DEFAULT
	
End Function

' Select THEME
Function options_combo_select_theme_callback Cdecl (ih As Ihandle Ptr, pszText As Zstring Ptr, iItem As Integer, iState As Integer) As Integer
	
	If iState = 1 Then
		
		optdlg_get_theme_color_proc(1)
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

Function options_add_new_theme_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	Dim As Ihandle Ptr combo = IupGetDialogChild(TGlobalVariables->hOptions, "combotheme")
	
	Dim As Ihandle Ptr txt = IupGetDialogChild(TGlobalVariables->hOptions, "txtnewtheme")
	
	Dim As Integer iCount = Val(*IupGetAttribute( combo , "COUNT"))
	
	IupSetAttribute(combo , Str(iCount+1) , *IupGetAttribute(txt,"VALUE"))
	
	IupSetStrAttribute(combo , "b" & Str(iCount+1) , *IupGetAttribute(combo, ("b" & *IupGetAttribute(combo, "VALUE") )))
	
	IupSetStrAttribute(combo , "f" & Str(iCount+1) , *IupGetAttribute(combo, ("f" & *IupGetAttribute(combo, "VALUE") )))
	
	IupSetStrAttribute(combo , "ba" & Str(iCount+1) , *IupGetAttribute(combo, ("ba" & *IupGetAttribute(combo, "VALUE") )))
	
	IupSetStrAttribute(combo , "bold" & Str(iCount+1) , *IupGetAttribute(combo, ("bold" & *IupGetAttribute(combo, "VALUE") )))
	
	IupSetStrAttribute(combo , "italic" & Str(iCount+1) , *IupGetAttribute(combo, ("italic" & *IupGetAttribute(combo, "VALUE") )))
	
	IupSetAttribute(combo, "VALUE" , Str(iCount+1))
	
	IupSetAttribute(txt, "VALUE" , "")
	
	Return IUP_DEFAULT
	
End Function

'--------------------------- path ------------------------------

Function option_btn_path_compilier_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	#ifdef __fb_win32__
		
		Dim As String sPath  = fdlg_dlg_open_proc(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionpathcompilier") , _
		!"Compiler (fbc.exe)|*fbc.exe|EXE files|*.exe*|" , TGlobalVariables->hOptions)
		
	#else
		
		Dim As String sPath  = fdlg_dlg_open_proc(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionpathcompilier") , _
		!"All files|**|", TGlobalVariables->hOptions)
		
	#endif
	
	If Len(sPath) Then
		
		sPath = enc_encode_path_proc(sPath , 1)
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtcomppath") , "VALUE" ,  sPath)
		
	Endif
	'
	Return IUP_DEFAULT
	
End Function

Function option_btn_path_include_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	Dim As String sPath  = fdlg_dlg_opendir_proc(TGlobalVariables->hOptions)
	
	If Len(sPath) Then
		
		sPath = enc_encode_path_proc(sPath , 1)
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtincludepath") , "VALUE" ,  sPath)
		
	Endif
	'
	Return IUP_DEFAULT
	
End Function

Function option_btn_path_debugger_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	#ifdef __fb_win32__
		
		Dim As String sPath  = fdlg_dlg_open_proc(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionpathdebug") , _
		!"Debugger (.exe)|*.exe|All files|*.*|",TGlobalVariables->hOptions)		
		
	#else
		
		Dim As String sPath  = fdlg_dlg_open_proc(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionpathdebug") , _
		!"All files|**|" , TGlobalVariables->hOptions)		
		
	#endif
	
	If Len(sPath) Then
		
		sPath = enc_encode_path_proc(sPath , 1)
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtdebugpath") , "VALUE" ,  sPath)
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

' --------------------- Actions with dialog Options Editor ------------------------------ 
Function option_apply_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	optdlg_apply_proc()
	
	Return IUP_DEFAULT
	
End Function

Function option_ok_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	optdlg_apply_proc()
	
	optdlg_ok_proc()
	
	IupDestroy(TGlobalVariables->hOptions)
	
	TGlobalVariables->hOptions = 0
	
	Return IUP_DEFAULT
	
End Function

Function option_cancel_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	optdlg_reset_proc()
	
	IupDestroy(TGlobalVariables->hOptions)
	
	TGlobalVariables->hOptions = 0
	
	Return IUP_DEFAULT
	
End Function

Function options_close_action_callback Cdecl (dlg As Ihandle Ptr) As Integer
	
	optdlg_reset_proc()
	
	IupDestroy(TGlobalVariables->hOptions)
	
	TGlobalVariables->hOptions = 0
	
	Return IUP_IGNORE
	
End Function

' ----------------------------Actions with dialog TOOL------------------------
Function options_close_tool_callback Cdecl (dlg As Ihandle Ptr) As Integer
	
	optdlg_tool_btncancel_proc()
	
	TGlobalVariables->tool_dlg = 0
	
	Return IUP_DEFAULT
	
End Function

Function options_tool_action_list_callback Cdecl (ih As Ihandle Ptr , pszText As Zstring Ptr , iItem As Integer , iState As Integer) As Integer 
	
	If iState = 1 Then
		
		optdlg_tool_list_action_proc(iItem)
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

Function options_tool_action_btnup_callback Cdecl (ih As Ihandle Ptr) As Integer 
	
	optdlg_tool_btnup_proc()
	
	Return IUP_DEFAULT
	
End Function

Function options_tool_action_btndown_callback Cdecl (ih As Ihandle Ptr) As Integer 
	
	optdlg_tool_btndown_proc()
	
	Return IUP_DEFAULT
	
End Function

Function options_tool_action_btnok_callback Cdecl (ih As Ihandle Ptr) As Integer 
	
	optdlg_tool_btnok_proc()
	
	IupDestroy(TGlobalVariables->tool_dlg)
	
	TGlobalVariables->tool_dlg = 0	
	
	Return IUP_DEFAULT
	
End Function

Function options_tool_action_btncancel_callback Cdecl (ih As Ihandle Ptr) As Integer 
	
	optdlg_tool_btncancel_proc()
	
	IupDestroy(TGlobalVariables->tool_dlg)
	
	TGlobalVariables->tool_dlg = 0
	
	Return IUP_DEFAULT
	
End Function

Function options_tool_action_btninsert_callback Cdecl (ih As Ihandle Ptr) As Integer 
	
	optdlg_tool_btninsert_proc()
	
	Return IUP_DEFAULT
	
End Function

Function options_tool_action_btnedit_callback Cdecl (ih As Ihandle Ptr) As Integer 
	
	optdlg_tool_btnedit_proc()
	
	Return IUP_DEFAULT
	
End Function

Function options_tool_action_btndelete_callback Cdecl (ih As Ihandle Ptr) As Integer 
	
	optdlg_tool_btndelete_proc()
	
	Return IUP_DEFAULT
	
End Function

Function options_tool_action_btnpath_callback Cdecl (ih As Ihandle Ptr) As Integer 
	
	#ifdef __fb_win32__
		
		Dim As String sPath  = fdlg_dlg_open_proc("" , _
		!"\"*.*\"" , TGlobalVariables->tool_dlg)
		
	#else
		
		Dim As String sPath  = fdlg_dlg_open_proc("" , _
		!"\"**\"" , TGlobalVariables->tool_dlg)	
		
	#endif
	
	If Len(sPath) Then
		
		sPath = enc_encode_path_proc(sPath , 1)
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->tool_dlg, "tooltxt2") , "VALUE" ,  sPath)
		
	Endif	
	
	Return IUP_DEFAULT
	
End Function

'-------------------------------------- FONTS --------------------------------------

' Selecting a font editor
Function options_select_fontedit_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	Dim As Ihandle Ptr txt = IupGetDialogChild(TGlobalVariables->hOptions, "ftxtedit")
	
	Dim As String sFont = fntdlg_font_dialog_proc ( IupGetAttribute(txt , "VALUE") )
	
	If Len(sFont) Then
		
		IupSetAttribute(txt , "VALUE" , sFont )
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

' Selecting a font window output info (compilation, search)	
Function options_select_fontwinout_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	Dim As Ihandle Ptr txt = IupGetDialogChild(TGlobalVariables->hOptions, "ftxtwinout")
	
	Dim As String sFont = fntdlg_font_dialog_proc ( IupGetAttribute(txt , "VALUE") )
	
	If Len(sFont) Then
		
		IupSetAttribute(txt , "VALUE" , sFont )	
		
	Endif	
	
	Return IUP_DEFAULT
	
End Function

' Selecting a font STATUSBAR
Function options_select_fontstatus_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	Dim As Ihandle Ptr txt = IupGetDialogChild(TGlobalVariables->hOptions, "ftxtstatus")
	
	Dim As String sFont = fntdlg_font_dialog_proc ( IupGetAttribute(txt , "VALUE") )
	
	If Len(sFont) Then	
		
		IupSetAttribute(txt , "VALUE" , sFont )		
		
	Endif	
	
	Return IUP_DEFAULT
	
End Function

' Selecting a font winside
Function options_select_fontwinside_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	Dim As Ihandle Ptr txt = IupGetDialogChild(TGlobalVariables->hOptions, "ftxtwinside")
	
	Dim As String sFont = fntdlg_font_dialog_proc ( IupGetAttribute(txt , "VALUE") )
	
	If Len(sFont) Then
		
		IupSetAttribute(txt , "VALUE" , sFont )
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

' Selecting a font annotation
Function options_select_fontannot_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	Dim As Ihandle Ptr txt = IupGetDialogChild(TGlobalVariables->hOptions, "ftxtannot")
	
	Dim As String sFont = fntdlg_font_dialog_proc ( IupGetAttribute(txt , "VALUE") )
	
	If Len(sFont) Then
		
		IupSetAttribute(txt , "VALUE" , sFont )
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

' Selecting a font TABS
Function options_select_fonttabs_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	Dim As Ihandle Ptr txt = IupGetDialogChild(TGlobalVariables->hOptions, "ftxttabs")
	
	Dim As String sFont = fntdlg_font_dialog_proc ( IupGetAttribute(txt , "VALUE") )
	
	If Len(sFont) Then
		
		IupSetAttribute(txt , "VALUE" , sFont )
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

'-------------------------------------- Parser --------------------------------------

Function option_disable_parser_callback Cdecl (ih As Ihandle Ptr , iState As Integer) As Integer
	
	If iState = 1 Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_autokeyword") , "ACTIVE", "YES")
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_autoas") , "ACTIVE", "YES")		
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_autoft") , "ACTIVE", "YES")
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_tips") , "ACTIVE", "YES")
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_delaytips") , "ACTIVE", "YES")
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "updownlenghtword") , "ACTIVE", "YES")
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "updownprsms") , "ACTIVE", "YES")	
		
		If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_delaytips") , "VALUE") = "ON" Then
			
			IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "updowntipsms") , "ACTIVE", "YES") 
			
		Else
			
			IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "updowntipsms") , "ACTIVE", "NO") 
			
		Endif
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_autokeyword") , "ACTIVE", "NO")
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_autoas") , "ACTIVE", "NO")		
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_autoft") , "ACTIVE", "NO")
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_tips") , "ACTIVE", "NO")
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_delaytips") , "ACTIVE", "NO")
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "updownlenghtword"), "ACTIVE", "NO")
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "updownprsms"), "ACTIVE", "NO")	
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "updowntipsms"), "ACTIVE", "NO")	
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

Function option_enable_delaytips_callback Cdecl (ih As Ihandle Ptr , iState As Integer) As Integer
	
	If iState = 1 Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "updowntipsms") , "ACTIVE", "YES")	
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "updowntipsms"), "ACTIVE", "NO")	
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

Function option_select_tips_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If ih = IupGetDialogChild(TGlobalVariables->hOptions, "radiotips1") Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "B1_9") , "VISIBLE" , "NO")
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "B2_9") , "VISIBLE" , "NO")
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "B3_9") , "VISIBLE" , "NO")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "B1_9") , "VISIBLE" , "YES")
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "B2_9") , "VISIBLE" , "YES")
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "B3_9") , "VISIBLE" , "YES")
		
	Endif
	
	Return IUP_DEFAULT
	
End Function


'-------------------------------------- PLUGINS --------------------------------------

' exit dialog setting plugins
Function plugin_setting_exit_callback Cdecl(ih As Ihandle Ptr ) As Integer
	
	IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitlewarning"),_
	*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstextlangreboot"))
	
	IupDestroy(ih)
	
	Return IUP_IGNORE
	
End Function

Function plugin_setting_action_callback Cdecl(ih As Ihandle Ptr, state As Integer) As Integer
	
	If state = 1 Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig, "Plugins" ,*IupGetAttribute(ih , "NAMEPLUGIN"), "1")
		
	Else
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig, "Plugins" ,*IupGetAttribute(ih , "NAMEPLUGIN"), "0")
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

Function item_open_setting_dialog_plugin_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	plg_PluginSettingDialogProc()
	
	Return IUP_DEFAULT
	
End Function

'-------------------------------------- PROJECT --------------------------------------

' close dialog project
Function project_dlgoption_close_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	IupDestroy(ih)
	
	Return IUP_IGNORE
	
End Function

' select path to project
Function project_btn_path_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	Dim As iHandle Ptr hParent = IupGetDialog(ih)
	
	Dim As String sPath  = fdlg_dlg_opendir_proc(hParent)
	
	If Len(sPath) Then
		
		sPath = enc_encode_path_proc(sPath , 1)
		
		IupSetAttribute(IupGetDialogChild(IupGetDialog(ih), "txtprjpath") , "VALUE" ,  sPath)
		
	Endif	
	
	Return IUP_DEFAULT
	
End Function

' press OK in the dialog create\edit
Function project_btn_ok_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	prj_create_or_edit_proc(ih)
	
	Return IUP_DEFAULT
	
End Function

' press CANCEL in the dialog create\edit
Function project_btn_cancel_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	IupDestroy(IupGetDialog(ih))
	
	Return IUP_DEFAULT
	
End Function

' press OK in the dialog add file
Function project_btn_ok_add_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	prj_add_file_in_project_proc(ih)
	
	Return IUP_DEFAULT
	
End Function

' press CANCEL in the dialog add file
Function project_btn_cancel_add_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	IupDestroy(IupGetDialog(ih))
	
	Return IUP_DEFAULT
	
End Function

' press OK in the dialog rename
Function project_btn_ok_rename_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	prj_rename_file(ih)
	
	Return IUP_DEFAULT
	
End Function

' press CANCEL in the dialog rename
Function project_btn_cancel_rename_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	IupDestroy(IupGetDialog(ih))
	
	Return IUP_DEFAULT
	
End Function

' menu new project
Function item_projectnew_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	If pProject.iProjectLoad = 0 Then
		
		prj_dialog_proc(1)
		
	Else
		
		IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitlewarning"),_
		*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgprjnotclose"))		
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

' menu open project
Function item_projectopen_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	If pProject.iProjectLoad = 0 Then
		
		prj_open_project_proc("")
		
	Else
		
		IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitlewarning"),_
		*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgprjnotclose"))
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

' menu close project
Function item_projectclose_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	If pProject.iProjectLoad = 1 Then
		
		prj_close_proc()
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

' menu add new file in the project 
Function item_project_addnewfile_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	If pProject.iProjectLoad = 1 Then
		
		prj_dialog_add_file_proc(0)
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

' menu add new module in the project 
Function item_project_addnewmodule_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	If pProject.iProjectLoad = 1 Then
		
		prj_dialog_add_file_proc(1)
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

' menu add existing file in the project
Function item_project_addexfile_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	If pProject.iProjectLoad = 1 Then
		
		prj_add_EX_file_in_project_proc(0)
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

' menu add existing module in the project
Function item_project_addexmodule_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	If pProject.iProjectLoad = 1 Then
		
		prj_add_EX_file_in_project_proc(1)
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

' menu make curent file to main 
Function item_project_do_curent_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	prj_set_main_curent()
	
	Return IUP_DEFAULT
	
End Function

' menu delete curent file from project
Function item_project_deletecurent_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	Dim As Long iModule
	
	Dim As String sFile
	
	sFile = prj_get_file_from_winside_or_tabs(iModule)
	
	If Len(sFile) Then
		
		prj_delete_file(sFile)
		
	Endif	
	
	Return IUP_DEFAULT
	
End Function

' menu rename curent file in the project
Function item_project_renamecurent_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	Dim As Long iModule
	
	Dim As String sFile
	
	sFile = prj_get_file_from_winside_or_tabs(iModule)
	
	If Len(sFile) Then
		
		prj_dialog_rename_file_proc(iModule , sFile)
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

' options project
Function item_project_options_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	If pProject.iProjectLoad = 1 Then
		
		prj_dialog_proc(0)
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

' --------------------- EXE startup options -------------------

Function com_close_action_callback Cdecl(dlg As Ihandle Ptr) As Integer 
	
	Return IUP_DEFAULT
	
End Function

Function com_btnok_action_callback Cdecl(btn As Ihandle Ptr) As Integer 
	
	Dim As ihandle Ptr dlg = IupGetDialog(btn)
	
	Dim As ihandle Ptr txt = IupGetDialogChild(dlg, "COM_TXT")

	If txt Then
		
		Dim As Zstring Ptr pszText = IupGetAttribute(txt, "VALUE")
		
		If pszText Then
			
			IupConfigSetVariableStr(TGlobalVariables->hConfig, "BUILD", "comexeparams", *pszText)
			
		Endif
		
	Endif
	
	If dlg Then
		
		IupDestroy(dlg)
		
	Endif
	
	Return IUP_DEFAULT
	
End Function

Function com_btncancel_action_callback Cdecl(btn As Ihandle Ptr) As Integer 
	
	Dim As ihandle Ptr dlg = IupGetDialog(btn)
	
	If dlg Then
		
		IupDestroy(dlg)
		
	Endif
	
	Return IUP_DEFAULT
	
End Function