function cmt_multi_comments_line_positions_proc(mt as iHandle ptr) as TMultiCommentsLinePositions ptr
	
	Dim As Integer iCount = IupGetInt(mt, "LINECOUNT")
	
	dim as Long iFindStart , iFindEnd  , iLineB 
	
	if iCount < 2 then return 0
	
	dim as TMultiCommentsLinePositions ptr NewList = New TMultiCommentsLinePositions
	
	for i as Long = 0 to iCount	- 1
		
		Dim As ZString Ptr pszText = IupGetAttributeId(mt, "LINE", i )
		
		if pszText andalso len(*pszText) > 2 andalso iFindStart = 0 then
			
			dim as Long iFindBackup
			
			do
			
				iFindStart = instr(iFindBackup+1 , *pszText , "/'")
				
				iFindBackup = iFindStart
				
				if iFindStart then
				
					dim as Long iChr34 = iFindStart , iNChr34
					
					do
						
						iChr34 = instrrev(*pszText , """" , iChr34-1)
						
						if iChr34 then
							
							iNChr34 +=1
							
						else
						
							exit do
							
						EndIf
						
					Loop
					
					if 1 and iNChr34 then
					
						iFindStart = 0
					
					else
				
						iFindEnd = instr(*pszText , "'/")
						
						iLineB = i
						
						if iFindEnd then
							
							NewList->addlast(iLineB , i)
							
							iFindStart = 0
							
						EndIf
						
						exit do
						
					endif
					
				else
				
					exit do
				
				EndIf
			
			loop
		
		elseif iFindStart then	
		
			iFindEnd = instr(*pszText , "'/")
			
			if iFindEnd then
				
				NewList->addlast(iLineB , i)
				
				iFindStart = 0
				
			EndIf
		
		EndIf
		
	Next
	
	if NewList->iCount then
		
		return NewList
		
	else
		
		delete NewList
		
	EndIf
	
End Function

Sub cmt_uncomment_proc() export
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As Integer iStartPos, iEndPos , iLineBeg , iLineEnd 
	
	IupGetIntInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "SELECTIONPOS", cast(any ptr,@iStartPos), cast(any ptr,@iEndPos))
	
	IupGetIntInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "SELECTION", cast(any ptr,@iLineBeg), cast(any ptr,@iLineEnd))
	
	Dim As ZString Ptr pszText = IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "SELECTEDTEXT")	
	
	If pszText = 0 orelse Len(*pszText) = 0 Then 
		
		Dim As integer iPos = IupGetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "CARETPOS")
		
		Dim As Integer iLineCur, iColumnCur , iLen , iPos0
		
		IupTextConvertPosToLinCol(TGlobalVariables->tTabsOptions(idTabs).multitext, iPos, cast(any ptr,@iLineCur), cast(any ptr,@iColumnCur))	
		
		Dim As ZString Ptr pszText = IupGetAttributeId(TGlobalVariables->tTabsOptions(idTabs).multitext, "LINE", iLineCur)
		
		if pszText then
			
			iLen = Len(*pszText)
			
		EndIf

		For i As Long = 0 To iLen - 1
			
			Select Case (*pszText)[i] 
					
				case 9,32
					
				Case Asc("'")
					
					iColumnCur = CInt(i)
					
					Exit For
					
				Case Else
					
					iColumnCur = -1
					
					Exit For
					
			End Select
			
		Next
		
		If iColumnCur <> -1 Then
			
			IupTextConvertLinColToPos(TGlobalVariables->tTabsOptions(idTabs).multitext,iLineCur,iColumnCur , cast(any ptr,@iPos0))
			
			IupSetStrf(TGlobalVariables->tTabsOptions(idTabs).multitext, "DELETERANGE", !"%d,%d", iPos0, 1)		
			
		EndIf
		
	Else
		
		Dim As Integer  iColumnCur , iLen , iPos0
		
		IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "BEGIN")
		
		For j As Long = iLineBeg To iLineEnd
			
			iColumnCur = 0
			
			Dim As ZString Ptr pszText = IupGetAttributeId(TGlobalVariables->tTabsOptions(idTabs).multitext, "LINE", CInt(j))
			
			if pszText then
				
				iLen = Len(*pszText)
				
			EndIf

			For i As Long = 0 To iLen - 1
				
				Select Case (*pszText)[i] 
						
					case 9,32
						
					Case Asc("'")
						
						iColumnCur = CInt(i)
						
						Exit For
						
					Case Else
						
						iColumnCur = -1
						
						Exit For
						
				End Select
				
			Next		
			
			If iColumnCur <> -1 Then
				
				IupTextConvertLinColToPos(TGlobalVariables->tTabsOptions(idTabs).multitext, CInt(j) , iColumnCur , cast(any ptr,@iPos0))
				
				IupSetStrf(TGlobalVariables->tTabsOptions(idTabs).multitext, "DELETERANGE", !"%d,%d", iPos0, 1)
				
			EndIf
			
		Next
		
		IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "END")
		
		IupSetStrf(TGlobalVariables->tTabsOptions(idTabs).multitext, "SELECTIONPOS", !"%d:%d", iStartPos-1, iEndPos-(iLineEnd-iLineBeg)-1)
		
	EndIf
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "ISCHANGES", "YES")
	
End Sub

Sub cmt_comment_proc() export
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As Integer iStartPos, iEndPos , iLineBeg , iLineEnd 
	
	IupGetIntInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "SELECTIONPOS", cast(any ptr,@iStartPos), cast(any ptr,@iEndPos))
	
	IupGetIntInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "SELECTION", cast(any ptr,@iLineBeg), cast(any ptr,@iLineEnd))
	
	Dim As ZString Ptr pszText = IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "SELECTEDTEXT")	
	
	If pszText = 0 orelse Len(*pszText) = 0 Then 
		
		Dim As integer iPos = IupGetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "CARETPOS")
		
		Dim As Integer iLineCur, iColumnCur , iLen , iPos0
		
		IupTextConvertPosToLinCol(TGlobalVariables->tTabsOptions(idTabs).multitext, iPos, cast(any ptr,@iLineCur), cast(any ptr,@iColumnCur))	
		
		Dim As ZString Ptr pszText = IupGetAttributeId(TGlobalVariables->tTabsOptions(idTabs).multitext, "LINE", iLineCur)
		
		if pszText then
			
			iLen = Len(*pszText)
			
		EndIf
		
		For i As Long = 0 To iLen - 1
			
			Select Case (*pszText)[i] 
					
				case 9,32
					
				Case Else
					
					iColumnCur = CInt(i)
					
					Exit For
					
			End Select
			
		Next
		
		IupTextConvertLinColToPos(TGlobalVariables->tTabsOptions(idTabs).multitext,iLineCur,iColumnCur , cast(any ptr,@iPos0))
		
		IupSetAttributeId(TGlobalVariables->tTabsOptions(idTabs).multitext, "INSERT", iPos0, "'")	
		
	Else
		
		Dim As Integer  iColumnCur , iLen , iPos0
		
		IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "BEGIN")
		
		For j As Long = iLineBeg To iLineEnd
			
			iColumnCur = 0
			
			Dim As ZString Ptr pszText = IupGetAttributeId(TGlobalVariables->tTabsOptions(idTabs).multitext, "LINE", CInt(j))
			
			if pszText then
				
				iLen = Len(*pszText)
				
				For i As Long = 0 To iLen - 1
					
					Select Case (*pszText)[i] 
							
						case 9,32
							
						Case Else
							
							iColumnCur = CInt(i)
							
							Exit For
							
					End Select
					
				Next
				
			EndIf				
			
			IupTextConvertLinColToPos(TGlobalVariables->tTabsOptions(idTabs).multitext, CInt(j) , iColumnCur , cast(any ptr,@iPos0))
			
			IupSetAttributeId(TGlobalVariables->tTabsOptions(idTabs).multitext, "INSERT", iPos0, "'")

		Next
		
		IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "END")
		
		IupSetStrf(TGlobalVariables->tTabsOptions(idTabs).multitext, "SELECTIONPOS", !"%d:%d", iStartPos+1, iEndPos+(iLineEnd-iLineBeg)+1)
		
	EndIf
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "ISCHANGES", "YES")
	
End Sub
