Sub cnf_set_info_recent_prj_and_find_in_config()
	
	If tRecentProjectInfo->iIndex Then
		
		Dim As TQueueList Ptr p = tRecentProjectInfo->pF
		
		For i As Long = 1 To 10
			
			IupConfigSetVariableStr(TGlobalVariables->hConfig, "RecentPr" , "n" & i , " ")
			
		Next
		
		For i As Long = 1 To tRecentProjectInfo->iIndex
			
			Dim As String sPath
			
			If p Andalso p->psPath Then
				
				sPath = *(p->psPath)
				
				p = p->p
				
			Endif
			
			If Len(sPath) Andalso Fileexists(tRecentProjectInfo->GetPath(Strptr(sPath))) = -1 Then
				
				IupConfigSetVariableStr(TGlobalVariables->hConfig, "RecentPr" , "n" & i , Strptr(sPath))
				
			Endif
			
		Next
		
	Endif
	
	If tRecentFindInfo->iIndex Then
		
		Dim As TQueueList Ptr p = tRecentFindInfo->pF
		
		For i As Long = 1 To 10
			
			IupConfigSetVariableStr(TGlobalVariables->hConfig, "RecentFind" , "n" & i , " ")
			
		Next
		
		For i As Long = 1 To tRecentFindInfo->iIndex
			
			Dim As String sPath
			
			If p Andalso p->psPath Then
				
				sPath = *(p->psPath)
				
				p = p->p
				
			Endif
			
			If Len(sPath) Then
				
				IupConfigSetVariableStr(TGlobalVariables->hConfig, "RecentFind" , "n" & i , Strptr(sPath))
				
			Endif
			
		Next
		
	Endif	
	
End Sub

Sub cnf_get_info_recent_prj_and_find_from_config()
	
	For i As Long = 10 To 1 Step -1
		
		Dim As String sPath = *IupConfigGetVariableStr(TGlobalVariables->hConfig, "RecentPr" , "n" & i)
		
		If Len(sPath) > 4 Then
			
			If Fileexists(tRecentProjectInfo->GetPath(Strptr(sPath))) = -1 Then
				
				tRecentProjectInfo->AddQueue(sPath)
				
			Endif
			
		Endif
		
		sPath = *IupConfigGetVariableStr(TGlobalVariables->hConfig, "RecentFind" , "n" & i)
		
		If Len(Trim(sPath)) Then
				
			tRecentFindInfo->AddQueue(sPath)
			
		Endif		
		
	Next
	
End Sub

Sub cnf_config_proc() Export
	
	TGlobalVariables->hConfig = IupConfig()
	
	TGlobalVariables->hConfigL = IupConfig()
	
	#ifdef __fb_win32__ 	
	
	IupSetAttribute(TGlobalVariables->hConfig, "APP_NAME", "s")
	
	IupSetAttribute(TGlobalVariables->hConfig, "APP_CONFIG", "YES")
	
	IupSetAttribute(TGlobalVariables->hConfig, "APP_PATH", "Option")
	
	#else
	
	IupSetAttribute(TGlobalVariables->hConfig, "APP_NAME", "cfg")
	
	IupSetAttribute(TGlobalVariables->hConfig, "APP_CONFIG", "YES")
	
	IupSetAttribute(TGlobalVariables->hConfig, "APP_PATH", "Options")			
	
	#endif
	
	IupConfigLoad(TGlobalVariables->hConfig)	
	
	TGlobalVariables->blangCurrent = Val(*IupConfigGetVariableStr(TGlobalVariables->hConfig,"Lang","current"))
	
	If TGlobalVariables->blangCurrent = 0 Then 
		
		TGlobalVariables->blangCurrent = 1
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Lang","current" , "1")
		
	Endif
	
	Dim As Zstring*4 szTemp = "id" & TGlobalVariables->blangCurrent
	
	TGlobalVariables->szLangid = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Lang",szTemp)
	
	If TGlobalVariables->szLangid = "" Then 
		
		TGlobalVariables->szLangid = "zEN"
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Lang" , "id1" , "zEN")
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Lang" , "id2" , "zRU")
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Lang" , "id3" , "zJP")
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Lang" , "id4" , "zES")
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Lang" , "id5" , "zFR")
		
	Endif
	
	szTemp = "n" & TGlobalVariables->blangCurrent

	TGlobalVariables->szLangName = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Lang",szTemp)
	
	If TGlobalVariables->szLangName = "" Then 
		
		TGlobalVariables->szLangName = "English"
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig, "Lang" , "n1" , "English")
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig, "Lang" , "n2" , "Русский")
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig, "Lang" , "n3" , "Japanese")
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig, "Lang" , "n4" , "Espanol")
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig, "Lang" , "n5" , "French")
		
	Endif
	
	Dim As Zstring*123 szCountEncodeItems = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"CountEncodeItems","CountEncode")
	
	For i As Long = 0 To 121
		
		bEncodingBool(i) = Val(Chr(szCountEncodeItems[i]))
		
	Next
	
	TGlobalVariables->szDefaultSystemEncoding = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"SystemDefaultEncode","DefaultEncode")
	
	#ifdef __fb_win32__ 	
	
	IupSetAttribute(TGlobalVariables->hConfigL, "APP_NAME", TGlobalVariables->szLangid)
	
	IupSetAttribute(TGlobalVariables->hConfigL, "APP_CONFIG", "YES")
	
	IupSetAttribute(TGlobalVariables->hConfigL, "APP_PATH", "lang/")
	
	IupSetAttribute(TGlobalVariables->hConfigplug, "APP_NAME", TGlobalVariables->szLangid)
	
	IupSetAttribute(TGlobalVariables->hConfigplug, "APP_CONFIG", "YES")
	
	IupSetAttribute(TGlobalVariables->hConfigplug, "APP_PATH", "lang/plug/")			
	
	
	#else
	
	IupSetAttribute(TGlobalVariables->hConfigL, "APP_NAME", "cfg")
	
	IupSetAttribute(TGlobalVariables->hConfigL, "APP_CONFIG", "YES")

	Static As Zstring*30 szPathLang
	
	szPathLang = "lang/" & TGlobalVariables->szLangid
	
	IupSetAttribute(TGlobalVariables->hConfigL, "APP_PATH", szPathLang)
	
	
	IupSetAttribute(TGlobalVariables->hConfigplug, "APP_NAME", "cfg")
	
	IupSetAttribute(TGlobalVariables->hConfigplug, "APP_CONFIG", "YES")

	Static As Zstring*30 szPathLang2
	
	szPathLang2 = "lang/plug/" & TGlobalVariables->szLangid
	
	IupSetAttribute(TGlobalVariables->hConfigplug, "APP_PATH", szPathLang2)	
		
	#endif
	
	IupConfigLoad(TGlobalVariables->hConfigL)
	
	IupConfigLoad(TGlobalVariables->hConfigplug)
	
	cnf_get_info_recent_prj_and_find_from_config()
	
End Sub