
Function misc_replace_string_proc (Byval sString As String, Byval sSearchStr As String, Byval sReplaceStr As String, Byval iPosition As Integer = 1 , Byval iSearchParam As Integer = 0 ) As String Export 
	
	Dim As String szTempString , sReturnString = sString
	
	Dim As Long iPosSearch, iPosSearchNext = iPosition, iPos0 = 1
	
	Do
	
		iPosSearch = Instr(iPosSearchNext , sReturnString , sSearchStr)
		
		If iPosSearch<>0 Then
		
			szTempString = Mid(sReturnString , iPos0 , iPosSearch - 1 ) & sReplaceStr & Mid(sReturnString , iPosSearch + Len(sSearchStr))
			
			If iSearchParam = 1 Then
			
				sReturnString = szTempString
				
				iPosSearchNext = iPosSearch + Len(sReplaceStr)
			
			Else
			
				Return szTempString
			
			End If
			
		Else
			
			Return sReturnString
		
		End If
	
	Loop
  
End Function

Sub misc_reverse_string_proc(sText As String) 
	
	Dim As Long iLen = Len(sText) - 1
	
	If iLen > 0 Then
		
		Dim As Long x = (iLen - 1) \ 2
		
		For i As Long = 0 To x
			
			sText[i] = sText[i] Xor sText[iLen-i]
			
			sText[iLen-i]=sText[iLen-i] Xor sText[i]
			
			sText[i]=sText[i] Xor sText[iLen-i]	
			
		Next			
		
	Endif
	
End Sub

Function misc_case_utf8(sText As String , iFlagLcase As Long = 1) As String Export
	
	If Len(sText) Then
		
		Dim As Wstring Ptr pws = EncodeUTF8ToUnicode(sText)
		
		If pws Then
			
			If iFlagLcase Then
			
				*pws = Lcase(*pws)
			
			Else
			
				*pws = Ucase(*pws)
			
			Endif
			
			Dim As String sRet = EncodeUnicodeToUTF8(pws)
			
			Deallocate(pws)
			
			Return sRet
		
		Endif
		
	Endif
	
End Function