#include "../tlist.bi"
#include "../declarations.bi"

Type TQuotes
	
	iB As Long
	
	iE As Long
	
End Type


Redim Shared As TQuotes iArrayIndexQuotes(0)

Dim Shared As T_GlobalVariables Ptr TGlobalVariablesDll

Sub FillValuesQuotesPositionsProc(pszText As Zstring Ptr)
	
	Redim As TQuotes iArrayIndexQuotes(100)
	
	Dim As Long iFindStart = 1 , iFindEnd ,  iStart , iPosWrap , iIndex
	
	Do
		
		iStart = iFindStart
		
		iFindStart = Instr(iFindStart , *pszText , """")
		
		iPosWrap = Instr(iFindStart , *pszText , Chr(10))
		
		If iPosWrap = 0 Then iPosWrap = Len(*pszText)
		
		If iFindStart Then
			
			iFindEnd = Instr(iFindStart+1 , *pszText , """")
			
			If iFindEnd > 0 Andalso iFindEnd < iPosWrap Then
				
				iArrayIndexQuotes(iIndex).iB = iFindStart
				
				iArrayIndexQuotes(iIndex).iE = iFindEnd			
				
				iFindStart = iFindEnd+1
				
			Else
				
				iArrayIndexQuotes(iIndex).iB = iFindStart
				
				iArrayIndexQuotes(iIndex).iE = iPosWrap
				
				iFindStart = iPosWrap+1
				
				If iFindEnd = 0 Then 
					
					iFindEnd = iPosWrap
					
					Exit Do
					
				Endif
				
			Endif
			
			iIndex +=1
			
			If iIndex >= Ubound (iArrayIndexQuotes) Then
				
				Redim Preserve As TQuotes iArrayIndexQuotes(Ubound (iArrayIndexQuotes) +10)
				
			Endif
			
		Else
			
			Exit Do
			
		Endif						
		
	Loop
	
End Sub

Function DeleteMultiLineCommentsProc(pszText As Zstring Ptr)  As String
	
	Dim As Long iFindStart = 1 , iFindEnd ,  iStart , iFlagCommentsInString
	
	Dim As String sTemp
	
	Do
		
		iStart = iFindStart
		
		iFindStart = Instr(iFindStart , *pszText , "/'")
		
		If iFindStart Then
			
			For i As Long = 0 To Ubound (iArrayIndexQuotes)-1
				
				If iArrayIndexQuotes(i).iB > 0 Then
					
					If iFindStart > iArrayIndexQuotes(i).iB Andalso iFindStart < iArrayIndexQuotes(i).iE Then
						
						iFlagCommentsInString = 1
						
						iFindStart = iArrayIndexQuotes(i).iE + 1
						
						Exit For
						
					Endif
					
				Else
					
					Exit For
					
				Endif
				
			Next
			
			If iFlagCommentsInString = 1 Then
				
				iFlagCommentsInString = 0
				
				sTemp &= Mid(*pszText , iStart , iFindStart- iStart)
				
			Else
				
				iFindEnd = Instr(iFindStart , *pszText , "'/")
				
				If iFindEnd Then
					
					sTemp &= Mid(*pszText , iStart , iFindStart- iStart)
					
					iFindStart = iFindEnd+2
					
				Else
					
					sTemp &= Mid(*pszText , 1 )
					
					Exit Do
					
				Endif			
				
			Endif
			
		Else
			
			sTemp &= Mid(*pszText , iStart )
			
			Exit Do
			
		Endif		
		
	Loop
	
	Return sTemp
	
End Function

Function DeleteSingleLineCommentsProc(pszText As Zstring Ptr)  As String
	
	Dim As Long iFindStart = 1 , iFindEnd ,  iStart , iFlagCommentsInString
	
	Dim As String sTemp
	
	Do
		
		iStart = iFindStart
		
		iFindStart = Instr(iFindStart , *pszText , "'")
		
		If iFindStart Then
			
			For i As Long = 0 To Ubound (iArrayIndexQuotes)-1
				
				If iArrayIndexQuotes(i).iB > 0 Then
					
					If iFindStart > iArrayIndexQuotes(i).iB Andalso iFindStart < iArrayIndexQuotes(i).iE Then
						
						iFlagCommentsInString = 1
						
						iFindStart = iArrayIndexQuotes(i).iE +1
						
						Exit For
						
					Endif
					
				Else
					
					Exit For
					
				Endif
				
			Next
			
			If iFlagCommentsInString = 1 Then
				
				iFlagCommentsInString = 0
				
				sTemp &= Mid(*pszText , iStart , iFindStart- iStart)
				
			Else
				
				iFindEnd = Instr(iFindStart , *pszText , Chr(10))
				
				If Mid(*pszText , iFindStart-1 , 1) = Chr(10) Then
					
					sTemp &= Mid(*pszText , iStart , (iFindStart - iStart) - 1 )
					
				Else	
					
					sTemp &= Mid(*pszText , iStart , iFindStart - iStart )
					
				Endif
				
				
				
				If iFindEnd Then	
					
					iFindStart = iFindEnd
					
				Else
					
					Exit Do
					
				Endif			
				
			Endif
			
		Else
			
			sTemp &= Mid(*pszText , iStart )
			
			Exit Do
			
		Endif		
		
	Loop
	
	Return sTemp
	
End Function

Sub CutCommentsProc () 
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariablesDll->tabs, "VALUEPOS"))
	
	Dim As Integer iStartPos, iEndPos
	
	IupGetIntInt(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "SELECTIONPOS", Cast(Any Ptr,@iStartPos), Cast(Any Ptr,@iEndPos))
	
	Dim As Zstring Ptr pszText = IupGetAttribute(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "SELECTEDTEXT")
	
	If Len(*pszText) = 0 Then
		
		IupSetFocus(TGlobalVariablesDll->tTabsOptions(idTabs).multitext)
		
		Dim As Integer count = IupGetInt(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "COUNT")
		
		IupSetStrf(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "SELECTIONPOS", !"%d:%d", 0, count)	
		
		pszText = IupGetAttribute(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "SELECTEDTEXT")	
		
		If Len(*pszText) = 0 Then Exit Sub
		
	Endif
	
	Dim As String szText
	
	FillValuesQuotesPositionsProc(pszText)
	
	szText = DeleteMultiLineCommentsProc(pszText)
	
	FillValuesQuotesPositionsProc(Strptr(szText))
	
	szText = DeleteSingleLineCommentsProc(Strptr(szText))
	
	IupSetAttribute(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "UNDOACTION", "BEGIN")
	
	If Len(szText) = 0 Then
		
		IupSetAttribute(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "SELECTEDTEXT", "")
		
	Else
		
		IupSetAttribute(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "SELECTEDTEXT", Strptr(szText))
		
	Endif
	
	IupSetAttribute(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "UNDOACTION", "END")
	
	IupSetAttribute(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "ISCHANGES", "YES")
	
End Sub

Function item_cut_comments_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariablesDll->tabs) < 2 Then Return IUP_DEFAULT
	
	CutCommentsProc()
	
	Return IUP_DEFAULT
	
End Function

Function InitPluginProc(TGlobalVariables As T_GlobalVariables Ptr , pszDimErrors() As Zstring Ptr , bEncodingBool() As Byte , szEncodingString As Any Ptr) As Integer Export
	
	If TGlobalVariables = 0 Then Return 0
	
	TGlobalVariablesDll = TGlobalVariables
	
	Dim As iHandle Ptr main_menu = IupGetParent(IupGetParent(IupGetParent(TGlobalVariablesDLL->hItemAbout)))
	
	If 	main_menu = 0 Then Return 0
	
	Dim As ihandle Ptr pPlugItem = IupItem(*IupConfigGetVariableStr(TGlobalVariablesDLL->hConfigplug,TGlobalVariablesDLL->szLangid,"plug_cutcomments"), NULL)
	
	IupSetCallback(pPlugItem, "ACTION", Cast(Any Ptr , @item_cut_comments_callback))
	
	Dim As ihandle Ptr hItemEdit = IupGetChild(IupGetChild(main_menu, 1),0)
	
	Dim As Long i , iIndex =-1
	
	Do
		
		Dim As iHandle Ptr hItem = IupGetChild(hItemEdit, i)
		
		If hItem = 0 Then Exit Do
		
		If *IupGetAttribute(hItem , "TITLE") = *IupConfigGetVariableStr(TGlobalVariablesDLL->hConfigplug,TGlobalVariablesDLL->szLangid,"plug_extedit") Then
			
			iIndex = i
			
			Exit Do
			
		Endif
		
		i+=1
		
	Loop
	
	If iIndex <> -1 Then
		
		IupAppend( IupGetChild(IupGetChild(hItemEdit, iIndex),0),  pPlugItem)
		
	Else
		
		Dim As iHandle Ptr submenu = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariablesDLL->hConfigplug,TGlobalVariablesDLL->szLangid,"plug_extedit"), IupMenu(_
		pPlugItem,_
		NULL))
		
		IupAppend( hItemEdit, submenu )
		
		IupMap(submenu)
		
	Endif
	
	IupMap(pPlugItem)
	
	Return 1
	
End Function