#include "../tlist.bi"
#include "../declarations.bi"

Dim Shared As T_GlobalVariables Ptr TGlobalVariablesDll

Function replace_blank_proc (Byval sString As String, Byval sSearchStr As String, Byval sReplaceStr As String, Byval iPosition As Integer = 1 , Byval iSearchParam As Integer = 0 ) As String 
	
	Dim As String szTempString , sReturnString = sString
	
	Dim As Long iPosSearch, iPosSearchNext = iPosition, iPos0 = 1
	
	Do
	
		iPosSearch = Instr(iPosSearchNext , sReturnString , sSearchStr)
		
		If iPosSearch<>0 Then
		
			szTempString = Mid(sReturnString , iPos0 , iPosSearch - 1 ) & sReplaceStr & Mid(sReturnString , iPosSearch + Len(sSearchStr))
			
			If iSearchParam = 1 Then
			
				sReturnString = szTempString
				
				iPosSearchNext = iPosSearch 
			
			Else
			
				Return szTempString
			
			End If
			
		Else
			
			Return sReturnString
		
		End If
	
	Loop
  
End Function

Sub CutDupBlankLines () 
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariablesDll->tabs, "VALUEPOS"))
	
	Dim As Integer iStartPos, iEndPos
	
	IupGetIntInt(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "SELECTIONPOS", Cast(Any Ptr,@iStartPos), Cast(Any Ptr,@iEndPos))
	
	Dim As Zstring Ptr pszText = IupGetAttribute(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "SELECTEDTEXT")
	
	If Len(*pszText) = 0 Then
		
		IupSetFocus(TGlobalVariablesDll->tTabsOptions(idTabs).multitext)
		
		Dim As Integer count = IupGetInt(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "COUNT")
		
		IupSetStrf(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "SELECTIONPOS", !"%d:%d", 0, count)	
		
		pszText = IupGetAttribute(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "SELECTEDTEXT")	
		
		If Len(*pszText) = 0 Then Exit Sub
		
	Endif
	
	Dim As String szText
	
	szText = replace_blank_proc(*pszText , Chr(13) & Chr(10) & Chr(13) & Chr(10) & Chr(13) & Chr(10), Chr(13) & Chr(10) & Chr(13) & Chr(10),  , 1)
	
	szText = replace_blank_proc(szText , Chr(10) & Chr(10) & Chr(10), Chr(10) & Chr(10), , 1)
	
	If Left (szText , 4) =  Chr(13) & Chr(10) & Chr(13) & Chr(10) Then

		szText = Mid (szText , 3)
		
	Elseif Left (szText , 2) =  Chr(10) & Chr(10) Then

		szText = Mid (szText , 2)

	Endif 
	
	If Right (szText , 4) =  Chr(13) & Chr(10) & Chr(13) & Chr(10) Then

		szText = Mid (szText , 1 , Len(szText)-2)
		
	Elseif Right (szText , 2) =  Chr(10) & Chr(10) Then

		szText = Mid (szText , 1 , Len(szText)-1)

	Endif 	

	IupSetAttribute(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "UNDOACTION", "BEGIN")
	
	If Len(szText) = 0 Then
	
		IupSetAttribute(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "SELECTEDTEXT", "")
		
	Else
	
		IupSetAttribute(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "SELECTEDTEXT", Strptr(szText))

	Endif
	
	IupSetAttribute(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "UNDOACTION", "END")
	
	IupSetAttribute(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "ISCHANGES", "YES")
	
End Sub

Function item_cut_comments_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariablesDll->tabs) < 2 Then Return IUP_DEFAULT
	
	CutDupBlankLines()
	
	Return IUP_DEFAULT
	
End Function

Function InitPluginProc(TGlobalVariables As T_GlobalVariables Ptr , pszDimErrors() As Zstring Ptr , bEncodingBool() As Byte , szEncodingString As Any Ptr) As Integer Export
	
	If TGlobalVariables = 0 Then Return 0
	
	TGlobalVariablesDll = TGlobalVariables
	
	Dim As iHandle Ptr main_menu = IupGetParent(IupGetParent(IupGetParent(TGlobalVariablesDLL->hItemAbout)))
	
	If 	main_menu = 0 Then Return 0
	
	Dim As ihandle Ptr pPlugItem = IupItem(*IupConfigGetVariableStr(TGlobalVariablesDLL->hConfigplug,TGlobalVariablesDLL->szLangid,"plug_dupblanklines"), NULL)
	
	IupSetCallback(pPlugItem, "ACTION", Cast(Any Ptr , @item_cut_comments_callback))
	
	Dim As ihandle Ptr hItemEdit = IupGetChild(IupGetChild(main_menu, 1),0)
	
	Dim As Long i , iIndex =-1
	
	Do
		
		Dim As iHandle Ptr hItem = IupGetChild(hItemEdit, i)
		
		If hItem = 0 Then Exit Do
		
		If *IupGetAttribute(hItem , "TITLE") = *IupConfigGetVariableStr(TGlobalVariablesDLL->hConfigplug,TGlobalVariablesDLL->szLangid,"plug_extedit") Then
			
			iIndex = i
			
			Exit Do
			
		Endif
		
		i+=1
		
	Loop
	
	If iIndex <> -1 Then
		
		IupAppend( IupGetChild(IupGetChild(hItemEdit, iIndex),0),  pPlugItem)
		
	Else
		
		Dim As iHandle Ptr submenu = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariablesDLL->hConfigplug,TGlobalVariablesDLL->szLangid,"plug_extedit"), IupMenu(_
		pPlugItem,_
		NULL))
		
		IupAppend( hItemEdit, submenu )
		
		IupMap(submenu)
		
	Endif
	
	IupMap(pPlugItem)
	
	Return 1
	
End Function