
Sub tbspc_spaces_to_tab_begin_proc() export
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As Integer iTabSize = IupGetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "TABSIZE")

	Dim As Integer iLineCount 
	
	iLineCount = IupGetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "LINECOUNT")
	
	For i As Long = 0 To iLineCount - 1
		
		Dim As ZString Ptr pszText = IupGetAttributeId(TGlobalVariables->tTabsOptions(idTabs).multitext, "LINE", i)
		
		Dim As Integer iRetBytes
		
		Dim As Integer iLenSz = Len(*pszText)
		
		Dim As Long iSpacesCount , iFlagBegin
		
		#ifdef __FB_WIN32__
		
		Dim As WString Ptr pwsText = Cast(WString Ptr,enc_encode_buffer_proc("UTF-16LE","UTF-8",Cast(Byte Ptr,pszText),iLenSz,iRetBytes))
		
		#else
		
		Dim As WString Ptr pwsText = Cast(WString Ptr,enc_encode_buffer_proc("UTF-32LE","UTF-8",Cast(Byte Ptr,pszText),iLenSz,iRetBytes))
		
		#endif		
		
		Dim As WString Ptr pwsTempText = Callocate(iRetBytes*SizeOf(WString)+2)
		
		Dim As Integer ilenWsText = len(*pwsText)
		
		If iRetBytes > 0 Then
			
			for i As Long = 0 To ilenWsText - 1
				
				If iFlagBegin = 0 AndAlso (*pwsText)[i] = 32 Then
					
					iSpacesCount +=1
					
					If (i+1) Mod iTabSize Then
						
						If i = ilenWsText - 1 Then
							
							*pwsTempText &= WSpace(iSpacesCount)
							
						EndIf						
						
					Else
						
						*pwsTempText &= !"\t"
						
						iSpacesCount = 0
						
					EndIf
					
				Else
					
					If iSpacesCount Then
						
						*pwsTempText &= WSpace(iSpacesCount)
						
						iSpacesCount = 0
						
					EndIf

					*pwsTempText &= WChr((*pwsText)[i])

					iFlagBegin = 1
					
				EndIf			
				
			Next
					
		EndIf
		
		Dim As Integer iPos 
		
		IupTextConvertLinColToPos(TGlobalVariables->tTabsOptions(idTabs).multitext, i, 0, cast(any ptr, @iPos))		
		
		IupSetStrf(TGlobalVariables->tTabsOptions(idTabs).multitext, "DELETERANGE", !"%d,%d", iPos, iLenSz)	
		
		#ifdef __FB_WIN32__
		
		pszText = Cast(ZString Ptr,enc_encode_buffer_proc("UTF-8","UTF-16LE",Cast(Byte Ptr,pwsTempText),len(*pwsTempText)*sizeof(wstring),iRetBytes))
		
		#else
		
		pszText = Cast(ZString Ptr,enc_encode_buffer_proc("UTF-8","UTF-32LE",Cast(Byte Ptr,pwsTempText),len(*pwsTempText)*sizeof(wstring),iRetBytes))
		
		#endif		
		
		IupSetAttributeId(TGlobalVariables->tTabsOptions(idTabs).multitext, "INSERT", iPos, pszText)	
		
		If pszText Then DeAllocate(pszText)

		If pwsText Then DeAllocate(pwsText)

		If pwsTempText Then DeAllocate(pwsTempText)
		
	Next
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "ISCHANGES", "YES")
	
End Sub

Sub tbspc_spaces_to_tab_proc() export
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As Integer iTabSize = IupGetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "TABSIZE")

	Dim As Integer iLineCount 
	
	iLineCount = IupGetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "LINECOUNT")
	
	For i As Long = 0 To iLineCount - 1
		
		Dim As ZString Ptr pszText = IupGetAttributeId(TGlobalVariables->tTabsOptions(idTabs).multitext, "LINE", i)
		
		Dim As Integer iRetBytes
		
		Dim As Integer iLenSz = Len(*pszText)
		
		Dim As Long iSpacesCount
		
		#ifdef __FB_WIN32__
		
		Dim As WString Ptr pwsText = Cast(WString Ptr,enc_encode_buffer_proc("UTF-16LE","UTF-8",Cast(Byte Ptr,pszText),iLenSz,iRetBytes))
		
		#else
		
		Dim As WString Ptr pwsText = Cast(WString Ptr,enc_encode_buffer_proc("UTF-32LE","UTF-8",Cast(Byte Ptr,pszText),iLenSz,iRetBytes))
		
		#endif
		
		Dim As WString Ptr pwsTempText = Callocate(iRetBytes*SizeOf(WString)+2)
		
		Dim As Integer ilenWsText = len(*pwsText)
		
		If iRetBytes > 0 Then
			
			for i As Long = 0 To ilenWsText - 1
				
				If (*pwsText)[i] = 32 Then
					
					iSpacesCount +=1
					
					If (i+1) Mod iTabSize Then
						
						If i = ilenWsText - 1 Then
							
							*pwsTempText &= WSpace(iSpacesCount)
							
						EndIf
						
					Else
						
						*pwsTempText &= !"\t"
						
						iSpacesCount = 0
						
					EndIf
					
				Else
					
					If iSpacesCount Then
						
						*pwsTempText &= WSpace(iSpacesCount)
						
						iSpacesCount = 0
						
					EndIf
					
					*pwsTempText &= WChr((*pwsText)[i])
					
				EndIf			
				
			Next
					
		EndIf
		
		Dim As Integer iPos 
		
		IupTextConvertLinColToPos(TGlobalVariables->tTabsOptions(idTabs).multitext, i, 0, cast(any ptr, @iPos))		
		
		IupSetStrf(TGlobalVariables->tTabsOptions(idTabs).multitext, "DELETERANGE", !"%d,%d", iPos, iLenSz)	
		
		#ifdef __FB_WIN32__
		
		pszText = Cast(ZString Ptr,enc_encode_buffer_proc("UTF-8","UTF-16LE",Cast(Byte Ptr,pwsTempText),len(*pwsTempText)*sizeof(wstring),iRetBytes))
		
		#else
		
		pszText = Cast(ZString Ptr,enc_encode_buffer_proc("UTF-8","UTF-32LE",Cast(Byte Ptr,pwsTempText),len(*pwsTempText)*sizeof(wstring),iRetBytes))
		
		#endif
		
		IupSetAttributeId(TGlobalVariables->tTabsOptions(idTabs).multitext, "INSERT", iPos, pszText)		
		
		If pszText Then DeAllocate(pszText)

		If pwsText Then DeAllocate(pwsText)

		If pwsTempText Then DeAllocate(pwsTempText)
		
	Next
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "ISCHANGES", "YES")
	
End Sub

Sub tbspc_tab_to_spaces_begin_proc() export
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As Integer iTabSize = IupGetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "TABSIZE")

	Dim As Integer iLineCount 
	
	iLineCount = IupGetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "LINECOUNT")
	
	For i As Long = 0 To iLineCount - 1
		
		Dim As ZString Ptr pszText = IupGetAttributeId(TGlobalVariables->tTabsOptions(idTabs).multitext, "LINE", i)
		
		Dim As Integer iRetBytes , iVirtualPos , iFlagBegin
		
		Dim As Integer iLenSz = Len(*pszText)
		
		#ifdef __FB_WIN32__
		
		Dim As WString Ptr pwsText = Cast(WString Ptr,enc_encode_buffer_proc("UTF-16LE","UTF-8",Cast(Byte Ptr,pszText),iLenSz,iRetBytes))
		
		#else
		
		Dim As WString Ptr pwsText = Cast(WString Ptr,enc_encode_buffer_proc("UTF-32LE","UTF-8",Cast(Byte Ptr,pszText),iLenSz,iRetBytes))
		
		#endif
		
		Dim As WString Ptr wsTempText = Callocate(len(*pwsText)*SizeOf(WString)*iTabSize+2)
		
		If iRetBytes > 0 Then
			
			for i As Long = 0 To len(*pwsText) - 1
				
				If iFlagBegin = 0 AndAlso (*pwsText)[i] = 9 Then
					
					Dim As Long iRest = iVirtualPos Mod iTabSize
					
					iVirtualPos += iTabSize - iRest
					
					*wsTempText &= WSpace(iTabSize - iRest)
				
				Else
					
					*wsTempText &= WChr((*pwsText)[i])
					
					iVirtualPos += 1
					
					iFlagBegin = 1
					
				EndIf			
				
			Next
					
		EndIf
		
		Dim As Integer iPos 
		
		IupTextConvertLinColToPos(TGlobalVariables->tTabsOptions(idTabs).multitext, i, 0, cast(any ptr, @iPos))		
		
		IupSetStrf(TGlobalVariables->tTabsOptions(idTabs).multitext, "DELETERANGE", !"%d,%d", iPos, iLenSz)	
		
		#ifdef __FB_WIN32__
		
		pszText = Cast(ZString Ptr,enc_encode_buffer_proc("UTF-8","UTF-16LE",Cast(Byte Ptr,wsTempText),len(*wsTempText)*SizeOf(WString),iRetBytes))
		
		#else
		
		pszText = Cast(ZString Ptr,enc_encode_buffer_proc("UTF-8","UTF-32LE",Cast(Byte Ptr,wsTempText),len(*wsTempText)*SizeOf(WString),iRetBytes))
		
		#endif
		
		IupSetAttributeId(TGlobalVariables->tTabsOptions(idTabs).multitext, "INSERT", iPos, pszText)		
		
		If pszText Then DeAllocate(pszText)

		If pwsText Then DeAllocate(pwsText)

		If wsTempText Then DeAllocate(wsTempText)
		
	Next
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "ISCHANGES", "YES")
	
End Sub

sub tbspc_fast_tab_in_space_proc(szLine as String)
	
	dim as Long iStart
	
	do
		
		iStart = instr(iStart + 1 , szLine , chr(9))
		
		if iStart then
		
			szLine[iStart-1] = 32

		else
		
			exit do
			
		EndIf		
		
	Loop
	
End Sub

Sub tbspc_tab_to_spaces_proc() export
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As Integer iTabSize = IupGetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "TABSIZE")

	Dim As Integer iLineCount 
	
	iLineCount = IupGetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "LINECOUNT")
	
	For i As Long = 0 To iLineCount - 1
		
		Dim As ZString Ptr pszText = IupGetAttributeId(TGlobalVariables->tTabsOptions(idTabs).multitext, "LINE", i)
		
		Dim As Integer iRetBytes , iVirtualPos
		
		Dim As Integer iLenSz = Len(*pszText)
		
		#ifdef __FB_WIN32__
		
		Dim As WString Ptr pwsText = Cast(WString Ptr,enc_encode_buffer_proc("UTF-16LE","UTF-8",Cast(Byte Ptr,pszText),iLenSz,iRetBytes))
		
		#else
		
		Dim As WString Ptr pwsText = Cast(WString Ptr,enc_encode_buffer_proc("UTF-32LE","UTF-8",Cast(Byte Ptr,pszText),iLenSz,iRetBytes))
		
		#endif
		
		Dim As WString Ptr wsTempText = Callocate(len(*pwsText)*SizeOf(WString)*iTabSize+2)
		
		If iRetBytes > 0 Then
			
			for i As Long = 0 To len(*pwsText) - 1
				
				If (*pwsText)[i] = 9 Then
					
					Dim As Long iRest = iVirtualPos Mod iTabSize
					
					iVirtualPos += iTabSize - iRest
					
					*wsTempText &= WSpace(iTabSize - iRest)
				
				Else
					
					*wsTempText &= WChr((*pwsText)[i])
					
					iVirtualPos += 1
					
				EndIf			
				
			Next
					
		EndIf
		
		Dim As Integer iPos 
		
		IupTextConvertLinColToPos(TGlobalVariables->tTabsOptions(idTabs).multitext, i, 0, cast(any ptr, @iPos))		
		
		IupSetStrf(TGlobalVariables->tTabsOptions(idTabs).multitext, "DELETERANGE", !"%d,%d", iPos, iLenSz)	
		
		#ifdef __FB_WIN32__
		
		pszText = Cast(ZString Ptr,enc_encode_buffer_proc("UTF-8","UTF-16LE",Cast(Byte Ptr,wsTempText),len(*wsTempText)*SizeOf(WString),iRetBytes))
		
		#else
		
		pszText = Cast(ZString Ptr,enc_encode_buffer_proc("UTF-8","UTF-32LE",Cast(Byte Ptr,wsTempText),len(*wsTempText)*SizeOf(WString),iRetBytes))
		
		#endif
		
		IupSetAttributeId(TGlobalVariables->tTabsOptions(idTabs).multitext, "INSERT", iPos, pszText)		
		
		If pszText Then DeAllocate(pszText)

		If pwsText Then DeAllocate(pwsText)

		If wsTempText Then DeAllocate(wsTempText)
		
	Next
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "ISCHANGES", "YES")
	
End Sub

Sub tbspc_remove_leading_spaces_proc (mt As Ihandle Ptr) export

	Dim As Integer iLineBeg , iLineEnd

	IupGetIntInt(mt, "SELECTION", cast(any ptr,@iLineBeg), cast(any ptr,@iLineEnd))
	
	Dim As ZString Ptr pszText = IupGetAttribute(mt, "SELECTEDTEXT")	

	Dim As Integer iLineCount = IupGetInt(mt, "LINECOUNT")

	Dim As Integer iPos

	if pszText = 0 orelse len(*pszText) = 0 then
		
		iLineBeg = 0
		
		iLineEnd = iLineCount - 1
		
	EndIf

	For i As integer = iLineBeg To iLineEnd

		Dim As ZString Ptr pszText = IupGetAttributeId(mt, "LINE", i)

		Dim As Integer iLen = StrSpn(pszText, !" ")

		If iLen = 0 Then Continue For

		IupTextConvertLinColToPos(mt, CInt(i), 0, cast(any ptr,@iPos))

		IupSetStrf(mt, "DELETERANGE", !"%d,%d", iPos, iLen)

	Next
	
	IupSetAttribute(mt, "ISCHANGES", "YES")

End Sub

Sub tbspc_remove_trailing_spaces_proc (mt As Ihandle Ptr) export

	Dim As Integer iLineBeg , iLineEnd

	IupGetIntInt(mt, "SELECTION", cast(any ptr,@iLineBeg), cast(any ptr,@iLineEnd))
	
	Dim As ZString Ptr pszText = IupGetAttribute(mt, "SELECTEDTEXT")	

	Dim As Integer iLineCount = IupGetInt(mt, "LINECOUNT")

	Dim As Integer j, iPos, iCount
	
	if pszText = 0 orelse len(*pszText) = 0 then
		
		iLineBeg = 0
		
		iLineEnd = iLineCount - 1
		
	EndIf

	For i As integer = iLineBeg To iLineEnd

		Dim As ZString Ptr pszText = IupGetAttributeId(mt, "LINE", i)

		Dim As Long iLen = Len(*pszText)

		If iLen = 0 Then 
			
			Continue For
			
		elseif iLen >= 2 Then
		
			If pszText[iLen - 2] = 13 andalso pszText[iLen - 1] = 10 then
				
				iLen -=2
				
			elseIf pszText[iLen - 1] = 10 Then
			
				iLen -=1	
				
			EndIf
			
		else
		
			If pszText[iLen - 1] = 10 Then
				
				iLen -=1
				
			EndIf
			
		EndIf

		iCount = 0

		j = iLen - 1

		While j >= 0

			If pszText[j] <> 32 AndAlso pszText[j] <> 9 Then Exit While

			iCount+=1

			j-=1

		Wend

		If iCount = 0 Then Continue For

		IupTextConvertLinColToPos(mt, i, iLen - iCount, cast(any ptr,@iPos))

		IupSetStrf(mt, "DELETERANGE", !"%d,%d", iPos, iCount)

	Next
	
	IupSetAttribute(mt, "ISCHANGES", "YES")

End Sub

